/*!
 * kokopu (https://www.npmjs.com/package/kokopu)
 * @version 4.10.0
 * @author Yoann Le Montagner <yo35@melix.net>
 * @license LGPL-3.0-or-later
 */
(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.kokopu = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Database = exports.isValidGameIndex = void 0;
const exception_1 = require("./exception");
function isValidGameIndex(gameIndex) {
    return Number.isInteger(gameIndex) && gameIndex >= 0;
}
exports.isValidGameIndex = isValidGameIndex;
/**
 * Describe a set of chess games, each of them being represented by a {@link Game} object.
 */
class Database {
    /**
     * @ignore
     */
    constructor() { }
    /**
     * Number of games in the database.
     */
    gameCount() {
        return this.doGameCount();
    }
    /**
     * Return the game corresponding to the given index.
     *
     * @param gameIndex - Must be between 0 inclusive and {@link Database.gameCount} exclusive.
     * @throws {@link exception.InvalidPGN} if the corresponding game cannot be parsed, or if the given game index is larger than the number of games in the underlying PGN data.
     */
    game(gameIndex) {
        if (!isValidGameIndex(gameIndex)) {
            throw new exception_1.IllegalArgument('Database.game()');
        }
        return this.doGame(gameIndex);
    }
    /**
     * Return an [Iterable](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Iteration_protocols) object allowing to iterate over
     * all the (valid) games within the database.
     *
     * Example, to print the ASCII representation of all the games within a database:
     * ```
     * const database = ... ;
     * for (const game of database.games()) {
     *   console.log(game.ascii());
     * }
     * ```
     *
     * If the database contains some games that cannot be parsed (i.e. games for which the method {@link Database.game} would throw a {@link exception.InvalidPGN} exception),
     * those games are ignored during the iteration. WARNING: for this reason, the number of games returned by the iterator may be lower than {@link Database.gameCount}.
     */
    games() {
        const gameCount = this.doGameCount();
        const gameLoader = (gameIndex) => this.doGame(gameIndex);
        return {
            [Symbol.iterator]() {
                return new GameIteratorImpl(gameCount, gameLoader);
            }
        };
    }
}
exports.Database = Database;
/**
 * Iterator that iterates over all the games of a {@link Database}.
 */
class GameIteratorImpl {
    constructor(gameCount, gameLoader) {
        this.gameIndex = 0;
        this.gameCount = gameCount;
        this.gameLoader = gameLoader;
    }
    next() {
        while (this.gameIndex < this.gameCount) {
            try {
                const game = this.gameLoader(this.gameIndex++);
                return { done: false, value: game };
            }
            catch (error) {
                // istanbul ignore if
                if (!(error instanceof exception_1.InvalidPGN)) {
                    throw error;
                }
            }
        }
        return { done: true, value: undefined };
    }
}

},{"./exception":3}],2:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _DateValue_type, _DateValue_year, _DateValue_month, _DateValue_day;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateValue = void 0;
const exception_1 = require("./exception");
/**
 * Date of a chess game. It can be either partially defined (with the year only, or with the year and month but without day of month),
 * or fully defined (with year, month and day of month).
 *
 * @see {@link Game.date}
 */
class DateValue {
    constructor(dateOrYear, month, day) {
        _DateValue_type.set(this, void 0);
        _DateValue_year.set(this, void 0);
        _DateValue_month.set(this, void 0);
        _DateValue_day.set(this, void 0);
        if (dateOrYear instanceof Date) {
            __classPrivateFieldSet(this, _DateValue_type, 'ymd', "f");
            __classPrivateFieldSet(this, _DateValue_year, dateOrYear.getFullYear(), "f");
            __classPrivateFieldSet(this, _DateValue_month, dateOrYear.getMonth() + 1, "f");
            __classPrivateFieldSet(this, _DateValue_day, dateOrYear.getDate(), "f");
        }
        else {
            const type = computeType(dateOrYear, month, day);
            if (!type) {
                throw new exception_1.IllegalArgument('DateValue()');
            }
            __classPrivateFieldSet(this, _DateValue_type, type, "f");
            __classPrivateFieldSet(this, _DateValue_year, dateOrYear, "f");
            __classPrivateFieldSet(this, _DateValue_month, month !== null && month !== void 0 ? month : undefined, "f");
            __classPrivateFieldSet(this, _DateValue_day, day !== null && day !== void 0 ? day : undefined, "f");
        }
    }
    /**
     * Type of date value:
     * - `'y'` means that only the year is defined,
     * - `'ym'` means that the year and the month are defined, but not the day in month,
     * - `'ymd'` means that the exact day is defined.
     */
    type() {
        return __classPrivateFieldGet(this, _DateValue_type, "f");
    }
    /**
     * Year (e.g. `2022`).
     */
    year() {
        return __classPrivateFieldGet(this, _DateValue_year, "f");
    }
    /**
     * Month index, valued between 1 (January) and 12 (December) inclusive.
     *
     * @throws {@link exception.IllegalArgument} if the current type is `'y'` (see {@link DateValue.type}).
     */
    month() {
        if (__classPrivateFieldGet(this, _DateValue_month, "f") === undefined) {
            throw new exception_1.IllegalArgument('DateValue.month()');
        }
        return __classPrivateFieldGet(this, _DateValue_month, "f");
    }
    /**
     * Day in month, valued between 1 and the number of days in the corresponding month (thus 31 at most).
     *
     * @throws {@link exception.IllegalArgument} if the current type is `'y'` or `'ym'` (see {@link DateValue.type}).
     */
    day() {
        if (__classPrivateFieldGet(this, _DateValue_day, "f") === undefined) {
            throw new exception_1.IllegalArgument('DateValue.day()');
        }
        return __classPrivateFieldGet(this, _DateValue_day, "f");
    }
    /**
     * Convert the current object into a standard JavaScript [Date](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date)
     * object.
     *
     * If the type of the current object is `'ym'`, the returned `Date` object points at the first day of the corresponding month.
     * If the type of the current object is `'y'`, the returned `Date` object points at the first day of the corresponding year.
     */
    toDate() {
        const month = __classPrivateFieldGet(this, _DateValue_month, "f") === undefined ? 0 : __classPrivateFieldGet(this, _DateValue_month, "f") - 1;
        const day = __classPrivateFieldGet(this, _DateValue_day, "f") === undefined ? 1 : __classPrivateFieldGet(this, _DateValue_day, "f");
        return new Date(__classPrivateFieldGet(this, _DateValue_year, "f"), month, day);
    }
    /**
     * Get the date in a compact format (e.g. `'2022-07-19'`, `'2022-07-**'` or `'2022-**-**'` depending on the type of the current object).
     */
    toString() {
        return toStringImpl(__classPrivateFieldGet(this, _DateValue_year, "f"), __classPrivateFieldGet(this, _DateValue_month, "f"), __classPrivateFieldGet(this, _DateValue_day, "f"), '-', '**');
    }
    /**
     * Parse the given value as a date in compact format (e.g. `'2022-07-19'`, `'2022-07-**'` or `'2022-**-**'`).
     *
     * @returns `undefined` if the value does not represent a valid date.
     */
    static fromString(value) {
        if (typeof value !== 'string') {
            throw new exception_1.IllegalArgument('DateValue.fromString()');
        }
        return fromStringImpl(value, /^([0-9]{4})-([0-9]{2})-([0-9]{2})$/, /^([0-9]{4})-([0-9]{2})-\*\*$/, /^([0-9]{4})-\*\*-\*\*$/, false);
    }
    /**
     * Get the date in a PGN format (e.g. `'2022.07.19'`, `'2022.07.??'` or `'2022.??.??'` depending on the type of the current object).
     */
    toPGNString() {
        return toStringImpl(__classPrivateFieldGet(this, _DateValue_year, "f"), __classPrivateFieldGet(this, _DateValue_month, "f"), __classPrivateFieldGet(this, _DateValue_day, "f"), '.', '??');
    }
    /**
     * Parse the given value as a date in PGN format (e.g. `'2022.07.19'`, `'2022.07.??'` or `'2022.??.??'`).
     *
     * @returns `undefined` if the value does not represent a valid date.
     */
    static fromPGNString(value) {
        if (typeof value !== 'string') {
            throw new exception_1.IllegalArgument('DateValue.fromPGNString()');
        }
        return fromStringImpl(value, /^([0-9]{4})\.([0-9]{2})\.([0-9]{2})$/, /^([0-9]{4})\.([0-9]{2})\.\?\?$/, /^([0-9]{4})(?:\.\?\?\.\?\?)?$/, true);
    }
    /**
     * Get the date of the game as a human-readable string (e.g. `'November 1955'`, `'September 4, 2021'`).
     *
     * @param locales - Locales to use to generate the result. If undefined, the default locale of the execution environment is used.
     *                  See [Intl documentation](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl#locale_identification_and_negotiation)
     *                  for more details.
     */
    toHumanReadableString(locales) {
        switch (__classPrivateFieldGet(this, _DateValue_type, "f")) {
            case 'ymd': {
                const date = new Date(__classPrivateFieldGet(this, _DateValue_year, "f"), __classPrivateFieldGet(this, _DateValue_month, "f") - 1, __classPrivateFieldGet(this, _DateValue_day, "f"));
                return new Intl.DateTimeFormat(locales, { dateStyle: 'long' }).format(date);
            }
            case 'ym': {
                const date = new Date(__classPrivateFieldGet(this, _DateValue_year, "f"), __classPrivateFieldGet(this, _DateValue_month, "f") - 1, 1);
                return new Intl.DateTimeFormat(locales, { month: 'long', year: 'numeric' }).format(date);
            }
            default:
                return String(__classPrivateFieldGet(this, _DateValue_year, "f"));
        }
    }
    /**
     * Whether the given year/month/day would corresponds to a valid date or not.
     */
    static isValid(year, month, day) {
        return Boolean(computeType(year, month, day));
    }
}
exports.DateValue = DateValue;
_DateValue_type = new WeakMap(), _DateValue_year = new WeakMap(), _DateValue_month = new WeakMap(), _DateValue_day = new WeakMap();
function toStringImpl(year, month, day, separator, undefinedToken) {
    const y = String(year).padStart(4, '0');
    const m = month === undefined ? undefinedToken : String(month).padStart(2, '0');
    const d = day === undefined ? undefinedToken : String(day).padStart(2, '0');
    return y + separator + m + separator + d;
}
function fromStringImpl(value, ymdRe, ymRe, yRe, tolerant) {
    if (ymdRe.test(value)) {
        const y = RegExp.$1;
        const m = RegExp.$2;
        const d = RegExp.$3;
        const year = parseInt(y, 10);
        const month = parseInt(m, 10);
        const day = parseInt(d, 10);
        if (DateValue.isValid(year, month, day)) {
            return new DateValue(year, month, day);
        }
        else if (tolerant) {
            return DateValue.isValid(year, month) ? new DateValue(year, month) : new DateValue(year);
        }
        else {
            return undefined;
        }
    }
    else if (ymRe.test(value)) {
        const y = RegExp.$1;
        const m = RegExp.$2;
        const year = parseInt(y, 10);
        const month = parseInt(m, 10);
        if (DateValue.isValid(year, month)) {
            return new DateValue(year, month);
        }
        else if (tolerant) {
            return new DateValue(year);
        }
        else {
            return undefined;
        }
    }
    else if (yRe.test(value)) {
        const year = parseInt(RegExp.$1, 10);
        return new DateValue(year);
    }
    else {
        return undefined;
    }
}
function computeType(year, month, day) {
    if (day !== undefined && day !== null) {
        return isValidYear(year) && isValidMonth(month) && Number.isInteger(day) && day >= 1 && day <= daysInMonth(year, month) ? 'ymd' : false;
    }
    else if (month !== undefined && month !== null) {
        return isValidYear(year) && isValidMonth(month) ? 'ym' : false;
    }
    else {
        return isValidYear(year) ? 'y' : false;
    }
}
function isValidYear(year) {
    return Number.isInteger(year) && year >= 0;
}
function isValidMonth(month) {
    return Number.isInteger(month) && month >= 1 && month <= 12;
}
function daysInMonth(year, month) {
    return new Date(year, month, 0).getDate();
}

},{"./exception":3}],3:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.InvalidPOJO = exports.InvalidPGN = exports.InvalidNotation = exports.InvalidFEN = exports.IllegalArgument = void 0;
/**
 * This module contains the exceptions used by the library.
 * @module
 */
/**
 * Exception thrown when an invalid argument is passed to a function.
 */
class IllegalArgument {
    constructor(functionName) {
        this.functionName = functionName;
    }
    /**
     * @ignore
     */
    toString() {
        return `Illegal argument in function ${this.functionName}`;
    }
}
exports.IllegalArgument = IllegalArgument;
/**
 * Exception thrown by the FEN parsing functions.
 */
class InvalidFEN {
    constructor(fen, message, ...tokens) {
        this.fen = fen;
        this.message = buildMessage(message, tokens);
    }
    /**
     * @ignore
     */
    toString() {
        return toStringImpl('InvalidFEN', this.message);
    }
}
exports.InvalidFEN = InvalidFEN;
/**
 * Exception thrown by the move notation parsing functions.
 */
class InvalidNotation {
    constructor(fen, notation, message, ...tokens) {
        this.fen = fen;
        this.notation = notation;
        this.message = buildMessage(message, tokens);
    }
    /**
     * @ignore
     */
    toString() {
        return toStringImpl('InvalidNotation', this.message);
    }
}
exports.InvalidNotation = InvalidNotation;
/**
 * Exception thrown by the PGN parsing functions.
 */
class InvalidPGN {
    constructor(pgn, index, lineNumber, message, ...tokens) {
        this.pgn = pgn;
        this.index = index;
        this.lineNumber = lineNumber;
        this.message = buildMessage(message, tokens);
    }
    /**
     * @ignore
     */
    toString() {
        return toStringImpl('InvalidPGN', `[character=${this.index} line=${this.lineNumber}] ${this.message}`);
    }
}
exports.InvalidPGN = InvalidPGN;
/**
 * Exception thrown by the POJO deserializing functions.
 */
class InvalidPOJO {
    constructor(pojo, fieldName, message, ...tokens) {
        this.pojo = pojo;
        this.fieldName = fieldName;
        this.message = buildMessage(message, tokens);
    }
    /**
     * @ignore
     */
    toString() {
        return toStringImpl('InvalidPOJO', this.message);
    }
}
exports.InvalidPOJO = InvalidPOJO;
function buildMessage(message, tokens) {
    return message.replace(/{(\d+)}/g, (match, placeholder) => {
        const placeholderIndex = Number(placeholder);
        return placeholderIndex < tokens.length ? String(tokens[placeholderIndex]) : match;
    });
}
function toStringImpl(exceptionName, message) {
    return exceptionName + ' -> ' + message;
}

},{}],4:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Game = void 0;
const date_value_1 = require("./date_value");
const exception_1 = require("./exception");
const helper_1 = require("./helper");
const i18n_1 = require("./i18n");
const position_1 = require("./position");
const common_1 = require("./private_game/common");
const node_variation_impl_1 = require("./private_game/node_variation_impl");
const pojo_util_1 = require("./private_game/pojo_util");
const base_types_impl_1 = require("./private_position/base_types_impl");
/**
 * Chess game, with the move history, the position at each step of the game, the comments and annotations (if any),
 * the result of the game, and some meta-data such as the name of the players, the date of the game, the name of the tournament, etc...
 */
class Game {
    constructor() {
        this._playerName = [undefined, undefined];
        this._playerElo = [undefined, undefined];
        this._playerTitle = [undefined, undefined];
        this._round = [undefined, undefined, undefined];
        this._result = 3 /* GameResultImpl.LINE */;
        this._moveTreeRoot = new node_variation_impl_1.MoveTreeRoot();
    }
    /**
     * Clear all the headers (player names, elos, titles, event name, date, etc...).
     *
     * The {@link Game.result} header is reseted to its default value.
     * The initial position and moves are not modified.
     */
    clearHeaders() {
        this._playerName = [undefined, undefined];
        this._playerElo = [undefined, undefined];
        this._playerTitle = [undefined, undefined];
        this._event = undefined;
        this._round = [undefined, undefined, undefined];
        this._date = undefined;
        this._site = undefined;
        this._annotator = undefined;
        this._eco = undefined;
        this._opening = undefined;
        this._openingVariation = undefined;
        this._openingSubVariation = undefined;
        this._termination = undefined;
        this._result = 3 /* GameResultImpl.LINE */;
    }
    playerName(color, value) {
        const colorCode = (0, base_types_impl_1.colorFromString)(color);
        if (colorCode < 0) {
            throw new exception_1.IllegalArgument('Game.playerName()');
        }
        if (arguments.length === 1) {
            return this._playerName[colorCode];
        }
        else {
            this._playerName[colorCode] = sanitizeStringHeader(value);
        }
    }
    playerElo(color, value) {
        const colorCode = (0, base_types_impl_1.colorFromString)(color);
        if (colorCode < 0) {
            throw new exception_1.IllegalArgument('Game.playerElo()');
        }
        if (arguments.length === 1) {
            return this._playerElo[colorCode];
        }
        else {
            value = sanitizeNumberHeader(value);
            if (value === undefined || (0, common_1.isValidElo)(value)) {
                this._playerElo[colorCode] = value;
            }
            else {
                throw new exception_1.IllegalArgument('Game.playerElo()');
            }
        }
    }
    playerTitle(color, value) {
        const colorCode = (0, base_types_impl_1.colorFromString)(color);
        if (colorCode < 0) {
            throw new exception_1.IllegalArgument('Game.playerTitle()');
        }
        if (arguments.length === 1) {
            return this._playerTitle[colorCode];
        }
        else {
            this._playerTitle[colorCode] = sanitizeStringHeader(value);
        }
    }
    event(value) {
        if (arguments.length === 0) {
            return this._event;
        }
        else {
            this._event = sanitizeStringHeader(value);
        }
    }
    round(value) {
        if (arguments.length === 0) {
            return this._round[0 /* RoundPart.ROUND */];
        }
        else {
            this._setRoundPart(0 /* RoundPart.ROUND */, value, 'Game.round()');
        }
    }
    subRound(value) {
        if (arguments.length === 0) {
            return this._round[1 /* RoundPart.SUB_ROUND */];
        }
        else {
            this._setRoundPart(1 /* RoundPart.SUB_ROUND */, value, 'Game.subRound()');
        }
    }
    subSubRound(value) {
        if (arguments.length === 0) {
            return this._round[2 /* RoundPart.SUB_SUB_ROUND */];
        }
        else {
            this._setRoundPart(2 /* RoundPart.SUB_SUB_ROUND */, value, 'Game.subSubRound()');
        }
    }
    _setRoundPart(roundPart, value, methodName) {
        value = sanitizeNumberHeader(value);
        if (value === undefined || (0, common_1.isValidRound)(value)) {
            this._round[roundPart] = value;
        }
        else {
            throw new exception_1.IllegalArgument(methodName);
        }
    }
    /**
     * Get the round, sub-round and sub-sub-round as a human-readable string, the 3 components being separated by dot characters.
     */
    fullRound() {
        return formatFullRound(this._round[0 /* RoundPart.ROUND */], this._round[1 /* RoundPart.SUB_ROUND */], this._round[2 /* RoundPart.SUB_SUB_ROUND */], '?');
    }
    date(valueOrYear, month, day) {
        switch (arguments.length) {
            case 0:
                return this._date;
            case 1:
                if (valueOrYear === undefined || valueOrYear === null) {
                    this._date = undefined;
                }
                else if (valueOrYear instanceof date_value_1.DateValue) {
                    this._date = valueOrYear;
                }
                else if (valueOrYear instanceof Date) {
                    this._date = new date_value_1.DateValue(valueOrYear);
                }
                else if (date_value_1.DateValue.isValid(valueOrYear)) {
                    this._date = new date_value_1.DateValue(valueOrYear);
                }
                else {
                    throw new exception_1.IllegalArgument('Game.date()');
                }
                break;
            default:
                if (date_value_1.DateValue.isValid(valueOrYear, month, day)) {
                    this._date = new date_value_1.DateValue(valueOrYear, month, day);
                }
                else {
                    throw new exception_1.IllegalArgument('Game.date()');
                }
                break;
        }
    }
    /**
     * Get the date of the game as a standard JavaScript `Date` object.
     *
     * If the day of month is undefined for the current game, the returned `Date` object points at the first day of the corresponding month.
     * If neither the day of month nor the month are undefined for the current game, the returned `Date` object points at the first day of the corresponding year.
     */
    dateAsDate() {
        return this._date === undefined ? undefined : this._date.toDate();
    }
    /**
     * Get the date of the game as a human-readable string (e.g. `'November 1955'`, `'September 4, 2021'`).
     *
     * @param locales - Locales to use to generate the result. If undefined, the default locale of the execution environment is used.
     *                  See [Intl documentation](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl#locale_identification_and_negotiation)
     *                  for more details.
     */
    dateAsString(locales) {
        return this._date === undefined ? undefined : this._date.toHumanReadableString(locales);
    }
    site(value) {
        if (arguments.length === 0) {
            return this._site;
        }
        else {
            this._site = sanitizeStringHeader(value);
        }
    }
    annotator(value) {
        if (arguments.length === 0) {
            return this._annotator;
        }
        else {
            this._annotator = sanitizeStringHeader(value);
        }
    }
    eco(value) {
        if (arguments.length === 0) {
            return this._eco;
        }
        else {
            value = sanitizeStringHeader(value);
            if (value !== undefined && !(0, helper_1.isValidECO)(value)) {
                throw new exception_1.IllegalArgument('Game.eco()');
            }
            this._eco = value;
        }
    }
    opening(value) {
        if (arguments.length === 0) {
            return this._opening;
        }
        else {
            this._opening = sanitizeStringHeader(value);
        }
    }
    openingVariation(value) {
        if (arguments.length === 0) {
            return this._openingVariation;
        }
        else {
            this._openingVariation = sanitizeStringHeader(value);
        }
    }
    openingSubVariation(value) {
        if (arguments.length === 0) {
            return this._openingSubVariation;
        }
        else {
            this._openingSubVariation = sanitizeStringHeader(value);
        }
    }
    termination(value) {
        if (arguments.length === 0) {
            return this._termination;
        }
        else {
            this._termination = sanitizeStringHeader(value);
        }
    }
    result(value) {
        if (arguments.length === 0) {
            return (0, base_types_impl_1.resultToString)(this._result);
        }
        else {
            const resultCode = (0, base_types_impl_1.resultFromString)(value);
            if (resultCode < 0) {
                throw new exception_1.IllegalArgument('Game.result()');
            }
            this._result = resultCode;
        }
    }
    /**
     * Get the chess game variant of the game.
     */
    variant() {
        return this._moveTreeRoot._position.variant();
    }
    initialPosition(initialPosition, fullMoveNumber) {
        if (arguments.length === 0) {
            return new position_1.Position(this._moveTreeRoot._position);
        }
        else {
            if (!(initialPosition instanceof position_1.Position)) {
                throw new exception_1.IllegalArgument('Game.initialPosition()');
            }
            if (arguments.length >= 2) {
                if (!Number.isInteger(fullMoveNumber)) {
                    throw new exception_1.IllegalArgument('Game.initialPosition()');
                }
                this._moveTreeRoot._fullMoveNumber = fullMoveNumber;
            }
            else {
                this._moveTreeRoot._fullMoveNumber = 1;
            }
            this._moveTreeRoot._position = new position_1.Position(initialPosition);
            this._moveTreeRoot.clearTree();
        }
    }
    /**
     * [FEN](https://en.wikipedia.org/wiki/Forsyth%E2%80%93Edwards_Notation) representation of the chess position at the beginning of the game.
     *
     * The fifty-move clock and full-move number are set according to the move history in the string returned by this method.
     */
    initialFEN() {
        return this._moveTreeRoot._position.fen({
            fiftyMoveClock: 0,
            fullMoveNumber: this._moveTreeRoot._fullMoveNumber,
        });
    }
    /**
     * Full-move number at which the game starts.
     */
    initialFullMoveNumber() {
        return this._moveTreeRoot._fullMoveNumber;
    }
    /**
     * Chess position at the end of the game.
     */
    finalPosition() {
        return this._moveTreeRoot.mainVariation().finalPosition();
    }
    /**
     * [FEN](https://en.wikipedia.org/wiki/Forsyth%E2%80%93Edwards_Notation) representation of the chess position at the end of the game.
     *
     * The fifty-move clock and full-move number are set according to the move history in the string returned by this method.
     */
    finalFEN() {
        return this._moveTreeRoot.mainVariation().finalFEN();
    }
    /**
     * The main variation of the game.
     */
    mainVariation() {
        return this._moveTreeRoot.mainVariation();
    }
    /**
     * Return the nodes corresponding to the moves of the main variation.
     *
     * @param withSubVariations - If `true`, the nodes of the sub-variations are also included in the result.
     */
    nodes(withSubVariations = false) {
        if (!withSubVariations) {
            return this.mainVariation().nodes();
        }
        const result = [];
        function processVariation(variation) {
            for (const currentNode of variation.nodes()) {
                for (const nextVariation of currentNode.variations()) {
                    processVariation(nextVariation);
                }
                result.push(currentNode);
            }
        }
        processVariation(this.mainVariation());
        return result;
    }
    /**
     * Number of half-moves in the main variation.
     *
     * For instance, after `1.e4 e5 2.Nf3`, the number of half-moves if 3 (2 white moves + 1 black move).
     */
    plyCount() {
        return this._moveTreeRoot.mainVariation().plyCount();
    }
    /**
     * Return the node or variation corresponding to the given ID (see {@link Node.id | Node.id} and {@link Variation.id | Variation.id}
     * to retrieve the ID of a node or variation).
     *
     * For the main variation, IDs are built as follows:
     * - `'start'` is the ID of the main variation,
     * - `'3w'` is for instance the ID of the node whose {@link Node.fullMoveNumber} is 3 and {@link Node.moveColor} is white
     *   (i.e. the 3rd white move if the game starts from the usual initial position),
     * - `'end'` is an alias corresponding to the last node in the main variation (or the main variation itself if it is empty).
     *
     * For sub-variations, IDs are built as in the following examples:
     * - `'2b-v0-start'` is the ID of the sub-variation at index 0 on node `'2b'` (in the main variation),
     * - `'5w-v3-11b'` is the ID of the node whose {@link Node.fullMoveNumber} is 11 and {@link Node.moveColor} is black within
     *   the sub-variation at index 3 on node `'5w'` (in the main variation),
     * - `'5w-v3-end'` is an alias corresponding to the last node in this sub-variation (or the sub-variation itself if it is empty).
     *
     * @param allowAliases - If `true`, search `id` among both IDs and ID aliases. If `false`, search among IDs only.
     * @returns `undefined` if the given ID does not correspond to an existing {@link Node} and {@link Variation}.
     */
    findById(id, allowAliases = true) {
        return this._moveTreeRoot.findById(id, allowAliases);
    }
    /**
     * Return the [POJO](https://en.wikipedia.org/wiki/Plain_old_Java_object) representation of the current {@link Game}.
     * To be used for JSON serialization, deep cloning, etc...
     */
    pojo() {
        const pojo = {};
        function isPlayerPOJOEmpty(game, color) {
            return game._playerName[color] === undefined && game._playerElo[color] === undefined && game._playerTitle[color] === undefined;
        }
        function getPlayerPOJO(game, color) {
            const playerPOJO = {};
            if (game._playerName[color] !== undefined) {
                playerPOJO.name = game._playerName[color];
            }
            if (game._playerElo[color] !== undefined) {
                playerPOJO.elo = game._playerElo[color];
            }
            if (game._playerTitle[color] !== undefined) {
                playerPOJO.title = game._playerTitle[color];
            }
            return playerPOJO;
        }
        // Headers
        if (!isPlayerPOJOEmpty(this, 0 /* ColorImpl.WHITE */)) {
            pojo.white = getPlayerPOJO(this, 0 /* ColorImpl.WHITE */);
        }
        if (!isPlayerPOJOEmpty(this, 1 /* ColorImpl.BLACK */)) {
            pojo.black = getPlayerPOJO(this, 1 /* ColorImpl.BLACK */);
        }
        if (this._event !== undefined) {
            pojo.event = this._event;
        }
        if (this._round[0 /* RoundPart.ROUND */] !== undefined) {
            pojo.round = this._round[0 /* RoundPart.ROUND */];
        }
        if (this._round[1 /* RoundPart.SUB_ROUND */] !== undefined) {
            pojo.subRound = this._round[1 /* RoundPart.SUB_ROUND */];
        }
        if (this._round[2 /* RoundPart.SUB_SUB_ROUND */] !== undefined) {
            pojo.subSubRound = this._round[2 /* RoundPart.SUB_SUB_ROUND */];
        }
        if (this._date !== undefined) {
            pojo.date = this._date.toString();
        }
        if (this._site !== undefined) {
            pojo.site = this._site;
        }
        if (this._annotator !== undefined) {
            pojo.annotator = this._annotator;
        }
        if (this._eco !== undefined) {
            pojo.eco = this._eco;
        }
        if (this._opening !== undefined) {
            pojo.opening = this._opening;
        }
        if (this._openingVariation !== undefined) {
            pojo.openingVariation = this._openingVariation;
        }
        if (this._openingSubVariation !== undefined) {
            pojo.openingSubVariation = this._openingSubVariation;
        }
        if (this._termination !== undefined) {
            pojo.termination = this._termination;
        }
        if (this._result !== 3 /* GameResultImpl.LINE */) {
            pojo.result = this.result();
        }
        // Moves
        this._moveTreeRoot.getPojo(pojo);
        return pojo;
    }
    /**
     * Decode the [POJO](https://en.wikipedia.org/wiki/Plain_old_Java_object) passed in argument, assuming it follows the schema defined by {@link GamePOJO}.
     *
     * @throws {@link exception.InvalidPOJO} if the given object cannot be decoded, either because it does not follow the schema defined by {@link GamePOJO},
     *         or because it would result in an inconsistent game (e.g. if it contains some invalid moves).
     */
    static fromPOJO(pojo) {
        if (typeof pojo !== 'object' || pojo === null) {
            throw new exception_1.InvalidPOJO(pojo, '', i18n_1.i18n.POJO_MUST_BE_AN_OBJECT);
        }
        const game = new Game();
        const exceptionBuilder = new pojo_util_1.POJOExceptionBuilder(pojo);
        function processPlayerPOJO(playerPOJO, color) {
            (0, pojo_util_1.decodeStringField)(playerPOJO, 'name', exceptionBuilder, value => { game._playerName[color] = value; });
            (0, pojo_util_1.decodeNumberField)(playerPOJO, 'elo', exceptionBuilder, value => {
                if (!(0, common_1.isValidElo)(value)) {
                    throw exceptionBuilder.build(i18n_1.i18n.INVALID_ELO_IN_POJO);
                }
                game._playerElo[color] = value;
            });
            (0, pojo_util_1.decodeStringField)(playerPOJO, 'title', exceptionBuilder, value => { game._playerTitle[color] = value; });
        }
        function processRoundPart(value, roundPart) {
            if (!(0, common_1.isValidRound)(value)) {
                throw exceptionBuilder.build(i18n_1.i18n.INVALID_ROUND_IN_POJO);
            }
            game._round[roundPart] = value;
        }
        // Headers
        (0, pojo_util_1.decodeObjectField)(pojo, 'white', exceptionBuilder, value => { processPlayerPOJO(value, 0 /* ColorImpl.WHITE */); });
        (0, pojo_util_1.decodeObjectField)(pojo, 'black', exceptionBuilder, value => { processPlayerPOJO(value, 1 /* ColorImpl.BLACK */); });
        (0, pojo_util_1.decodeStringField)(pojo, 'event', exceptionBuilder, value => { game._event = value; });
        (0, pojo_util_1.decodeNumberField)(pojo, 'round', exceptionBuilder, value => { processRoundPart(value, 0 /* RoundPart.ROUND */); });
        (0, pojo_util_1.decodeNumberField)(pojo, 'subRound', exceptionBuilder, value => { processRoundPart(value, 1 /* RoundPart.SUB_ROUND */); });
        (0, pojo_util_1.decodeNumberField)(pojo, 'subSubRound', exceptionBuilder, value => { processRoundPart(value, 2 /* RoundPart.SUB_SUB_ROUND */); });
        (0, pojo_util_1.decodeStringField)(pojo, 'date', exceptionBuilder, value => {
            const date = date_value_1.DateValue.fromString(value);
            if (date === undefined) {
                throw exceptionBuilder.build(i18n_1.i18n.INVALID_DATE_IN_POJO);
            }
            game._date = date;
        });
        (0, pojo_util_1.decodeStringField)(pojo, 'site', exceptionBuilder, value => { game._site = value; });
        (0, pojo_util_1.decodeStringField)(pojo, 'annotator', exceptionBuilder, value => { game._annotator = value; });
        (0, pojo_util_1.decodeStringField)(pojo, 'eco', exceptionBuilder, value => {
            if (!(0, helper_1.isValidECO)(value)) {
                throw exceptionBuilder.build(i18n_1.i18n.INVALID_ECO_CODE_IN_POJO);
            }
            game._eco = value;
        });
        (0, pojo_util_1.decodeStringField)(pojo, 'opening', exceptionBuilder, value => { game._opening = value; });
        (0, pojo_util_1.decodeStringField)(pojo, 'openingVariation', exceptionBuilder, value => { game._openingVariation = value; });
        (0, pojo_util_1.decodeStringField)(pojo, 'openingSubVariation', exceptionBuilder, value => { game._openingSubVariation = value; });
        (0, pojo_util_1.decodeStringField)(pojo, 'termination', exceptionBuilder, value => { game._termination = value; });
        (0, pojo_util_1.decodeStringField)(pojo, 'result', exceptionBuilder, value => {
            const resultCode = (0, base_types_impl_1.resultFromString)(value);
            if (resultCode < 0) {
                throw exceptionBuilder.build(i18n_1.i18n.INVALID_RESULT_IN_POJO);
            }
            game._result = resultCode;
        });
        // Moves
        game._moveTreeRoot.setPojo(pojo, exceptionBuilder);
        return game;
    }
    /**
     * Return a human-readable string representing the game. This string is multi-line,
     * and is intended to be displayed in a fixed-width font (similarly to an ASCII-art picture).
     */
    ascii() {
        const lines = [];
        function pushIfDefined(header) {
            if (header !== undefined) {
                lines.push(header);
            }
        }
        // Headers
        pushIfDefined(formatEventAndRound(this._event, this._round[0 /* RoundPart.ROUND */], this._round[1 /* RoundPart.SUB_ROUND */], this._round[2 /* RoundPart.SUB_SUB_ROUND */]));
        pushIfDefined(formatSimpleHeader('Site', this._site));
        pushIfDefined(formatSimpleHeader('Date', this.dateAsString('en-us')));
        pushIfDefined(formatPlayer('White', this._playerName[0 /* ColorImpl.WHITE */], this._playerElo[0 /* ColorImpl.WHITE */], this._playerTitle[0 /* ColorImpl.WHITE */]));
        pushIfDefined(formatPlayer('Black', this._playerName[1 /* ColorImpl.BLACK */], this._playerElo[1 /* ColorImpl.BLACK */], this._playerTitle[1 /* ColorImpl.BLACK */]));
        pushIfDefined(formatSimpleHeader('Annotator', this._annotator));
        pushIfDefined(formatSimpleHeader('ECO', this._eco));
        pushIfDefined(formatOpening(this._opening, this._openingVariation, this._openingSubVariation));
        pushIfDefined(formatSimpleHeader('Termination', this._termination));
        // Variant & initial position
        const variant = this._moveTreeRoot._position.variant();
        if (variant !== 'regular') {
            lines.push('Variant: ' + variant);
        }
        if (!(0, helper_1.variantWithCanonicalStartPosition)(variant) || !position_1.Position.isEqual(this._moveTreeRoot._position, new position_1.Position(variant))) {
            lines.push(this._moveTreeRoot._position.ascii());
        }
        // Moves & result
        function isNonEmptyVariation(variation) {
            return variation.first() !== undefined || variation.nags().length > 0 || variation.tags().length > 0 || variation.comment() !== undefined;
        }
        function dumpNode(node, indent, hasSomethingAfter) {
            // Describe the move
            const move = indent + node.fullMoveNumber() + (node.moveColor() === 'w' ? '.' : '...') + node.notation();
            const moveAnnotations = formatAnnotations(node);
            lines.push(moveAnnotations.length === 0 ? move : move + ' ' + moveAnnotations.join(' '));
            // Print the sub-variations
            let atLeastOneNonEmptyVariation = false;
            for (const variation of node.variations()) {
                if (isNonEmptyVariation(variation)) {
                    lines.push(indent + ' |');
                    dumpVariation(variation, indent + (hasSomethingAfter ? ' |  ' : '    '), indent + ' +- ', false);
                    atLeastOneNonEmptyVariation = true;
                }
            }
            return atLeastOneNonEmptyVariation;
        }
        function dumpVariation(variation, indent, indentFirst, hasSomethingAfter) {
            // Variation annotations
            const variationAnnotations = formatAnnotations(variation);
            if (variationAnnotations.length > 0) {
                lines.push(indentFirst + variationAnnotations.join(' '));
            }
            // List of moves
            let node = variation.first();
            let atLeastOneVariationInPreviousNode = false;
            let isFirstNode = true;
            while (node !== undefined) {
                if (atLeastOneVariationInPreviousNode) {
                    lines.push(indent + ' |');
                }
                const nextNode = node.next();
                atLeastOneVariationInPreviousNode = dumpNode(node, isFirstNode && variationAnnotations.length === 0 ? indentFirst : indent, hasSomethingAfter || nextNode !== undefined);
                isFirstNode = false;
                node = nextNode;
            }
        }
        dumpVariation(this._moveTreeRoot.mainVariation(), '', '', false);
        lines.push((0, base_types_impl_1.resultToString)(this._result));
        return lines.join('\n');
    }
}
exports.Game = Game;
function sanitizeStringHeader(value) {
    return value === undefined || value === null ? undefined : String(value);
}
function sanitizeNumberHeader(value) {
    return value === undefined || value === null ? undefined : Number(value);
}
function trimCollapseAndMarkEmpty(text) {
    text = (0, common_1.trimAndCollapseSpaces)(text);
    return text === '' ? '<empty>' : text;
}
function formatSimpleHeader(key, header) {
    return header === undefined ? undefined : `${key}: ${trimCollapseAndMarkEmpty(header)}`;
}
function formatEventAndRound(event, round, subRound, subSubRound) {
    if (event === undefined && round === undefined && subRound === undefined && subSubRound === undefined) {
        return undefined;
    }
    let result = event === undefined ? 'Event: <undefined>' : `Event: ${trimCollapseAndMarkEmpty(event)}`;
    const fullRound = formatFullRound(round, subRound, subSubRound, '*');
    if (fullRound !== undefined) {
        result += ` (${fullRound})`;
    }
    return result;
}
function formatFullRound(round, subRound, subSubRound, undefinedToken) {
    if (round === undefined && subRound === undefined && subSubRound === undefined) {
        return undefined;
    }
    let result = round === undefined ? undefinedToken : String(round);
    if (subRound !== undefined || subSubRound !== undefined) {
        result += '.' + (subRound !== null && subRound !== void 0 ? subRound : undefinedToken);
    }
    if (subSubRound !== undefined) {
        result += '.' + subSubRound;
    }
    return result;
}
function formatPlayer(key, playerName, playerElo, playerTitle) {
    if (playerName === undefined && playerElo === undefined && playerTitle === undefined) {
        return undefined;
    }
    let result = playerName === undefined ? `${key}: <undefined>` : `${key}: ${trimCollapseAndMarkEmpty(playerName)}`;
    if (playerElo !== undefined && playerTitle !== undefined) {
        result += ` (${trimCollapseAndMarkEmpty(playerTitle)} ${playerElo})`;
    }
    else if (playerElo !== undefined) {
        result += ` (${playerElo})`;
    }
    else if (playerTitle !== undefined) {
        result += ` (${trimCollapseAndMarkEmpty(playerTitle)})`;
    }
    return result;
}
function formatOpening(opening, openingVariation, openingSubVariation) {
    if (opening === undefined && openingVariation === undefined && openingSubVariation === undefined) {
        return undefined;
    }
    let result = opening === undefined ? 'Opening: <undefined>' : `Opening: ${trimCollapseAndMarkEmpty(opening)}`;
    if (openingSubVariation !== undefined) {
        result += ` (${openingVariation === undefined ? '<undefined>' : trimCollapseAndMarkEmpty(openingVariation)}, ${trimCollapseAndMarkEmpty(openingSubVariation)})`;
    }
    else if (openingVariation !== undefined) {
        result += ` (${trimCollapseAndMarkEmpty(openingVariation)})`;
    }
    return result;
}
function formatAnnotations(node) {
    const result = [];
    // NAGs
    for (const nag of node.nags()) {
        result.push((0, helper_1.nagSymbol)(nag));
    }
    // Tags
    for (const tagKey of node.tags()) {
        result.push(`${tagKey}={${(0, common_1.trimAndCollapseSpaces)(node.tag(tagKey))}}`);
    }
    // Comment
    const comment = node.comment();
    if (comment !== undefined) {
        result.push(trimCollapseAndMarkEmpty(comment));
    }
    return result;
}

},{"./date_value":2,"./exception":3,"./helper":5,"./i18n":6,"./position":11,"./private_game/common":12,"./private_game/node_variation_impl":13,"./private_game/pojo_util":14,"./private_position/base_types_impl":19}],5:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidECO = exports.nagSymbol = exports.variantWithCanonicalStartPosition = exports.oppositeColor = exports.coordinatesToSquare = exports.squareToCoordinates = exports.squareColor = exports.forEachSquare = exports.isGameVariant = exports.isGameResult = exports.isCastle960 = exports.isCastle = exports.isSquareCouple = exports.isSquare = exports.isRank = exports.isFile = exports.isColoredPiece = exports.isPiece = exports.isColor = void 0;
const exception_1 = require("./exception");
const base_types_impl_1 = require("./private_position/base_types_impl");
const impl_1 = require("./private_position/impl");
const common_1 = require("./private_game/common");
/**
 * Whether the given value represents a valid {@link Color} or not.
 */
function isColor(value) {
    return (0, base_types_impl_1.colorFromString)(value) >= 0;
}
exports.isColor = isColor;
/**
 * Whether the given value represents a valid {@link Piece} or not.
 */
function isPiece(value) {
    return (0, base_types_impl_1.pieceFromString)(value) >= 0;
}
exports.isPiece = isPiece;
/**
 * Whether the given value represents a valid {@link ColoredPiece} or not.
 */
function isColoredPiece(value) {
    return (0, base_types_impl_1.coloredPieceFromString)(value) >= 0;
}
exports.isColoredPiece = isColoredPiece;
/**
 * Whether the given value represents a valid {@link File} or not.
 */
function isFile(value) {
    return (0, base_types_impl_1.fileFromString)(value) >= 0;
}
exports.isFile = isFile;
/**
 * Whether the given value represents a valid {@link Rank} or not.
 */
function isRank(value) {
    return (0, base_types_impl_1.rankFromString)(value) >= 0;
}
exports.isRank = isRank;
/**
 * Whether the given value represents a valid {@link Square} or not.
 */
function isSquare(value) {
    return (0, base_types_impl_1.squareFromString)(value) >= 0;
}
exports.isSquare = isSquare;
/**
 * Whether the given value represents a valid {@link SquareCouple} or not.
 */
function isSquareCouple(value) {
    return typeof value === 'string' && /^[a-h][1-8][a-h][1-8]$/.test(value);
}
exports.isSquareCouple = isSquareCouple;
/**
 * Whether the given value represents a valid {@link Castle} or not.
 */
function isCastle(value) {
    return typeof value === 'string' && /^[wb][kq]$/.test(value);
}
exports.isCastle = isCastle;
/**
 * Whether the given value represents a valid {@link Castle960} or not.
 */
function isCastle960(value) {
    return typeof value === 'string' && /^[wb][a-h]$/.test(value);
}
exports.isCastle960 = isCastle960;
/**
 * Whether the given value represents a valid {@link GameResult} or not.
 */
function isGameResult(value) {
    return (0, base_types_impl_1.resultFromString)(value) >= 0;
}
exports.isGameResult = isGameResult;
/**
 * Whether the given value represents a valid {@link GameVariant} or not.
 */
function isGameVariant(value) {
    return (0, base_types_impl_1.variantFromString)(value) >= 0;
}
exports.isGameVariant = isGameVariant;
/**
 * Execute the given callback on each of the 64 squares.
 */
function forEachSquare(callback) {
    for (let rank = 0; rank < 8; ++rank) {
        for (let file = 0; file < 8; ++file) {
            callback((0, base_types_impl_1.squareToString)(rank * 16 + file));
        }
    }
}
exports.forEachSquare = forEachSquare;
/**
 * Return the color of a square.
 */
function squareColor(square) {
    const squareCode = (0, base_types_impl_1.squareFromString)(square);
    if (squareCode < 0) {
        throw new exception_1.IllegalArgument('squareColor()');
    }
    return (0, base_types_impl_1.colorToString)((0, base_types_impl_1.squareColorImpl)(squareCode));
}
exports.squareColor = squareColor;
/**
 * Return the coordinates of a square.
 */
function squareToCoordinates(square) {
    const squareCode = (0, base_types_impl_1.squareFromString)(square);
    if (squareCode < 0) {
        throw new exception_1.IllegalArgument('squareToCoordinates()');
    }
    return { rank: Math.trunc(squareCode / 16), file: squareCode % 16 };
}
exports.squareToCoordinates = squareToCoordinates;
function coordinatesToSquare(fileOrCoordinates, rankOrUndefined) {
    const file = typeof fileOrCoordinates === 'number' ? fileOrCoordinates : fileOrCoordinates.file;
    const rank = typeof fileOrCoordinates === 'number' ? rankOrUndefined : fileOrCoordinates.rank;
    if (!Number.isInteger(file) || !Number.isInteger(rank) || file < 0 || file >= 8 || rank < 0 || rank >= 8) {
        throw new exception_1.IllegalArgument('coordinatesToSquare()');
    }
    return (0, base_types_impl_1.fileToString)(file) + (0, base_types_impl_1.rankToString)(rank);
}
exports.coordinatesToSquare = coordinatesToSquare;
/**
 * Change white to black, and black to white.
 */
function oppositeColor(color) {
    const colorCode = (0, base_types_impl_1.colorFromString)(color);
    if (colorCode < 0) {
        throw new exception_1.IllegalArgument('oppositeColor()');
    }
    return (0, base_types_impl_1.colorToString)(1 - colorCode);
}
exports.oppositeColor = oppositeColor;
/**
 * Whether the given variant has a canonical start position or not.
 */
function variantWithCanonicalStartPosition(variant) {
    const variantCode = (0, base_types_impl_1.variantFromString)(variant);
    if (variantCode < 0) {
        throw new exception_1.IllegalArgument('variantWithCanonicalStartPosition()');
    }
    return (0, impl_1.hasCanonicalStartPosition)(variantCode);
}
exports.variantWithCanonicalStartPosition = variantWithCanonicalStartPosition;
const NAG_SYMBOLS = new Map();
NAG_SYMBOLS.set(1, '!'); // good move
NAG_SYMBOLS.set(2, '?'); // bad move
NAG_SYMBOLS.set(3, '!!'); // very good move
NAG_SYMBOLS.set(4, '??'); // very bad move
NAG_SYMBOLS.set(5, '!?'); // interesting move
NAG_SYMBOLS.set(6, '?!'); // questionable move
NAG_SYMBOLS.set(7, '\u25a1'); // Only move
NAG_SYMBOLS.set(8, '\u25a1'); // Only move (ChessBase)
NAG_SYMBOLS.set(9, '\u2612'); // Worst move (Chess.com)
NAG_SYMBOLS.set(10, '='); // equal position
NAG_SYMBOLS.set(11, '='); // equal position (ChessBase)
NAG_SYMBOLS.set(13, '\u221e'); // unclear position
NAG_SYMBOLS.set(14, '\u2a72'); // White has a slight advantage
NAG_SYMBOLS.set(15, '\u2a71'); // Black has a slight advantage
NAG_SYMBOLS.set(16, '\u00b1'); // White has a moderate advantage
NAG_SYMBOLS.set(17, '\u2213'); // Black has a moderate advantage
NAG_SYMBOLS.set(18, '+\u2212'); // White has a decisive advantage
NAG_SYMBOLS.set(19, '\u2212+'); // Black has a decisive advantage
NAG_SYMBOLS.set(20, '+\u2212\u2212'); // White has a crushing advantage
NAG_SYMBOLS.set(21, '\u2212\u2212+'); // Black has a crushing advantage
NAG_SYMBOLS.set(22, '\u2a00'); // Zugzwang
NAG_SYMBOLS.set(32, '\u27f3'); // Development advantage
NAG_SYMBOLS.set(36, '\u2191'); // Initiative
NAG_SYMBOLS.set(40, '\u2192'); // Attack
NAG_SYMBOLS.set(44, '\u2bf9'); // Compensation
NAG_SYMBOLS.set(132, '\u21c6'); // Counterplay
NAG_SYMBOLS.set(138, '\u2a01'); // Zeitnot
NAG_SYMBOLS.set(140, '\u2206'); // With idea...
NAG_SYMBOLS.set(141, '\u2207'); // Aimed against...
NAG_SYMBOLS.set(142, '\u2313'); // Better is...
NAG_SYMBOLS.set(143, '\u2264'); // Worse is...
NAG_SYMBOLS.set(145, 'RR'); // Editorial comment
NAG_SYMBOLS.set(146, 'N'); // Novelty
/**
 * Return the human-readable symbol for the given [NAG](https://en.wikipedia.org/wiki/Numeric_Annotation_Glyphs).
 */
function nagSymbol(nag) {
    if (!(0, common_1.isValidNag)(nag)) {
        throw new exception_1.IllegalArgument('nagSymbol()');
    }
    const result = NAG_SYMBOLS.get(nag);
    return result !== null && result !== void 0 ? result : '$' + nag;
}
exports.nagSymbol = nagSymbol;
/**
 * Whether the given string represents a valid [ECO code](https://en.wikipedia.org/wiki/List_of_chess_openings) or not.
 */
function isValidECO(eco) {
    return typeof eco === 'string' && /^[A-E][0-9][0-9]$/.test(eco);
}
exports.isValidECO = isValidECO;

},{"./exception":3,"./private_game/common":12,"./private_position/base_types_impl":19,"./private_position/impl":21}],6:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.i18n = void 0;
/**
 * This module defines the localizable strings used by the library.
 */
var i18n;
(function (i18n) {
    /* eslint-disable prefer-const */
    // WARNING: all those constants must be declared with "let" to allow them to be re-defined if necessary by consumer codes.
    // FEN parsing error messages
    i18n.WRONG_NUMBER_OF_FEN_FIELDS = 'A FEN string must contain exactly 6 space-separated fields.';
    i18n.WRONG_NUMBER_OF_SUBFIELDS_IN_BOARD_FIELD = 'The 1st field of a FEN string must contain exactly 8 `/`-separated subfields.';
    i18n.UNEXPECTED_CHARACTER_IN_BOARD_FIELD = 'Unexpected character in the 1st field of the FEN string: `{0}`.';
    i18n.UNEXPECTED_END_OF_SUBFIELD_IN_BOARD_FIELD = 'Subfield {0} of the FEN string 1st field is unexpectedly short.';
    i18n.INVALID_TURN_FIELD = 'The 2nd field of a FEN string must be either `w` or `b`.';
    i18n.INVALID_CASTLING_FIELD = 'The 3rd field of a FEN string must be either `-` or a list of characters among `K`, `Q`, `k` and `q` (in this order).';
    i18n.INVALID_EN_PASSANT_FIELD = 'The 4th field of a FEN string must be either `-` or a square from the 3rd or 6th rank where en-passant is allowed.';
    i18n.WRONG_RANK_IN_EN_PASSANT_FIELD = 'The rank number indicated in the FEN string 4th field is inconsistent with respect to the 2nd field.';
    i18n.INEFFECTIVE_EN_PASSANT_FIELD = 'No en-passant capture can happen on file {0} in the position defined in the FEN string.';
    i18n.INVALID_HALF_MOVE_COUNT_FIELD = 'The 5th field of a FEN string must be a number, indicating the number of half-move since the last pawn move or capture.';
    i18n.INVALID_MOVE_NUMBER_FIELD = 'The 6th field of a FEN string must be a number, indicating the move number of the game.';
    i18n.INVALID_VARIANT_PREFIX = 'Invalid variant prefix: `{0}`.';
    // Notation & UCI parsing error messages
    i18n.INVALID_UCI_NOTATION_SYNTAX = 'The syntax of the UCI notation is invalid.';
    i18n.ILLEGAL_UCI_MOVE = 'The UCI move is not legal.';
    i18n.INVALID_MOVE_NOTATION_SYNTAX = 'The syntax of the move notation is invalid.';
    i18n.ILLEGAL_POSITION = 'The position is not legal.';
    i18n.ILLEGAL_NO_KING_CASTLING = 'Castling is not legal in the considered position as it has no king.';
    i18n.ILLEGAL_QUEEN_SIDE_CASTLING = 'Queen-side castling is not legal in the considered position.';
    i18n.ILLEGAL_KING_SIDE_CASTLING = 'King-side castling is not legal in the considered position.';
    i18n.NO_PIECE_CAN_MOVE_TO = 'No {0} can move to {1}.';
    i18n.NO_PIECE_CAN_MOVE_TO_DISAMBIGUATION = 'No {0} on the specified rank/file can move to {1}.';
    i18n.REQUIRE_DISAMBIGUATION = 'Cannot determine uniquely which {0} is supposed to move to {1}.';
    i18n.WRONG_DISAMBIGUATION_SYMBOL = 'Wrong disambiguation symbol (expected: `{0}`, observed: `{1}`).';
    i18n.CASTLING_MOVE_ENCODED_WITH_ZERO = 'Capital O must be used for castling moves (instead of digit 0).';
    i18n.TRYING_TO_CAPTURE_YOUR_OWN_PIECES = 'Capturing its own pieces is not legal.';
    i18n.CAPTURE_IS_MANDATORY = 'Capture is mandatory.';
    i18n.INVALID_PIECE_SYMBOL = 'Character `{0}` is not a valid piece symbol.';
    i18n.INVALID_PIECE_SYMBOL_COLOR = 'Invalid color for piece symbol `{0}`.';
    i18n.INVALID_CAPTURING_PAWN_MOVE = 'Invalid capturing pawn move.';
    i18n.INVALID_NON_CAPTURING_PAWN_MOVE = 'Invalid non-capturing pawn move.';
    i18n.NOT_SAFE_FOR_WHITE_KING = 'This move would let the white king in check.';
    i18n.NOT_SAFE_FOR_BLACK_KING = 'This move would let the black king in check.';
    i18n.MISSING_PROMOTION = 'A promoted piece must be specified for this move.';
    i18n.MISSING_PROMOTION_SYMBOL = 'Character `=` is required to specify a promoted piece.';
    i18n.INVALID_PROMOTED_PIECE = '{0} cannot be specified as a promoted piece.';
    i18n.ILLEGAL_PROMOTION = 'Specifying a promoted piece is illegal for this move.';
    i18n.ILLEGAL_NULL_MOVE = 'Cannot play a null-move in this position.';
    i18n.MISSING_CAPTURE_SYMBOL = 'Capture symbol `x` is missing.';
    i18n.INVALID_CAPTURE_SYMBOL = 'This move is not a capture move.';
    i18n.WRONG_CHECK_CHECKMATE_SYMBOL = 'Wrong check/checkmate symbol (expected: `{0}`, observed: `{1}`).';
    // PGN parsing error messages
    i18n.INVALID_PGN_TOKEN = 'Unrecognized character or group of characters.';
    i18n.INVALID_MOVE_IN_PGN_TEXT = 'Invalid move ({0}). {1}';
    i18n.INVALID_FEN_IN_PGN_TEXT = 'Invalid FEN string in the initial position header. {0}';
    i18n.UNEXPECTED_PGN_HEADER = 'Unexpected PGN game header.';
    i18n.MISSING_PGN_HEADER_ID = 'Missing or invalid PGN game header ID.';
    i18n.MISSING_PGN_HEADER_VALUE = 'Missing or invalid PGN game header value.';
    i18n.MISSING_END_OF_PGN_HEADER = 'Missing or invalid end of PGN game header.';
    i18n.UNEXPECTED_BEGIN_OF_VARIATION = 'Unexpected begin of variation.';
    i18n.UNEXPECTED_END_OF_VARIATION = 'Unexpected end of variation.';
    i18n.UNEXPECTED_END_OF_GAME = 'Unexpected end of game: there are pending variations.';
    i18n.UNEXPECTED_END_OF_TEXT = 'Unexpected end of text: there is a pending game.';
    i18n.INVALID_GAME_INDEX = 'Game index {0} is invalid (only {1} game(s) found in the PGN data).';
    i18n.UNKNOWN_VARIANT = 'Unknown chess game variant ({0}).';
    i18n.VARIANT_WITHOUT_FEN = 'For game variant {0}, the FEN header is mandatory.';
    // POJO deserializing error messages
    i18n.POJO_MUST_BE_AN_OBJECT = 'Unexpected non-object value passed as POJO.';
    i18n.INVALID_POJO_STRING_FIELD = 'Invalid value (must be a string).';
    i18n.INVALID_POJO_NUMBER_FIELD = 'Invalid value (must be a number).';
    i18n.INVALID_POJO_BOOLEAN_FIELD = 'Invalid value (must be a boolean).';
    i18n.INVALID_POJO_OBJECT_FIELD = 'Invalid value (must be an object).';
    i18n.INVALID_POJO_ARRAY_FIELD = 'Invalid value (must be an array).';
    i18n.INVALID_ELO_IN_POJO = 'Ill-formed elo.';
    i18n.INVALID_ROUND_IN_POJO = 'Ill-formed round, sub-round or sub-sub-round.';
    i18n.INVALID_DATE_IN_POJO = 'Ill-formed date.';
    i18n.INVALID_ECO_CODE_IN_POJO = 'Ill-formed ECO code.';
    i18n.INVALID_RESULT_IN_POJO = 'Ill-formed result.';
    i18n.INVALID_VARIANT_IN_POJO = 'Ill-formed variant.';
    i18n.INVALID_NAG_IN_POJO = 'Invalid NAG ({0}).';
    i18n.INVALID_TAG_IN_POJO = 'Invalid tag ({0}).';
    i18n.INVALID_MOVE_IN_POJO = 'Invalid move ({0}). {1}';
    i18n.INVALID_FEN_IN_POJO = 'Invalid initial position FEN. {0}';
    i18n.MISSING_INITIAL_POSITION_IN_POJO = 'For game variant {0}, the initial position field is mandatory.';
    i18n.INVALID_OR_MISSING_NODE_ARRAY = 'Invalid or missing node POJO array.';
    i18n.INVALID_OR_MISSING_NOTATION_FIELD = 'Invalid or missing node POJO.';
    i18n.NOT_A_NODE_POJO = 'A node POJO must be either a string or an object.';
    i18n.NOT_A_VARIATION_POJO = 'A variation POJO must be either an array or an object.';
})(i18n = exports.i18n || (exports.i18n = {}));

},{}],7:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.pgnWrite = exports.pgnRead = exports.Database = exports.Game = exports.Variation = exports.Node = exports.AbstractNode = exports.Position = exports.isMoveDescriptor = exports.MoveDescriptor = exports.DateValue = exports.isValidECO = exports.nagSymbol = exports.variantWithCanonicalStartPosition = exports.oppositeColor = exports.coordinatesToSquare = exports.squareToCoordinates = exports.squareColor = exports.forEachSquare = exports.isGameVariant = exports.isGameResult = exports.isCastle960 = exports.isCastle = exports.isSquareCouple = exports.isSquare = exports.isRank = exports.isFile = exports.isColoredPiece = exports.isPiece = exports.isColor = exports.exception = exports.i18n = void 0;
var i18n_1 = require("./i18n");
Object.defineProperty(exports, "i18n", { enumerable: true, get: function () { return i18n_1.i18n; } });
exports.exception = require("./exception");
var helper_1 = require("./helper");
Object.defineProperty(exports, "isColor", { enumerable: true, get: function () { return helper_1.isColor; } });
Object.defineProperty(exports, "isPiece", { enumerable: true, get: function () { return helper_1.isPiece; } });
Object.defineProperty(exports, "isColoredPiece", { enumerable: true, get: function () { return helper_1.isColoredPiece; } });
Object.defineProperty(exports, "isFile", { enumerable: true, get: function () { return helper_1.isFile; } });
Object.defineProperty(exports, "isRank", { enumerable: true, get: function () { return helper_1.isRank; } });
Object.defineProperty(exports, "isSquare", { enumerable: true, get: function () { return helper_1.isSquare; } });
Object.defineProperty(exports, "isSquareCouple", { enumerable: true, get: function () { return helper_1.isSquareCouple; } });
Object.defineProperty(exports, "isCastle", { enumerable: true, get: function () { return helper_1.isCastle; } });
Object.defineProperty(exports, "isCastle960", { enumerable: true, get: function () { return helper_1.isCastle960; } });
Object.defineProperty(exports, "isGameResult", { enumerable: true, get: function () { return helper_1.isGameResult; } });
Object.defineProperty(exports, "isGameVariant", { enumerable: true, get: function () { return helper_1.isGameVariant; } });
Object.defineProperty(exports, "forEachSquare", { enumerable: true, get: function () { return helper_1.forEachSquare; } });
Object.defineProperty(exports, "squareColor", { enumerable: true, get: function () { return helper_1.squareColor; } });
Object.defineProperty(exports, "squareToCoordinates", { enumerable: true, get: function () { return helper_1.squareToCoordinates; } });
Object.defineProperty(exports, "coordinatesToSquare", { enumerable: true, get: function () { return helper_1.coordinatesToSquare; } });
Object.defineProperty(exports, "oppositeColor", { enumerable: true, get: function () { return helper_1.oppositeColor; } });
Object.defineProperty(exports, "variantWithCanonicalStartPosition", { enumerable: true, get: function () { return helper_1.variantWithCanonicalStartPosition; } });
Object.defineProperty(exports, "nagSymbol", { enumerable: true, get: function () { return helper_1.nagSymbol; } });
Object.defineProperty(exports, "isValidECO", { enumerable: true, get: function () { return helper_1.isValidECO; } });
var date_value_1 = require("./date_value");
Object.defineProperty(exports, "DateValue", { enumerable: true, get: function () { return date_value_1.DateValue; } });
var move_descriptor_1 = require("./move_descriptor");
Object.defineProperty(exports, "MoveDescriptor", { enumerable: true, get: function () { return move_descriptor_1.MoveDescriptor; } });
Object.defineProperty(exports, "isMoveDescriptor", { enumerable: true, get: function () { return move_descriptor_1.isMoveDescriptor; } });
var position_1 = require("./position");
Object.defineProperty(exports, "Position", { enumerable: true, get: function () { return position_1.Position; } });
var node_variation_1 = require("./node_variation");
Object.defineProperty(exports, "AbstractNode", { enumerable: true, get: function () { return node_variation_1.AbstractNode; } });
Object.defineProperty(exports, "Node", { enumerable: true, get: function () { return node_variation_1.Node; } });
Object.defineProperty(exports, "Variation", { enumerable: true, get: function () { return node_variation_1.Variation; } });
var game_1 = require("./game");
Object.defineProperty(exports, "Game", { enumerable: true, get: function () { return game_1.Game; } });
var database_1 = require("./database");
Object.defineProperty(exports, "Database", { enumerable: true, get: function () { return database_1.Database; } });
var pgn_1 = require("./pgn");
Object.defineProperty(exports, "pgnRead", { enumerable: true, get: function () { return pgn_1.pgnRead; } });
Object.defineProperty(exports, "pgnWrite", { enumerable: true, get: function () { return pgn_1.pgnWrite; } });

},{"./database":1,"./date_value":2,"./exception":3,"./game":4,"./helper":5,"./i18n":6,"./move_descriptor":8,"./node_variation":9,"./pgn":10,"./position":11}],8:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isMoveDescriptor = exports.MoveDescriptor = void 0;
/**
 * Describe a legal chess move, with its characteristics.
 */
class MoveDescriptor {
    /**
     * @ignore
     */
    constructor() { }
    /**
     * @ignore
     */
    toString() {
        let result = this.from() + this.to();
        if (this.isPromotion()) {
            result += this.promotion().toUpperCase();
        }
        else if (this.isCastling()) {
            result += 'O';
        }
        return result;
    }
}
exports.MoveDescriptor = MoveDescriptor;
/**
 * @deprecated Use `obj instanceof MoveDescriptor` instead.
 */
function isMoveDescriptor(obj) {
    return obj instanceof MoveDescriptor;
}
exports.isMoveDescriptor = isMoveDescriptor;

},{}],9:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Variation = exports.Node = exports.AbstractNode = void 0;
/**
 * Base class for {@link Node} and {@link Variation}.
 */
class AbstractNode {
    /**
     * @ignore
     */
    constructor() { }
}
exports.AbstractNode = AbstractNode;
/**
 * Represent one move in the tree structure formed by a chess game with multiple variations.
 */
class Node extends AbstractNode {
    /**
     * @ignore
     */
    constructor() {
        super();
    }
    /**
     * @deprecated Use `obj instanceof Variation` instead.
     */
    isVariation() {
        return false;
    }
    /**
     * @ignore
     */
    toString() {
        return `${this.id()}[${this.notation()}]`;
    }
}
exports.Node = Node;
/**
 * Represent one variation in the tree structure formed by a chess game, meaning a starting chess position and
 * a list of moves played consecutively from this position.
 */
class Variation extends AbstractNode {
    /**
     * @ignore
     */
    constructor() {
        super();
    }
    /**
     * @deprecated Use `obj instanceof Variation` instead.
     */
    isVariation() {
        return true;
    }
    /**
     * @ignore
     */
    toString() {
        return this.id();
    }
}
exports.Variation = Variation;

},{}],10:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.pgnWrite = exports.pgnRead = void 0;
const database_1 = require("./database");
const exception_1 = require("./exception");
const game_1 = require("./game");
const pgn_read_impl_1 = require("./private_pgn/pgn_read_impl");
const pgn_write_impl_1 = require("./private_pgn/pgn_write_impl");
function pgnRead(pgnString, gameIndex) {
    if (typeof pgnString !== 'string') {
        throw new exception_1.IllegalArgument('pgnRead()');
    }
    if (arguments.length === 1) { // Parse all games (and return a Database object)...
        return (0, pgn_read_impl_1.readDatabase)(pgnString);
    }
    else { // Parse one game...
        if (!(0, database_1.isValidGameIndex)(gameIndex)) {
            throw new exception_1.IllegalArgument('pgnRead()');
        }
        return (0, pgn_read_impl_1.readOneGame)(pgnString, gameIndex);
    }
}
exports.pgnRead = pgnRead;
function pgnWrite(gameOrGames, options) {
    if (options === undefined || options === null) {
        options = {};
    }
    if (gameOrGames instanceof game_1.Game) {
        return (0, pgn_write_impl_1.writeGame)(gameOrGames, options);
    }
    else if (Array.isArray(gameOrGames) && gameOrGames.every(game => game instanceof game_1.Game)) {
        return (0, pgn_write_impl_1.writeGames)(gameOrGames, options);
    }
    else {
        throw new exception_1.IllegalArgument('pgnWrite()');
    }
}
exports.pgnWrite = pgnWrite;

},{"./database":1,"./exception":3,"./game":4,"./private_pgn/pgn_read_impl":15,"./private_pgn/pgn_write_impl":16}],11:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Position = void 0;
const exception_1 = require("./exception");
const helper_1 = require("./helper");
const i18n_1 = require("./i18n");
const attacks_1 = require("./private_position/attacks");
const base_types_impl_1 = require("./private_position/base_types_impl");
const fen_1 = require("./private_position/fen");
const impl_1 = require("./private_position/impl");
const legality_1 = require("./private_position/legality");
const move_descriptor_impl_1 = require("./private_position/move_descriptor_impl");
const move_generation_1 = require("./private_position/move_generation");
const notation_1 = require("./private_position/notation");
const uci_1 = require("./private_position/uci");
/**
 * Represent a chess position, i.e.:
 * - the state of a 64-square chessboard,
 * - who is about to play,
 * - the castling rights,
 * - and the file on which *en-passant* is possible, if any.
 */
class Position {
    constructor(arg0, arg1) {
        switch (arguments.length) {
            // Default constructor
            case 0:
                this._impl = (0, impl_1.makeInitial)(0 /* GameVariantImpl.REGULAR_CHESS */);
                break;
            // Possible overloads with 1 argument:
            //  - 'start'
            //  - 'empty'
            //  - Position
            //  - GameVariant (valid only for variants with a canonical starting position)
            //  - FEN
            //  - GameVariant:FEN
            case 1: {
                if (arg0 === 'start') {
                    this._impl = (0, impl_1.makeInitial)(0 /* GameVariantImpl.REGULAR_CHESS */);
                }
                else if (arg0 === 'empty') {
                    this._impl = (0, impl_1.makeEmpty)(0 /* GameVariantImpl.REGULAR_CHESS */);
                }
                else if (arg0 instanceof Position) {
                    this._impl = (0, impl_1.makeCopy)(arg0._impl);
                }
                else {
                    const variantCode = (0, base_types_impl_1.variantFromString)(arg0);
                    if (variantCode >= 0) {
                        if (!(0, impl_1.hasCanonicalStartPosition)(variantCode)) {
                            throw new exception_1.IllegalArgument('Position()');
                        }
                        this._impl = (0, impl_1.makeInitial)(variantCode);
                    }
                    else if (typeof arg0 === 'string') {
                        const separatorIndex = arg0.indexOf(':');
                        if (separatorIndex < 0) {
                            this._impl = (0, fen_1.parseFEN)(0 /* GameVariantImpl.REGULAR_CHESS */, arg0, false).position;
                        }
                        else {
                            const variantPrefix = arg0.substring(0, separatorIndex);
                            const variantPrefixCode = (0, base_types_impl_1.variantFromString)(variantPrefix);
                            if (variantPrefixCode < 0) {
                                throw new exception_1.InvalidFEN(arg0, i18n_1.i18n.INVALID_VARIANT_PREFIX, variantPrefix);
                            }
                            this._impl = (0, fen_1.parseFEN)(variantPrefixCode, arg0.substring(separatorIndex + 1), false).position;
                        }
                    }
                    else {
                        throw new exception_1.IllegalArgument('Position()');
                    }
                }
                break;
            }
            // Possible overloads with 2 arguments:
            //  - (GameVariant, 'start') (valid only for variants with a canonical starting position)
            //  - (GameVariant, 'empty')
            //  - (GameVariant, scharnaglCode) (valid only for Chess960)
            //  - (GameVariant, FEN)
            default: {
                const variantCode = (0, base_types_impl_1.variantFromString)(arg0);
                if (variantCode < 0) {
                    throw new exception_1.IllegalArgument('Position()');
                }
                if (arg1 === 'start') {
                    if (!(0, impl_1.hasCanonicalStartPosition)(variantCode)) {
                        throw new exception_1.IllegalArgument('Position()');
                    }
                    this._impl = (0, impl_1.makeInitial)(variantCode);
                }
                else if (arg1 === 'empty') {
                    this._impl = (0, impl_1.makeEmpty)(variantCode);
                }
                else if (typeof arg1 === 'number') {
                    if (variantCode !== 1 /* GameVariantImpl.CHESS960 */ || !isValidScharnaglCode(arg1)) {
                        throw new exception_1.IllegalArgument('Position()');
                    }
                    this._impl = (0, impl_1.make960FromScharnagl)(arg1);
                }
                else if (typeof arg1 === 'string') {
                    this._impl = (0, fen_1.parseFEN)(variantCode, arg1, false).position;
                }
                else {
                    throw new exception_1.IllegalArgument('Position()');
                }
                break;
            }
        }
    }
    /**
     * Set the position to the empty state, for the given chess game variant.
     */
    clear(variant = 'regular') {
        const variantCode = (0, base_types_impl_1.variantFromString)(variant);
        if (variantCode < 0) {
            throw new exception_1.IllegalArgument('Position.clear()');
        }
        this._impl = (0, impl_1.makeEmpty)(variantCode);
    }
    /**
     * Set the position to the starting state (in the regular chess variant).
     */
    reset() {
        this._impl = (0, impl_1.makeInitial)(0 /* GameVariantImpl.REGULAR_CHESS */);
    }
    /**
     * Set the position to Chess960 starting position corresponding to the given Scharnagl code.
     *
     * @param scharnaglCode - Must be between 0 and 959 inclusive (see https://chess960.net/start-positions/
     *                        or https://www.chessprogramming.org/Reinhard_Scharnagl for more details).
     */
    reset960(scharnaglCode) {
        if (!isValidScharnaglCode(scharnaglCode)) {
            throw new exception_1.IllegalArgument('Position.reset960()');
        }
        this._impl = (0, impl_1.make960FromScharnagl)(scharnaglCode);
    }
    /**
     * Set the position to the starting state of the antichess variant.
     */
    resetAntichess() {
        this._impl = (0, impl_1.makeInitial)(5 /* GameVariantImpl.ANTICHESS */);
    }
    /**
     * Set the position to the starting state of the horde chess variant.
     */
    resetHorde() {
        this._impl = (0, impl_1.makeInitial)(6 /* GameVariantImpl.HORDE */);
    }
    /**
     * Check whether both given objects represent the same chess position (i.e. the same chess variant, same board,
     * and same turn/castling/en-passant flags).
     */
    static isEqual(pos1, pos2) {
        return pos1 instanceof Position && pos2 instanceof Position && (0, legality_1.isEqual)(pos1._impl, pos2._impl);
    }
    // -------------------------------------------------------------------------
    // FEN & ASCII conversion
    // -------------------------------------------------------------------------
    /**
     * Return a human-readable string representing the position. This string is multi-line,
     * and is intended to be displayed in a fixed-width font (similarly to an ASCII-art picture).
     * For instance:
     *
     * ```
     * const position = new Position();
     * console.log(position.ascii());
     *
     * // +---+---+---+---+---+---+---+---+
     * // | r | n | b | q | k | b | n | r |
     * // +---+---+---+---+---+---+---+---+
     * // | p | p | p | p | p | p | p | p |
     * // +---+---+---+---+---+---+---+---+
     * // |   |   |   |   |   |   |   |   |
     * // +---+---+---+---+---+---+---+---+
     * // |   |   |   |   |   |   |   |   |
     * // +---+---+---+---+---+---+---+---+
     * // |   |   |   |   |   |   |   |   |
     * // +---+---+---+---+---+---+---+---+
     * // |   |   |   |   |   |   |   |   |
     * // +---+---+---+---+---+---+---+---+
     * // | P | P | P | P | P | P | P | P |
     * // +---+---+---+---+---+---+---+---+
     * // | R | N | B | Q | K | B | N | R |
     * // +---+---+---+---+---+---+---+---+
     * // w KQkq -
     * ```
     */
    ascii() {
        return (0, fen_1.ascii)(this._impl);
    }
    fen(fenOrOptions, strict) {
        // Getter, without options.
        if (arguments.length === 0) {
            return (0, fen_1.getFEN)(this._impl);
        }
        // Getter, with options.
        else if (arguments.length === 1 && typeof fenOrOptions === 'object') {
            const validate = buildValidator(fenOrOptions, 'Position.fen()');
            const fiftyMoveClock = validate('fiftyMoveClock', 0, val => Number.isInteger(val));
            const fullMoveNumber = validate('fullMoveNumber', 1, val => Number.isInteger(val));
            const withVariant = validate('withVariant', false, val => typeof val === 'boolean');
            const regularFENIfPossible = validate('regularFENIfPossible', false, val => typeof val === 'boolean');
            return (withVariant ? (0, base_types_impl_1.variantToString)(this._impl.variant) + ':' : '') + (0, fen_1.getFEN)(this._impl, fiftyMoveClock, fullMoveNumber, regularFENIfPossible);
        }
        // Setter, without strict option.
        else if (arguments.length === 1 && typeof fenOrOptions === 'string') {
            const result = (0, fen_1.parseFEN)(this._impl.variant, fenOrOptions, false);
            this._impl = result.position;
            return { fiftyMoveClock: result.fiftyMoveClock, fullMoveNumber: result.fullMoveNumber };
        }
        // Setter, with strict option.
        else if (arguments.length >= 2 && typeof fenOrOptions === 'string' && typeof strict === 'boolean') {
            const result = (0, fen_1.parseFEN)(this._impl.variant, fenOrOptions, strict);
            this._impl = result.position;
            return { fiftyMoveClock: result.fiftyMoveClock, fullMoveNumber: result.fullMoveNumber };
        }
        // Unsupported overload.
        else {
            throw new exception_1.IllegalArgument('Position.fen()');
        }
    }
    // -------------------------------------------------------------------------
    // Accessors
    // -------------------------------------------------------------------------
    /**
     * Get the chess game variant in use.
     */
    variant() {
        return (0, base_types_impl_1.variantToString)(this._impl.variant);
    }
    square(square, value) {
        const squareCode = (0, base_types_impl_1.squareFromString)(square);
        if (squareCode < 0) {
            throw new exception_1.IllegalArgument('Position.square()');
        }
        if (arguments.length === 1) {
            const cp = this._impl.board[squareCode];
            return cp === -1 /* SpI.EMPTY */ ? '-' : (0, base_types_impl_1.coloredPieceToString)(cp);
        }
        else if (value === '-') {
            this._impl.board[squareCode] = -1 /* SpI.EMPTY */;
            this._impl.legal = null;
            this._impl.effectiveCastling = null;
            this._impl.effectiveEnPassant = null;
        }
        else {
            const cp = (0, base_types_impl_1.coloredPieceFromString)(value);
            if (cp < 0) {
                throw new exception_1.IllegalArgument('Position.square()');
            }
            this._impl.board[squareCode] = cp;
            this._impl.legal = null;
            this._impl.effectiveCastling = null;
            this._impl.effectiveEnPassant = null;
        }
    }
    turn(value) {
        if (arguments.length === 0) {
            return (0, base_types_impl_1.colorToString)(this._impl.turn);
        }
        else {
            const colorCode = (0, base_types_impl_1.colorFromString)(value);
            if (colorCode < 0) {
                throw new exception_1.IllegalArgument('Position.turn()');
            }
            this._impl.turn = colorCode;
            this._impl.legal = null;
            this._impl.effectiveEnPassant = null;
        }
    }
    castling(castle, value) {
        if (!(this._impl.variant === 1 /* GameVariantImpl.CHESS960 */ ? (0, helper_1.isCastle960)(castle) : (0, helper_1.isCastle)(castle))) {
            throw new exception_1.IllegalArgument('Position.castling()');
        }
        const color = (0, base_types_impl_1.colorFromString)(castle[0]);
        const file = this._impl.variant === 1 /* GameVariantImpl.CHESS960 */ ? (0, base_types_impl_1.fileFromString)(castle[1]) : castle[1] === 'k' ? 7 : 0;
        if (arguments.length === 1) {
            return (this._impl.castling[color] & 1 << file) !== 0;
        }
        else if (typeof value === 'boolean') {
            if (value) {
                this._impl.castling[color] |= 1 << file;
            }
            else {
                this._impl.castling[color] &= ~(1 << file);
            }
            this._impl.effectiveCastling = null;
        }
        else {
            throw new exception_1.IllegalArgument('Position.castling()');
        }
    }
    /**
     * Get a validated (aka. effective) castle flag (i.e. whether or not the corresponding castle is allowed or not).
     *
     * Compared to {@link Position.castling}, if this method returns `true`, then it is guaranteed that there are a king and a rook on the squares
     * corresponding to the given castle.
     *
     * @param castle - Must be {@link Castle960} if the {@link Position} is configured for Chess960, or {@link Castle} otherwise.
     */
    effectiveCastling(castle) {
        if (!(this._impl.variant === 1 /* GameVariantImpl.CHESS960 */ ? (0, helper_1.isCastle960)(castle) : (0, helper_1.isCastle)(castle))) {
            throw new exception_1.IllegalArgument('Position.effectiveCastling()');
        }
        const color = (0, base_types_impl_1.colorFromString)(castle[0]);
        const file = this._impl.variant === 1 /* GameVariantImpl.CHESS960 */ ? (0, base_types_impl_1.fileFromString)(castle[1]) : castle[1] === 'k' ? 7 : 0;
        (0, legality_1.refreshEffectiveCastling)(this._impl);
        return (this._impl.effectiveCastling[color] & 1 << file) !== 0;
    }
    enPassant(value) {
        if (arguments.length === 0) {
            return this._impl.enPassant < 0 ? '-' : (0, base_types_impl_1.fileToString)(this._impl.enPassant);
        }
        else if (value === '-') {
            this._impl.enPassant = -1;
            this._impl.effectiveEnPassant = -1;
        }
        else {
            const enPassantCode = (0, base_types_impl_1.fileFromString)(value);
            if (enPassantCode < 0) {
                throw new exception_1.IllegalArgument('Position.enPassant()');
            }
            this._impl.enPassant = enPassantCode;
            this._impl.effectiveEnPassant = null;
        }
    }
    /**
     * Get the effective *en-passant* flag (i.e. the column on which a *en-passant* capture is possible, if any).
     *
     * If {@link Position.enPassant} returns `'-'`, this method returns `'-'`. Otherwise, it returns:
     * - either the same file that is returned by {@link Position.enPassant} if a *en-passant* capture is allowed on this file,
     * - or `'-'` otherwise.
     */
    effectiveEnPassant() {
        (0, legality_1.refreshEffectiveEnPassant)(this._impl);
        return this._impl.effectiveEnPassant < 0 ? '-' : (0, base_types_impl_1.fileToString)(this._impl.effectiveEnPassant);
    }
    // -------------------------------------------------------------------------
    // Attacks
    // -------------------------------------------------------------------------
    /**
     * Check if any piece of the given color attacks the given square.
     */
    isAttacked(square, byWho) {
        const squareCode = (0, base_types_impl_1.squareFromString)(square);
        const byWhoCode = (0, base_types_impl_1.colorFromString)(byWho);
        if (squareCode < 0 || byWhoCode < 0) {
            throw new exception_1.IllegalArgument('Position.isAttacked()');
        }
        return (0, attacks_1.isAttacked)(this._impl, squareCode, byWhoCode);
    }
    /**
     * Return the squares from which a piece of the given color attacks the given square.
     */
    getAttacks(square, byWho) {
        const squareCode = (0, base_types_impl_1.squareFromString)(square);
        const byWhoCode = (0, base_types_impl_1.colorFromString)(byWho);
        if (squareCode < 0 || byWhoCode < 0) {
            throw new exception_1.IllegalArgument('Position.getAttacks()');
        }
        return (0, attacks_1.getAttacks)(this._impl, squareCode, byWhoCode).map(base_types_impl_1.squareToString);
    }
    // -------------------------------------------------------------------------
    // Legality
    // -------------------------------------------------------------------------
    /**
     * Check whether the current position is legal or not.
     *
     * A position is considered to be legal if all the following conditions are met:
     *
     * 1. There is exactly one white king and one black king on the board (or more generally,
     *    the number of kings on the board matches what is expected in the game variant of the position).
     * 2. The player that is not about to play is not in check (this condition is omitted for variants
     *    in which kings have no royal power).
     * 3. There are no pawn on ranks 1 and 8 (except if the game variant of the position allows it).
     */
    isLegal() {
        return (0, legality_1.isLegal)(this._impl);
    }
    /**
     * Return the square on which is located the king of the given color. If there is no such king on the board
     * (or on the contrary, if there are two or more such kings on the board), `false` is returned.
     *
     * For non-standard variants, the behavior of this method depends on whether king has royal power in the current variant or not
     * (i.e. whether it can be put in check or not). For instance:
     * - in antichess, the king has no royal power, thus `false` is always returned,
     * - in Chess960, the king has royal power (as in the usual chess rules), thus the method returns the square on which the king is located.
     */
    kingSquare(color) {
        const colorCode = (0, base_types_impl_1.colorFromString)(color);
        if (colorCode < 0) {
            throw new exception_1.IllegalArgument('Position.kingSquare()');
        }
        (0, legality_1.refreshLegalFlagAndKingSquares)(this._impl);
        const squareCode = this._impl.king[colorCode];
        return squareCode < 0 ? false : (0, base_types_impl_1.squareToString)(squareCode);
    }
    // -------------------------------------------------------------------------
    // Move generation
    // -------------------------------------------------------------------------
    /**
     * Whether the player that is about to play is in check or not. If the position is not legal (see {@link Position.isLegal}),
     * the returned value is always `false`.
     *
     * For antichess, this method always returns `false`.
     */
    isCheck() {
        return (0, move_generation_1.isCheck)(this._impl);
    }
    /**
     * Whether the player that is about to play is checkmated or not. If the position is not legal (see {@link Position.isLegal}),
     * the returned value is always `false`.
     *
     * For antichess, this method returns `true` if the player about to play has no remaining piece or pawn,
     * or if non of his/her remaining pieces can move (i.e. same behavior as {@link Position.isStalemate} for this variant).
     *
     * For horde chess, this method returns `true` if black has been checkmated or if white has no remaining piece.
     */
    isCheckmate() {
        return (0, move_generation_1.isCheckmate)(this._impl);
    }
    /**
     * Whether the player that is about to play is stalemated or not. If the position is not legal (see {@link Position.isLegal}),
     * the returned value is always `false`.
     *
     * For antichess, this method returns `true` if the player about to play has no remaining piece or pawn,
     * or if non of his/her remaining pieces can move (i.e. same behavior as {@link Position.isCheckmate} for this variant).
     *
     * For horde chess, this method returns `true` if black has been stalemated or if white cannot move but has still at least one piece.
     */
    isStalemate() {
        return (0, move_generation_1.isStalemate)(this._impl);
    }
    /**
     * Whether both players have insufficient material so the game cannot end in checkmate ([dead position rule](https://en.wikipedia.org/wiki/Rules_of_chess#Dead_position)).
     * If the position is not legal (see {@link Position.isLegal}), the returned value is always `false`.
     *
     * By default, the method uses the FIDE rules, i.e. the position is considered as dead if there is no possible checkmate, even if both players
     * cooperate for that. This is different from the USCF rules, for which the position is considered as dead if no player can force the other into
     * a checkmate. For instance, king + two knights vs king is NOT considered as dead according to the FIDE rules, whereas it is according to the
     * USCF rules.
     *
     * For antichess and horde chess, this method always returns `false` since it is always possible to end in a checkmate-like situation
     * (by capturing all the pieces of one player).
     *
     * @param uscfRules - `true` to use the USCF rules (forced checkmate), `false` to use the FIDE rules (possible checkmate).
     */
    isDead(uscfRules = false) {
        return (0, move_generation_1.isDead)(this._impl, uscfRules);
    }
    /**
     * Whether at least one legal move exists in the current position or not. If the position is not legal (see {@link Position.isLegal}),
     * the returned value is always `false`.
     */
    hasMove() {
        return (0, move_generation_1.hasMove)(this._impl);
    }
    /**
     * Return the list of all legal moves in the current position. An empty list is returned if the position itself is not legal
     * (see {@link Position.isLegal}).
     */
    moves() {
        return (0, move_generation_1.moves)(this._impl);
    }
    /**
     * Check whether a move is legal or not, and return a factory capable the corresponding {@link MoveDescriptor}(-s) if it is legal.
     *
     * For castling moves, `to` is supposed to represent:
     * - for regular chess, the destination square of the king (i.e. c1, g1, c8 or g8),
     * - for Chess960, the origin square of the rook ("king-take-rook" pattern).
     *
     * A code interpreting the result returned by {@link Position.isMoveLegal} would typically look like this:
     *
     * ```
     * const result = position.isMoveLegal(from, to);
     * if (!result) {
     *   // The move "from -> to" is not legal.
     * }
     * else {
     *   switch (result.status) {
     *
     *     case 'regular':
     *       // The move "from -> to" is legal, and the corresponding move descriptor
     *       // is `result()`.
     *       break;
     *
     *     case 'promotion':
     *       // The move "from -> to" is legal, but it corresponds to a promotion,
     *       // so the promoted piece must be specified. The corresponding move descriptors
     *       // are `result('q')`, `result('r')`, `result('b')` and `result('n')`.
     *       break;
     *
     *     default:
     *       // This case is not supposed to happen.
     *       break;
     *   }
     * }
     * ```
     */
    isMoveLegal(from, to) {
        const fromCode = (0, base_types_impl_1.squareFromString)(from);
        const toCode = (0, base_types_impl_1.squareFromString)(to);
        if (fromCode < 0 || toCode < 0) {
            throw new exception_1.IllegalArgument('Position.isMoveLegal()');
        }
        const moveInfo = (0, move_generation_1.isMoveLegal)(this._impl, fromCode, toCode);
        // No legal move.
        if (!moveInfo) {
            return false;
        }
        switch (moveInfo.type) {
            case 'promotion': {
                const result = (promotion) => {
                    const promotionCode = (0, base_types_impl_1.pieceFromString)(promotion);
                    if (promotionCode >= 0) {
                        const moveDescriptor = moveInfo.moveDescriptorFactory(promotionCode);
                        if (moveDescriptor) {
                            return moveDescriptor;
                        }
                    }
                    throw new exception_1.IllegalArgument('Position.isMoveLegal()');
                };
                result.status = 'promotion';
                return result;
            }
            case 'regular': {
                const result = () => moveInfo.moveDescriptor;
                result.status = 'regular';
                return result;
            }
        }
    }
    play(move) {
        if (typeof move === 'string') {
            try {
                (0, move_generation_1.play)(this._impl, (0, notation_1.parseNotation)(this._impl, move, false, 'standard'));
                return true;
            }
            catch (err) {
                // istanbul ignore else
                if (err instanceof exception_1.InvalidNotation) {
                    return false;
                }
                else {
                    throw err;
                }
            }
        }
        else if (move instanceof move_descriptor_impl_1.MoveDescriptorImpl) {
            (0, move_generation_1.play)(this._impl, move);
            return true;
        }
        else {
            throw new exception_1.IllegalArgument('Position.play()');
        }
    }
    /**
     * Whether a null-move (i.e. switching the player about to play) can be played in the current position or not.
     *
     * A null-move is possible if the position is legal and if the current player about to play is not in check.
     */
    isNullMoveLegal() {
        return (0, move_generation_1.isNullMoveLegal)(this._impl);
    }
    /**
     * Play a null-move on the current position if it is legal.
     *
     * @returns `true` if the move has actually been played, `false` otherwise.
     */
    playNullMove() {
        return (0, move_generation_1.playNullMove)(this._impl);
    }
    notation(moveOrDescriptor, strict) {
        if (arguments.length === 1 && moveOrDescriptor instanceof move_descriptor_impl_1.MoveDescriptorImpl) {
            return (0, notation_1.getNotation)(this._impl, moveOrDescriptor, 'standard');
        }
        else if (arguments.length === 1 && typeof moveOrDescriptor === 'string') {
            return (0, notation_1.parseNotation)(this._impl, moveOrDescriptor, false, 'standard');
        }
        else if (arguments.length >= 2 && typeof moveOrDescriptor === 'string' && typeof strict === 'boolean') {
            return (0, notation_1.parseNotation)(this._impl, moveOrDescriptor, strict, 'standard');
        }
        else {
            throw new exception_1.IllegalArgument('Position.notation()');
        }
    }
    figurineNotation(moveOrDescriptor, strict) {
        if (arguments.length === 1 && moveOrDescriptor instanceof move_descriptor_impl_1.MoveDescriptorImpl) {
            return (0, notation_1.getNotation)(this._impl, moveOrDescriptor, 'figurine');
        }
        else if (arguments.length === 1 && typeof moveOrDescriptor === 'string') {
            return (0, notation_1.parseNotation)(this._impl, moveOrDescriptor, false, 'figurine');
        }
        else if (arguments.length >= 2 && typeof moveOrDescriptor === 'string' && typeof strict === 'boolean') {
            return (0, notation_1.parseNotation)(this._impl, moveOrDescriptor, strict, 'figurine');
        }
        else {
            throw new exception_1.IllegalArgument('Position.figurineNotation()');
        }
    }
    uci(moveOrDescriptor, strictOrForceKxR) {
        if (arguments.length === 1 && moveOrDescriptor instanceof move_descriptor_impl_1.MoveDescriptorImpl) {
            return (0, uci_1.getUCINotation)(this._impl, moveOrDescriptor, false);
        }
        else if (arguments.length >= 2 && moveOrDescriptor instanceof move_descriptor_impl_1.MoveDescriptorImpl && typeof strictOrForceKxR === 'boolean') {
            return (0, uci_1.getUCINotation)(this._impl, moveOrDescriptor, strictOrForceKxR);
        }
        else if (arguments.length === 1 && typeof moveOrDescriptor === 'string') {
            return (0, uci_1.parseUCINotation)(this._impl, moveOrDescriptor, false);
        }
        else if (arguments.length >= 2 && typeof moveOrDescriptor === 'string' && typeof strictOrForceKxR === 'boolean') {
            return (0, uci_1.parseUCINotation)(this._impl, moveOrDescriptor, strictOrForceKxR);
        }
        else {
            throw new exception_1.IllegalArgument('Position.uci()');
        }
    }
}
exports.Position = Position;
function isValidScharnaglCode(scharnaglCode) {
    return Number.isInteger(scharnaglCode) && scharnaglCode >= 0 && scharnaglCode < 960;
}
function buildValidator(options, functionName) {
    return function (key, defaultValue, validator) {
        if (options[key] === undefined) {
            return defaultValue;
        }
        else {
            const value = options[key];
            if (!validator(value)) {
                throw new exception_1.IllegalArgument(functionName);
            }
            return value;
        }
    };
}

},{"./exception":3,"./helper":5,"./i18n":6,"./private_position/attacks":18,"./private_position/base_types_impl":19,"./private_position/fen":20,"./private_position/impl":21,"./private_position/legality":22,"./private_position/move_descriptor_impl":23,"./private_position/move_generation":24,"./private_position/notation":25,"./private_position/uci":26}],12:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidRound = exports.isValidElo = exports.isValidNag = exports.trimAndCollapseSpaces = void 0;
/**
 * Trim the given string, and replace all the sub-sequence of 1 or several space-like characters by a single space.
 */
function trimAndCollapseSpaces(text) {
    return text.replace(/^\s+|\s+$/g, '').replace(/\s+/g, ' ');
}
exports.trimAndCollapseSpaces = trimAndCollapseSpaces;
/**
 * Whether the given value is a valid NAG or not.
 */
function isValidNag(nag) {
    return Number.isInteger(nag) && nag >= 0;
}
exports.isValidNag = isValidNag;
/**
 * Whether the given value is a valid NAG or not.
 */
function isValidElo(elo) {
    return Number.isInteger(elo) && elo >= 0;
}
exports.isValidElo = isValidElo;
/**
 * Whether the given value is a valid round (or sub-round, or sub-sub-round...) or not.
 */
function isValidRound(round) {
    return Number.isInteger(round) && round >= 0;
}
exports.isValidRound = isValidRound;

},{}],13:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MoveTreeRoot = void 0;
const exception_1 = require("../exception");
const helper_1 = require("../helper");
const i18n_1 = require("../i18n");
const node_variation_1 = require("../node_variation");
const position_1 = require("../position");
const common_1 = require("./common");
const pojo_util_1 = require("./pojo_util");
const base_types_impl_1 = require("../private_position/base_types_impl");
/**
 * Container for the data at the root of the `NodeData` / `VariationData` tree.
 */
class MoveTreeRoot {
    constructor() {
        this._position = new position_1.Position();
        this._fullMoveNumber = 1;
        this._mainVariationData = createVariationData(this, true);
    }
    clearTree() {
        this._mainVariationData = createVariationData(this, true);
    }
    mainVariation() {
        return new VariationImpl(this._mainVariationData, this._position);
    }
    findById(id, allowAliases) {
        const tokens = id.split('-');
        if (tokens.length % 2 !== 1) {
            return undefined;
        }
        const position = new position_1.Position(this._position);
        // Find the parent variation of the target node.
        let variationData = this._mainVariationData;
        for (let i = 0; i + 1 < tokens.length; i += 2) {
            const nodeData = findNode(variationData, tokens[i], position);
            if (nodeData === undefined) {
                return undefined;
            }
            const match = /^v(\d+)$/.exec(tokens[i + 1]);
            if (!match) {
                return undefined;
            }
            const variationIndex = parseInt(match[1]);
            if (variationIndex >= nodeData.variations.length) {
                return undefined;
            }
            variationData = nodeData.variations[variationIndex];
        }
        // Find the target node within its parent variation, or return the variation itself
        // if the ID is a variation ID (i.e. if it ends with 'start').
        const lastToken = tokens[tokens.length - 1];
        if (lastToken === 'start') {
            return new VariationImpl(variationData, position);
        }
        else if (allowAliases && lastToken === 'end') {
            if (variationData.child === undefined) {
                return new VariationImpl(variationData, position);
            }
            else {
                let nodeData = variationData.child;
                while (nodeData.child !== undefined) {
                    applyMoveDescriptor(position, nodeData);
                    nodeData = nodeData.child;
                }
                return new NodeImpl(nodeData, position);
            }
        }
        else {
            const nodeData = findNode(variationData, lastToken, position);
            return nodeData === undefined ? undefined : new NodeImpl(nodeData, position);
        }
    }
    getPojo(pojo) {
        // Encode the game variant and initial position, if necessary.
        const variant = this._position.variant();
        if (variant !== 'regular') {
            pojo.variant = variant;
        }
        const isCanonicalStartPosition = (0, helper_1.variantWithCanonicalStartPosition)(variant) && position_1.Position.isEqual(this._position, new position_1.Position(variant)) && this._fullMoveNumber === 1;
        if (!isCanonicalStartPosition) {
            pojo.initialPosition = this._position.fen({ fullMoveNumber: this._fullMoveNumber });
        }
        // Encode the moves.
        const mainVariationPOJO = getVariationPOJO(new position_1.Position(this._position), this._mainVariationData, true);
        if (!Array.isArray(mainVariationPOJO) || mainVariationPOJO.length > 0) {
            pojo.mainVariation = mainVariationPOJO;
        }
    }
    setPojo(pojo, exceptionBuilder) {
        // Decode the game variant and initial position, if any.
        let variant = 'regular';
        let initialPositionDefined = false;
        (0, pojo_util_1.decodeStringField)(pojo, 'variant', exceptionBuilder, value => {
            if ((0, base_types_impl_1.variantFromString)(value) < 0) {
                throw exceptionBuilder.build(i18n_1.i18n.INVALID_VARIANT_IN_POJO);
            }
            variant = value;
        });
        (0, pojo_util_1.decodeStringField)(pojo, 'initialPosition', exceptionBuilder, value => {
            this._position = new position_1.Position(variant, 'empty');
            try {
                const { fullMoveNumber } = this._position.fen(value);
                this._fullMoveNumber = fullMoveNumber;
                initialPositionDefined = true;
            }
            catch (error) {
                // istanbul ignore else
                if (error instanceof exception_1.InvalidFEN) {
                    throw exceptionBuilder.build(i18n_1.i18n.INVALID_FEN_IN_POJO, error.message);
                }
                else {
                    throw error;
                }
            }
        });
        if (variant !== 'regular' && !initialPositionDefined) {
            if (!(0, helper_1.variantWithCanonicalStartPosition)(variant)) {
                exceptionBuilder.push('initialPosition'); // no-pop
                throw exceptionBuilder.build(i18n_1.i18n.MISSING_INITIAL_POSITION_IN_POJO, variant);
            }
            this._position = new position_1.Position(variant);
            this._fullMoveNumber = 1;
        }
        // Decode the moves.
        if ('mainVariation' in pojo && pojo.mainVariation !== undefined) {
            exceptionBuilder.push('mainVariation');
            this._mainVariationData = setVariationPOJO(pojo.mainVariation, this, this._position, 0, this._fullMoveNumber, true, exceptionBuilder);
            exceptionBuilder.pop();
        }
        else {
            this.clearTree();
        }
    }
}
exports.MoveTreeRoot = MoveTreeRoot;
function findNode(variationData, nodeIdToken, position) {
    let nodeData = variationData.child;
    while (nodeData !== undefined) {
        if (nodeIdToken === nodeData.fullMoveNumber + nodeData.moveColor) {
            return nodeData;
        }
        applyMoveDescriptor(position, nodeData);
        nodeData = nodeData.child;
    }
    return undefined;
}
function getVariationPOJO(position, variationData, isLongVariationByDefault) {
    const nodePOJOs = [];
    let nodeData = variationData.child;
    while (nodeData !== undefined) {
        nodePOJOs.push(getNodePOJO(position, nodeData));
        applyMoveDescriptor(position, nodeData);
        nodeData = nodeData.child;
    }
    const pojo = {
        nodes: nodePOJOs,
    };
    let pojoIsTrivial = true;
    if (variationData.isLongVariation !== isLongVariationByDefault) {
        pojo.isLongVariation = variationData.isLongVariation;
        pojoIsTrivial = false;
    }
    if (appendAnnotationFields(pojo, variationData)) {
        pojoIsTrivial = false;
    }
    return pojoIsTrivial ? pojo.nodes : pojo;
}
function getNodePOJO(position, nodeData) {
    const pojo = {
        notation: nodeData.moveDescriptor === null ? '--' : position.notation(nodeData.moveDescriptor),
    };
    let pojoIsTrivial = true;
    if (nodeData.variations.length > 0) {
        pojo.variations = nodeData.variations.map(variation => getVariationPOJO(new position_1.Position(position), variation, false));
        pojoIsTrivial = false;
    }
    if (appendAnnotationFields(pojo, nodeData)) {
        pojoIsTrivial = false;
    }
    return pojoIsTrivial ? pojo.notation : pojo;
}
function appendAnnotationFields(pojo, data) {
    let atLeastOneAnnotation = false;
    if (data.comment !== undefined) {
        pojo.comment = data.comment;
        if (data.isLongComment) {
            pojo.isLongComment = true;
        }
        atLeastOneAnnotation = true;
    }
    if (data.nags.size > 0) {
        pojo.nags = getNags(data);
        atLeastOneAnnotation = true;
    }
    if (data.tags.size > 0) {
        pojo.tags = getTagRecords(data);
        atLeastOneAnnotation = true;
    }
    return atLeastOneAnnotation;
}
function setVariationPOJO(variationPOJO, parent, position, fiftyMoveClock, fullMoveNumber, isLongVariationByDefault, exceptionBuilder) {
    let result;
    let nodes;
    // Initialize the VariationData object.
    if (Array.isArray(variationPOJO)) {
        result = createVariationData(parent, isLongVariationByDefault);
        nodes = variationPOJO;
    }
    else if (typeof variationPOJO === 'object' && variationPOJO !== null) {
        // Decode everything but the nodes.
        let longVariation = isLongVariationByDefault;
        (0, pojo_util_1.decodeBooleanField)(variationPOJO, 'isLongVariation', exceptionBuilder, value => { longVariation = value; });
        result = createVariationData(parent, longVariation);
        decodeAnnotationFields(variationPOJO, result, exceptionBuilder);
        // Decode the node array.
        exceptionBuilder.push('nodes');
        if (!('nodes' in variationPOJO) || !Array.isArray(variationPOJO.nodes)) {
            throw exceptionBuilder.build(i18n_1.i18n.INVALID_OR_MISSING_NODE_ARRAY);
        }
        nodes = variationPOJO.nodes;
    }
    else {
        throw exceptionBuilder.build(i18n_1.i18n.NOT_A_VARIATION_POJO);
    }
    // Decode the nodes.
    let insertionPoint = result;
    position = new position_1.Position(position);
    for (let i = 0; i < nodes.length; ++i) {
        exceptionBuilder.push(i);
        insertionPoint.child = setNodePOJO(nodes[i], result, position, fiftyMoveClock, fullMoveNumber, exceptionBuilder);
        exceptionBuilder.pop();
        insertionPoint = insertionPoint.child;
        applyMoveDescriptor(position, insertionPoint);
        fiftyMoveClock = computeNextFiftyMoveClock(insertionPoint);
        if (position.turn() === 'w') {
            ++fullMoveNumber;
        }
    }
    // Un-push the "nodes" path component if necessary.
    if (!Array.isArray(variationPOJO)) {
        exceptionBuilder.pop();
    }
    return result;
}
function setNodePOJO(nodePOJO, parentVariation, position, fiftyMoveClock, fullMoveNumber, exceptionBuilder) {
    // Decode the notation.
    let moveDescriptor;
    if (typeof nodePOJO === 'string') {
        moveDescriptor = decodeMoveDescriptorField(position, nodePOJO, exceptionBuilder);
    }
    else if (typeof nodePOJO === 'object' && nodePOJO !== null) {
        exceptionBuilder.push('notation');
        if (!('notation' in nodePOJO) || typeof nodePOJO.notation !== 'string') {
            throw exceptionBuilder.build(i18n_1.i18n.INVALID_OR_MISSING_NOTATION_FIELD);
        }
        moveDescriptor = decodeMoveDescriptorField(position, nodePOJO.notation, exceptionBuilder);
        exceptionBuilder.pop();
    }
    else {
        throw exceptionBuilder.build(i18n_1.i18n.NOT_A_NODE_POJO);
    }
    const result = createNodeData(parentVariation, position.turn(), fiftyMoveClock, fullMoveNumber, moveDescriptor);
    if (typeof nodePOJO === 'object' && nodePOJO !== null) {
        // Decode the annotations.
        decodeAnnotationFields(nodePOJO, result, exceptionBuilder);
        // Decode the variations.
        (0, pojo_util_1.decodeArrayField)(nodePOJO, 'variations', exceptionBuilder, value => {
            for (let i = 0; i < value.length; ++i) {
                exceptionBuilder.push(i);
                result.variations.push(setVariationPOJO(value[i], result, position, fiftyMoveClock, fullMoveNumber, false, exceptionBuilder));
                exceptionBuilder.pop();
            }
        });
    }
    return result;
}
function decodeMoveDescriptorField(position, move, exceptionBuilder) {
    try {
        return computeMoveDescriptor(position, move);
    }
    catch (error) {
        // istanbul ignore else
        if (error instanceof exception_1.InvalidNotation) {
            throw exceptionBuilder.build(i18n_1.i18n.INVALID_MOVE_IN_POJO, move, error.message);
        }
        else {
            throw error;
        }
    }
}
function decodeAnnotationFields(abstractNodePOJO, data, exceptionBuilder) {
    (0, pojo_util_1.decodeStringField)(abstractNodePOJO, 'comment', exceptionBuilder, value => { data.comment = value; });
    (0, pojo_util_1.decodeBooleanField)(abstractNodePOJO, 'isLongComment', exceptionBuilder, value => { data.isLongComment = value; });
    (0, pojo_util_1.decodeArrayField)(abstractNodePOJO, 'nags', exceptionBuilder, value => {
        for (let i = 0; i < value.length; ++i) {
            const nag = value[i];
            if (nag === undefined) {
                continue;
            }
            else if (!(0, common_1.isValidNag)(nag)) {
                exceptionBuilder.push(i); // no-pop
                throw exceptionBuilder.build(i18n_1.i18n.INVALID_NAG_IN_POJO, nag);
            }
            data.nags.add(nag);
        }
    });
    (0, pojo_util_1.decodeObjectField)(abstractNodePOJO, 'tags', exceptionBuilder, value => {
        for (const tagKey in value) {
            if (!isValidTagKey(tagKey)) {
                exceptionBuilder.push(`[${tagKey}]`); // no-pop
                throw exceptionBuilder.build(i18n_1.i18n.INVALID_TAG_IN_POJO, tagKey);
            }
            const tagValue = value[tagKey];
            if (tagValue === undefined) {
                continue;
            }
            else if (typeof tagValue !== 'string') {
                exceptionBuilder.push(tagKey); // no-pop
                throw exceptionBuilder.build(i18n_1.i18n.INVALID_TAG_IN_POJO, tagKey);
            }
            data.tags.set(tagKey, tagValue);
        }
    });
}
function createNodeData(parentVariation, moveColor, fiftyMoveClock, fullMoveNumber, moveDescriptor) {
    return {
        parentVariation: parentVariation,
        child: undefined,
        variations: [],
        moveColor: moveColor,
        fiftyMoveClock: fiftyMoveClock,
        fullMoveNumber: fullMoveNumber,
        moveDescriptor: moveDescriptor,
        nags: new Set(),
        tags: new Map(),
        comment: undefined,
        isLongComment: false,
    };
}
function createVariationData(parent, longVariation) {
    return {
        parent: parent,
        child: undefined,
        isLongVariation: longVariation,
        nags: new Set(),
        tags: new Map(),
        comment: undefined,
        isLongComment: false,
    };
}
/**
 * Compute the move descriptor associated to the given SAN notation, assuming the given position.
 */
function computeMoveDescriptor(position, move) {
    if (move === '--') {
        if (!position.isNullMoveLegal()) {
            throw new exception_1.InvalidNotation(position.fen(), '--', i18n_1.i18n.ILLEGAL_NULL_MOVE);
        }
        return null;
    }
    else {
        return position.notation(move);
    }
}
/**
 * Play the move descriptor encoded in the given node data structure, or play null-move if no move descriptor is defined.
 */
function applyMoveDescriptor(position, nodeData) {
    if (nodeData.moveDescriptor === null) {
        position.playNullMove();
    }
    else {
        position.play(nodeData.moveDescriptor);
    }
}
/**
 * Compute the new value of the fifty-move clock after the move described by the given node data structure.
 */
function computeNextFiftyMoveClock(nodeData) {
    if (nodeData.moveDescriptor === null) {
        return nodeData.fiftyMoveClock;
    }
    else if (nodeData.moveDescriptor.isCapture() || nodeData.moveDescriptor.movingPiece() === 'p') {
        return 0;
    }
    else {
        return nodeData.fiftyMoveClock + 1;
    }
}
/**
 * Compute the new value of the full-move number after the move described by the given node data structure.
 */
function computeNextFullMoveNumber(nodeData) {
    return nodeData.moveColor === 'w' ? nodeData.fullMoveNumber : nodeData.fullMoveNumber + 1;
}
/**
 * Return the initial position of the given variation.
 */
function rebuildVariationPosition(variationData) {
    if (variationData.parent instanceof MoveTreeRoot) {
        return new position_1.Position(variationData.parent._position);
    }
    else {
        let current = variationData.parent.parentVariation.child;
        const position = rebuildVariationPosition(variationData.parent.parentVariation);
        while (current !== variationData.parent) {
            applyMoveDescriptor(position, current);
            current = current.child;
        }
        return position;
    }
}
/**
 * Compute the ID of the given node.
 */
function buildNodeId(nodeData) {
    return buildVariationIdPrefix(nodeData.parentVariation) + nodeData.fullMoveNumber + nodeData.moveColor;
}
/**
 * Compute the ID of the given variation, without the final `'start'` token.
 */
function buildVariationIdPrefix(variationData) {
    if (variationData.parent instanceof MoveTreeRoot) {
        return '';
    }
    else {
        const parentNodeId = buildNodeId(variationData.parent);
        const variationIndex = variationData.parent.variations.indexOf(variationData);
        return `${parentNodeId}-v${variationIndex}-`;
    }
}
/**
 * Whether the variation corresponding to the given descriptor is a "long variation",
 * i.e. whether it is a flagged as "isLongVariation" AND SO ARE ALL IT'S PARENTS.
 */
function isLongVariation(variationData) {
    while (true) {
        if (!variationData.isLongVariation) {
            return false;
        }
        if (variationData.parent instanceof MoveTreeRoot) {
            return true;
        }
        variationData = variationData.parent.parentVariation;
    }
}
/**
 * Whether the given number is a valid variation index for the given node.
 */
function isValidVariationIndex(variationIndex, nodeData) {
    return Number.isInteger(variationIndex) && variationIndex >= 0 && variationIndex < nodeData.variations.length;
}
/**
 * Return all the NAGs of the given abstract node.
 */
function getNags(data) {
    const result = [];
    for (const nag of data.nags) {
        result.push(nag);
    }
    return result.sort((a, b) => a - b);
}
/**
 * Keep only the NAGs that are asserted by the given filter.
 */
function filterNags(data, filter) {
    const result = new Set();
    for (const nag of data.nags) {
        if (filter(nag)) {
            result.add(nag);
        }
    }
    data.nags = result;
}
/**
 * Whether the given valid is a valid tag key or not.
 */
function isValidTagKey(tagKey) {
    return typeof tagKey === 'string' && /^\w+$/.test(tagKey);
}
/**
 * Return all the tag keys of the given abstract node.
 */
function getTagKeys(data) {
    const result = [];
    for (const tag of data.tags.keys()) {
        result.push(tag);
    }
    return result.sort();
}
/**
 * Keep only the tags that are asserted by the given filter.
 */
function filterTags(data, filter) {
    const result = new Map();
    for (const [tagKey, tagValue] of data.tags.entries()) {
        if (filter(tagKey, tagValue)) {
            result.set(tagKey, tagValue);
        }
    }
    data.tags = result;
}
/**
 * Return all the pairs tag key + tag value of the given abstract node.
 */
function getTagRecords(data) {
    const result = {};
    for (const [tagKey, tagValue] of data.tags.entries()) {
        result[tagKey] = tagValue;
    }
    return result;
}
/**
 * Implementation class for `Node`.
 */
class NodeImpl extends node_variation_1.Node {
    constructor(data, positionBefore) {
        super();
        this._data = data;
        this._positionBefore = positionBefore;
    }
    id() {
        return buildNodeId(this._data);
    }
    nags() {
        return getNags(this._data);
    }
    hasNag(nag) {
        if (!(0, common_1.isValidNag)(nag)) {
            throw new exception_1.IllegalArgument('Node.hasNag()');
        }
        return this._data.nags.has(nag);
    }
    addNag(nag) {
        if (!(0, common_1.isValidNag)(nag)) {
            throw new exception_1.IllegalArgument('Node.addNag()');
        }
        return this._data.nags.add(nag);
    }
    removeNag(nag) {
        if (!(0, common_1.isValidNag)(nag)) {
            throw new exception_1.IllegalArgument('Node.removeNag()');
        }
        return this._data.nags.delete(nag);
    }
    clearNags() {
        this._data.nags.clear();
    }
    filterNags(filter) {
        filterNags(this._data, filter);
    }
    tags() {
        return getTagKeys(this._data);
    }
    tag(tagKey, value) {
        if (!isValidTagKey(tagKey)) {
            throw new exception_1.IllegalArgument('Node.tag()');
        }
        if (arguments.length === 1) {
            return this._data.tags.get(tagKey);
        }
        else {
            if (value === undefined || value === null) {
                this._data.tags.delete(tagKey);
            }
            else {
                this._data.tags.set(tagKey, String(value));
            }
        }
    }
    clearTags() {
        this._data.tags.clear();
    }
    filterTags(filter) {
        filterTags(this._data, filter);
    }
    comment(value, isLongComment) {
        if (arguments.length === 0) {
            return this._data.comment;
        }
        else if (value === undefined || value === null) {
            this._data.comment = undefined;
            this._data.isLongComment = false;
        }
        else {
            this._data.comment = String(value);
            this._data.isLongComment = Boolean(isLongComment);
        }
    }
    isLongComment() {
        return this._data.isLongComment && isLongVariation(this._data.parentVariation);
    }
    parentVariation() {
        const initialPosition = rebuildVariationPosition(this._data.parentVariation);
        return new VariationImpl(this._data.parentVariation, initialPosition);
    }
    previous() {
        let current = this._data.parentVariation.child;
        if (current === this._data) {
            return undefined;
        }
        const position = rebuildVariationPosition(this._data.parentVariation);
        while (current.child !== this._data) {
            applyMoveDescriptor(position, current);
            current = current.child;
        }
        return new NodeImpl(current, position);
    }
    next() {
        if (this._data.child === undefined) {
            return undefined;
        }
        const nextPositionBefore = new position_1.Position(this._positionBefore);
        applyMoveDescriptor(nextPositionBefore, this._data);
        return new NodeImpl(this._data.child, nextPositionBefore);
    }
    notation() {
        return this._data.moveDescriptor === null ? '--' : this._positionBefore.notation(this._data.moveDescriptor);
    }
    figurineNotation() {
        return this._data.moveDescriptor === null ? '--' : this._positionBefore.figurineNotation(this._data.moveDescriptor);
    }
    positionBefore() {
        return new position_1.Position(this._positionBefore);
    }
    position() {
        const position = new position_1.Position(this._positionBefore);
        applyMoveDescriptor(position, this._data);
        return position;
    }
    fen() {
        return this.position().fen({
            fiftyMoveClock: computeNextFiftyMoveClock(this._data),
            fullMoveNumber: computeNextFullMoveNumber(this._data),
        });
    }
    fiftyMoveClock() {
        return computeNextFiftyMoveClock(this._data);
    }
    fullMoveNumber() {
        return this._data.fullMoveNumber;
    }
    moveColor() {
        return this._data.moveColor;
    }
    variations() {
        return this._data.variations.map(variation => new VariationImpl(variation, this._positionBefore));
    }
    play(move) {
        const nextPositionBefore = new position_1.Position(this._positionBefore);
        applyMoveDescriptor(nextPositionBefore, this._data);
        const nextMoveColor = nextPositionBefore.turn();
        const nextFiftyMoveClock = computeNextFiftyMoveClock(this._data);
        const nextFullMoveNumber = computeNextFullMoveNumber(this._data);
        this._data.child = createNodeData(this._data.parentVariation, nextMoveColor, nextFiftyMoveClock, nextFullMoveNumber, computeMoveDescriptor(nextPositionBefore, move));
        return new NodeImpl(this._data.child, nextPositionBefore);
    }
    removePrecedingMoves() {
        const moveTreeRoot = findRoot(this._data);
        // Reset the initial position and full-move number, and rebuild a new main variation (so that the annotations get cleared).
        moveTreeRoot._position = this._positionBefore;
        moveTreeRoot._fullMoveNumber = this._data.fullMoveNumber;
        moveTreeRoot._mainVariationData = createVariationData(moveTreeRoot, true);
        // Replug the nodes.
        moveTreeRoot._mainVariationData.child = this._data;
        resetParentVariationRecursively(this._data, moveTreeRoot._mainVariationData);
        resetFiftyMoveClockRecursively(this._data, 0);
    }
    removeFollowingMoves() {
        this._data.child = undefined;
    }
    addVariation(longVariation) {
        const result = createVariationData(this._data, longVariation !== null && longVariation !== void 0 ? longVariation : false);
        this._data.variations.push(result);
        return new VariationImpl(result, this._positionBefore);
    }
    removeVariation(variationIndex) {
        if (!isValidVariationIndex(variationIndex, this._data)) {
            throw new exception_1.IllegalArgument('Node.removeVariation()');
        }
        this._data.variations = this._data.variations.slice(0, variationIndex).concat(this._data.variations.slice(variationIndex + 1));
    }
    swapVariations(variationIndex1, variationIndex2) {
        if (!isValidVariationIndex(variationIndex1, this._data) || !isValidVariationIndex(variationIndex2, this._data)) {
            throw new exception_1.IllegalArgument('Node.swapVariations()');
        }
        const variationTmp = this._data.variations[variationIndex1];
        this._data.variations[variationIndex1] = this._data.variations[variationIndex2];
        this._data.variations[variationIndex2] = variationTmp;
    }
    promoteVariation(variationIndex) {
        if (!isValidVariationIndex(variationIndex, this._data) || this._data.variations[variationIndex].child === undefined) {
            throw new exception_1.IllegalArgument('Node.promoteVariation()');
        }
        const oldMainLine = this._data;
        const newMainLine = this._data.variations[variationIndex].child;
        // Detach the array containing the variations from the current node.
        const variations = oldMainLine.variations;
        oldMainLine.variations = [];
        // Create a new variation with the old main line.
        variations[variationIndex] = createVariationData(newMainLine, false);
        variations[variationIndex].child = oldMainLine;
        // Create a new main line with the promoted variation, and re-attach the variations.
        this._data = newMainLine;
        newMainLine.variations = variations.concat(newMainLine.variations);
        // Re-map the parents.
        findParent(oldMainLine).child = newMainLine;
        resetParentVariationRecursively(newMainLine, oldMainLine.parentVariation);
        resetParentVariationRecursively(oldMainLine, variations[variationIndex]);
        for (const variation of newMainLine.variations) {
            variation.parent = newMainLine;
        }
    }
}
function findRoot(node) {
    let candidate = node;
    while (!(candidate instanceof MoveTreeRoot)) {
        candidate = candidate.parentVariation.parent;
    }
    return candidate;
}
function findParent(oldMainLine) {
    let candidate = oldMainLine.parentVariation;
    while (candidate.child !== oldMainLine) {
        candidate = candidate.child;
    }
    return candidate;
}
function resetParentVariationRecursively(root, newParentVariation) {
    let current = root;
    while (current !== undefined) {
        current.parentVariation = newParentVariation;
        current = current.child;
    }
}
function resetFiftyMoveClockRecursively(root, fiftyMoveClock) {
    let current = root;
    while (current !== undefined) {
        // Update the current node.
        current.fiftyMoveClock = fiftyMoveClock;
        // Update its variations.
        for (const variation of current.variations) {
            resetFiftyMoveClockRecursively(variation.child, fiftyMoveClock);
        }
        fiftyMoveClock = computeNextFiftyMoveClock(current);
        current = current.child;
    }
}
/**
 * Implementation class for `Variation`.
 */
class VariationImpl extends node_variation_1.Variation {
    constructor(data, initialPosition) {
        super();
        this._data = data;
        this._initialPosition = initialPosition;
    }
    id() {
        return buildVariationIdPrefix(this._data) + 'start';
    }
    nags() {
        return getNags(this._data);
    }
    hasNag(nag) {
        if (!(0, common_1.isValidNag)(nag)) {
            throw new exception_1.IllegalArgument('Variation.hasNag()');
        }
        return this._data.nags.has(nag);
    }
    addNag(nag) {
        if (!(0, common_1.isValidNag)(nag)) {
            throw new exception_1.IllegalArgument('Variation.addNag()');
        }
        return this._data.nags.add(nag);
    }
    removeNag(nag) {
        if (!(0, common_1.isValidNag)(nag)) {
            throw new exception_1.IllegalArgument('Variation.removeNag()');
        }
        return this._data.nags.delete(nag);
    }
    clearNags() {
        this._data.nags.clear();
    }
    filterNags(filter) {
        filterNags(this._data, filter);
    }
    tags() {
        return getTagKeys(this._data);
    }
    tag(tagKey, value) {
        if (!isValidTagKey(tagKey)) {
            throw new exception_1.IllegalArgument('Variation.tag()');
        }
        if (arguments.length === 1) {
            return this._data.tags.get(tagKey);
        }
        else {
            if (value === undefined || value === null) {
                this._data.tags.delete(tagKey);
            }
            else {
                this._data.tags.set(tagKey, String(value));
            }
        }
    }
    clearTags() {
        this._data.tags.clear();
    }
    filterTags(filter) {
        filterTags(this._data, filter);
    }
    comment(value, isLongComment) {
        if (arguments.length === 0) {
            return this._data.comment;
        }
        else if (value === undefined || value === null) {
            this._data.comment = undefined;
            this._data.isLongComment = false;
        }
        else {
            this._data.comment = String(value);
            this._data.isLongComment = Boolean(isLongComment);
        }
    }
    isLongComment() {
        return this._data.isLongComment && isLongVariation(this._data);
    }
    parentNode() {
        return this._data.parent instanceof MoveTreeRoot ? undefined : new NodeImpl(this._data.parent, this._initialPosition);
    }
    first() {
        return this._data.child === undefined ? undefined : new NodeImpl(this._data.child, this._initialPosition);
    }
    nodes() {
        const result = [];
        let currentNodeData = this._data.child;
        let previousNodeData = undefined;
        let previousPositionBefore = this._initialPosition;
        while (currentNodeData !== undefined) {
            // Compute the "position-before" attribute the current node.
            previousPositionBefore = new position_1.Position(previousPositionBefore);
            if (previousNodeData !== undefined) {
                applyMoveDescriptor(previousPositionBefore, previousNodeData);
            }
            // Push the current node.
            result.push(new NodeImpl(currentNodeData, previousPositionBefore));
            // Increment the counters.
            previousNodeData = currentNodeData;
            currentNodeData = currentNodeData.child;
        }
        return result;
    }
    plyCount() {
        let result = 0;
        let currentNodeData = this._data.child;
        while (currentNodeData !== undefined) {
            ++result;
            currentNodeData = currentNodeData.child;
        }
        return result;
    }
    isLongVariation() {
        return isLongVariation(this._data);
    }
    initialPosition() {
        return new position_1.Position(this._initialPosition);
    }
    initialFEN() {
        return this._initialPosition.fen({
            fiftyMoveClock: this.initialFiftyMoveClock(),
            fullMoveNumber: this.initialFullMoveNumber(),
        });
    }
    initialFiftyMoveClock() {
        return this._data.parent instanceof MoveTreeRoot ? 0 : this._data.parent.fiftyMoveClock;
    }
    initialFullMoveNumber() {
        return this._data.parent instanceof MoveTreeRoot ? this._data.parent._fullMoveNumber : this._data.parent.fullMoveNumber;
    }
    finalPosition() {
        const result = new position_1.Position(this._initialPosition);
        for (let nodeData = this._data.child; nodeData !== undefined; nodeData = nodeData.child) {
            applyMoveDescriptor(result, nodeData);
        }
        return result;
    }
    finalFEN() {
        if (this._data.child === undefined) {
            return this.initialFEN();
        }
        const position = new position_1.Position(this._initialPosition);
        let nodeData = this._data.child;
        while (true) {
            applyMoveDescriptor(position, nodeData);
            if (nodeData.child === undefined) {
                break;
            }
            nodeData = nodeData.child;
        }
        return position.fen({
            fiftyMoveClock: computeNextFiftyMoveClock(nodeData),
            fullMoveNumber: computeNextFullMoveNumber(nodeData),
        });
    }
    play(move) {
        const moveColor = this._initialPosition.turn();
        const fiftyMoveClock = this.initialFiftyMoveClock();
        const fullMoveNumber = this.initialFullMoveNumber();
        this._data.child = createNodeData(this._data, moveColor, fiftyMoveClock, fullMoveNumber, computeMoveDescriptor(this._initialPosition, move));
        return new NodeImpl(this._data.child, this._initialPosition);
    }
    clearMoves() {
        this._data.child = undefined;
    }
}

},{"../exception":3,"../helper":5,"../i18n":6,"../node_variation":9,"../position":11,"../private_position/base_types_impl":19,"./common":12,"./pojo_util":14}],14:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _POJOExceptionBuilder_pojo, _POJOExceptionBuilder_path;
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeObjectField = exports.decodeArrayField = exports.decodeBooleanField = exports.decodeNumberField = exports.decodeStringField = exports.POJOExceptionBuilder = void 0;
const exception_1 = require("../exception");
const i18n_1 = require("../i18n");
/**
 * Helper class to build a {@link InvalidPOJO}.
 */
class POJOExceptionBuilder {
    constructor(pojo) {
        _POJOExceptionBuilder_pojo.set(this, void 0);
        _POJOExceptionBuilder_path.set(this, []);
        __classPrivateFieldSet(this, _POJOExceptionBuilder_pojo, pojo, "f");
    }
    push(fieldName) {
        __classPrivateFieldGet(this, _POJOExceptionBuilder_path, "f").push(fieldName);
    }
    pop() {
        __classPrivateFieldGet(this, _POJOExceptionBuilder_path, "f").pop();
    }
    build(message, ...tokens) {
        let fieldName = '';
        let isFirstPathComponent = true;
        for (const pathComponent of __classPrivateFieldGet(this, _POJOExceptionBuilder_path, "f")) {
            if (typeof pathComponent === 'number') {
                fieldName += `[${pathComponent}]`;
            }
            else {
                fieldName += isFirstPathComponent ? pathComponent : '.' + pathComponent;
            }
            isFirstPathComponent = false;
        }
        return new exception_1.InvalidPOJO(__classPrivateFieldGet(this, _POJOExceptionBuilder_pojo, "f"), fieldName, message, ...tokens);
    }
}
exports.POJOExceptionBuilder = POJOExceptionBuilder;
_POJOExceptionBuilder_pojo = new WeakMap(), _POJOExceptionBuilder_path = new WeakMap();
/**
 * Validate a string-valued field read from a POJO.
 */
function decodeStringField(pojo, fieldName, exceptionBuilder, setter) {
    if (!(fieldName in pojo)) {
        return;
    }
    exceptionBuilder.push(fieldName);
    const value = pojo[fieldName];
    if (typeof value === 'string') {
        setter(value);
    }
    else if (value !== undefined) {
        throw exceptionBuilder.build(i18n_1.i18n.INVALID_POJO_STRING_FIELD);
    }
    exceptionBuilder.pop();
}
exports.decodeStringField = decodeStringField;
/**
 * Validate a number-valued field read from a POJO.
 */
function decodeNumberField(pojo, fieldName, exceptionBuilder, setter) {
    if (!(fieldName in pojo)) {
        return;
    }
    exceptionBuilder.push(fieldName);
    const value = pojo[fieldName];
    if (typeof value === 'number') {
        setter(value);
    }
    else if (value !== undefined) {
        throw exceptionBuilder.build(i18n_1.i18n.INVALID_POJO_NUMBER_FIELD);
    }
    exceptionBuilder.pop();
}
exports.decodeNumberField = decodeNumberField;
/**
 * Validate a boolean-valued field read from a POJO.
 */
function decodeBooleanField(pojo, fieldName, exceptionBuilder, setter) {
    if (!(fieldName in pojo)) {
        return;
    }
    exceptionBuilder.push(fieldName);
    const value = pojo[fieldName];
    if (typeof value === 'boolean') {
        setter(value);
    }
    else if (value !== undefined) {
        throw exceptionBuilder.build(i18n_1.i18n.INVALID_POJO_BOOLEAN_FIELD);
    }
    exceptionBuilder.pop();
}
exports.decodeBooleanField = decodeBooleanField;
/**
 * Validate an array-valued field read from a POJO.
 */
function decodeArrayField(pojo, fieldName, exceptionBuilder, setter) {
    if (!(fieldName in pojo)) {
        return;
    }
    exceptionBuilder.push(fieldName);
    const value = pojo[fieldName];
    if (Array.isArray(value)) {
        setter(value);
    }
    else if (value !== undefined) {
        throw exceptionBuilder.build(i18n_1.i18n.INVALID_POJO_ARRAY_FIELD);
    }
    exceptionBuilder.pop();
}
exports.decodeArrayField = decodeArrayField;
/**
 * Validate an object-valued field read from a POJO.
 */
function decodeObjectField(pojo, fieldName, exceptionBuilder, setter) {
    if (!(fieldName in pojo)) {
        return;
    }
    exceptionBuilder.push(fieldName);
    const value = pojo[fieldName];
    if (typeof value === 'object' && value !== null) {
        setter(value);
    }
    else if (value !== undefined) {
        throw exceptionBuilder.build(i18n_1.i18n.INVALID_POJO_OBJECT_FIELD);
    }
    exceptionBuilder.pop();
}
exports.decodeObjectField = decodeObjectField;

},{"../exception":3,"../i18n":6}],15:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.readOneGame = exports.readDatabase = void 0;
const database_1 = require("../database");
const date_value_1 = require("../date_value");
const exception_1 = require("../exception");
const game_1 = require("../game");
const helper_1 = require("../helper");
const i18n_1 = require("../i18n");
const node_variation_1 = require("../node_variation");
const position_1 = require("../position");
const token_stream_1 = require("./token_stream");
function parseNullableHeader(value) {
    return value === '?' ? undefined : value;
}
function parsePositiveIntegerHeader(value) {
    if (/^\d+$/.test(value)) {
        const result = Number(value);
        if (Number.isInteger(result)) {
            return result;
        }
    }
    return undefined;
}
function parseRoundHeader(value) {
    if (/^(\?|\d+)(?:\.(\?|\d+)(?:\.(\?|\d+)(?:\.(?:\?|\d+))*)?)?$/.test(value)) {
        const round = Number(RegExp.$1);
        const subRound = RegExp.$2 ? Number(RegExp.$2) : undefined;
        const subSubRound = RegExp.$3 ? Number(RegExp.$3) : undefined;
        return {
            round: Number.isInteger(round) ? round : undefined,
            subRound: Number.isInteger(subRound) ? subRound : undefined,
            subSubRound: Number.isInteger(subSubRound) ? subSubRound : undefined,
        };
    }
    return { round: undefined, subRound: undefined, subSubRound: undefined };
}
function parseECOHeader(value) {
    return (0, helper_1.isValidECO)(value) ? value : undefined;
}
function parseVariant(value) {
    value = value.toLowerCase();
    if (value === 'regular' || value === 'standard') {
        return 'regular';
    }
    else if (value === 'fischerandom' || /^chess[ -]?960$/.test(value)) {
        return 'chess960';
    }
    else if (/^no[ -]king$/.test(value)) {
        return 'no-king';
    }
    else if (/^white[ -]king[ -]only$/.test(value)) {
        return 'white-king-only';
    }
    else if (/^black[ -]king[ -]only$/.test(value)) {
        return 'black-king-only';
    }
    else if (/^anti[ -]?chess/.test(value)) {
        return 'antichess';
    }
    else if (value === 'horde') {
        return 'horde';
    }
    else {
        return undefined;
    }
}
function processHeader(stream, game, factory, key, value, valueCharacterIndex, valueLineIndex) {
    value = value.trim();
    switch (key) {
        case 'White':
            game.playerName('w', parseNullableHeader(value));
            break;
        case 'Black':
            game.playerName('b', parseNullableHeader(value));
            break;
        case 'WhiteElo':
            game.playerElo('w', parsePositiveIntegerHeader(value));
            break;
        case 'BlackElo':
            game.playerElo('b', parsePositiveIntegerHeader(value));
            break;
        case 'WhiteTitle':
            game.playerTitle('w', value);
            break;
        case 'BlackTitle':
            game.playerTitle('b', value);
            break;
        case 'Event':
            game.event(parseNullableHeader(value));
            break;
        case 'Round': {
            const { round, subRound, subSubRound } = parseRoundHeader(value);
            game.round(round);
            game.subRound(subRound);
            game.subSubRound(subSubRound);
            break;
        }
        case 'Date':
            game.date(date_value_1.DateValue.fromPGNString(value));
            break;
        case 'Site':
            game.site(parseNullableHeader(value));
            break;
        case 'Annotator':
            game.annotator(value);
            break;
        case 'ECO':
            game.eco(parseECOHeader(value));
            break;
        case 'Opening':
            game.opening(value);
            break;
        case 'Variation':
            game.openingVariation(value);
            break;
        case 'SubVariation':
            game.openingSubVariation(value);
            break;
        case 'Termination':
            game.termination(value);
            break;
        // The header 'FEN' has a special meaning, in that it is used to define a custom
        // initial position, that may be different from the usual one.
        case 'FEN':
            factory.fen = value;
            factory.fenTokenCharacterIndex = valueCharacterIndex;
            factory.fenTokenLineIndex = valueLineIndex;
            break;
        // The header 'Variant' indicates that this is not a regular chess game.
        case 'Variant':
            factory.variant = parseVariant(value);
            if (factory.variant === undefined) {
                throw new exception_1.InvalidPGN(stream.text(), valueCharacterIndex, valueLineIndex, i18n_1.i18n.UNKNOWN_VARIANT, value);
            }
            factory.variantTokenCharacterIndex = valueCharacterIndex;
            factory.variantTokenLineIndex = valueLineIndex;
            break;
    }
}
function initializeInitialPosition(stream, game, factory) {
    // If a FEN header has been encountered, set-up the initial position with it, taking the optional variant into account.
    if (factory.fen !== undefined) {
        try {
            const position = factory.variant === undefined ? new position_1.Position() : new position_1.Position(factory.variant, 'empty');
            const moveCounters = position.fen(factory.fen);
            game.initialPosition(position, moveCounters.fullMoveNumber);
        }
        catch (error) {
            // istanbul ignore else
            if (error instanceof exception_1.InvalidFEN) {
                throw new exception_1.InvalidPGN(stream.text(), factory.fenTokenCharacterIndex, factory.fenTokenLineIndex, i18n_1.i18n.INVALID_FEN_IN_PGN_TEXT, error.message);
            }
            else {
                throw error;
            }
        }
    }
    // Otherwise, if a variant header has been encountered, but without FEN header...
    else if (factory.variant !== undefined) {
        if ((0, helper_1.variantWithCanonicalStartPosition)(factory.variant)) {
            const position = new position_1.Position(factory.variant, 'start');
            game.initialPosition(position, 1);
        }
        else {
            throw new exception_1.InvalidPGN(stream.text(), factory.variantTokenCharacterIndex, factory.variantTokenLineIndex, i18n_1.i18n.VARIANT_WITHOUT_FEN, factory.variant);
        }
    }
    // If neither a variant header nor a FEN header has been encountered, nothing to do (the default initial position as defined in the `Game` object
    // is the right one).
}
/**
 * Parse exactly 1 game from the given stream.
 */
function doParseGame(stream) {
    // State variable for syntactic analysis.
    let game = null; // the result
    let node = null; // current node (or variation) to which the next move should be appended
    const nodeStack = []; // when starting a variation, its parent node (btw., always a "true" node, not a variation) is stacked here
    const initialPositionFactory = {};
    // Token loop
    while (stream.consumeToken()) {
        // Create a new game if necessary
        if (game === null) {
            game = new game_1.Game();
        }
        // Set-up the root node when the first move-text token is encountered.
        if (stream.isMoveTextSection() && node === null) {
            initializeInitialPosition(stream, game, initialPositionFactory);
            node = game.mainVariation();
        }
        // Token type switch
        switch (stream.token()) {
            // Header
            case 1 /* TokenType.BEGIN_HEADER */: {
                if (node !== null) {
                    throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.UNEXPECTED_PGN_HEADER);
                }
                if (!stream.consumeToken() || stream.token() !== 3 /* TokenType.HEADER_ID */) {
                    throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.MISSING_PGN_HEADER_ID);
                }
                const headerId = stream.tokenValue();
                if (!stream.consumeToken() || stream.token() !== 4 /* TokenType.HEADER_VALUE */) {
                    throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.MISSING_PGN_HEADER_VALUE);
                }
                const headerValue = stream.tokenValue();
                const headerValueCharacterIndex = stream.tokenCharacterIndex();
                const headerValueLineIndex = stream.tokenLineIndex();
                if (!stream.consumeToken() || stream.token() !== 2 /* TokenType.END_HEADER */) {
                    throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.MISSING_END_OF_PGN_HEADER);
                }
                processHeader(stream, game, initialPositionFactory, headerId, headerValue, headerValueCharacterIndex, headerValueLineIndex);
                break;
            }
            // Move number
            case 5 /* TokenType.MOVE_NUMBER */:
                break;
            // Move or null-move
            case 6 /* TokenType.MOVE */:
                try {
                    node = node.play(stream.tokenValue());
                }
                catch (error) {
                    // istanbul ignore else
                    if (error instanceof exception_1.InvalidNotation) {
                        throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.INVALID_MOVE_IN_PGN_TEXT, error.notation, error.message);
                    }
                    else {
                        throw error;
                    }
                }
                break;
            // NAG
            case 7 /* TokenType.NAG */:
                node.addNag(stream.tokenValue());
                break;
            // Comment
            case 8 /* TokenType.COMMENT */: {
                const { comment, tags } = stream.tokenValue();
                for (const [key, value] of tags) {
                    node.tag(key, value);
                }
                if (comment !== undefined) {
                    if (node.comment() === undefined) {
                        const isLongComment = node instanceof node_variation_1.Variation ? stream.emptyLineAfterToken() : stream.emptyLineBeforeToken();
                        node.comment(comment, isLongComment);
                    }
                    else { // Concatenate the current comment to the previous one, if any.
                        const isLongComment = node.isLongComment();
                        node.comment(node.comment() + ' ' + comment, isLongComment);
                    }
                }
                break;
            }
            // Begin of variation
            case 9 /* TokenType.BEGIN_VARIATION */:
                if (node instanceof node_variation_1.Variation) {
                    throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.UNEXPECTED_BEGIN_OF_VARIATION);
                }
                nodeStack.push(node);
                node = node.addVariation(stream.emptyLineBeforeToken());
                break;
            // End of variation
            case 10 /* TokenType.END_VARIATION */:
                if (nodeStack.length === 0) {
                    throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.UNEXPECTED_END_OF_VARIATION);
                }
                node = nodeStack.pop();
                break;
            // End-of-game
            case 11 /* TokenType.END_OF_GAME */:
                if (nodeStack.length !== 0) {
                    throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.UNEXPECTED_END_OF_GAME);
                }
                game.result(stream.tokenValue());
                return game;
            // Something unexpected...
            default:
                throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.INVALID_PGN_TOKEN);
        } // switch(stream.token())
    } // while(stream.consumeToken())
    throw new exception_1.InvalidPGN(stream.text(), stream.tokenCharacterIndex(), stream.tokenLineIndex(), i18n_1.i18n.UNEXPECTED_END_OF_TEXT);
}
/**
 * Implementation of {@link Database} for a PGN reader.
 */
class PGNDatabaseImpl extends database_1.Database {
    constructor(pgnString) {
        super();
        this._currentGameIndex = -1;
        this._text = pgnString;
        this._gameLocations = [];
        this._stream = new token_stream_1.TokenStream(pgnString);
        while (true) {
            const currentLocation = this._stream.currentLocation();
            if (!this._stream.skipGame()) {
                break;
            }
            this._gameLocations.push(currentLocation);
        }
    }
    doGameCount() {
        return this._gameLocations.length;
    }
    doGame(gameIndex) {
        if (gameIndex >= this._gameLocations.length) {
            throw new exception_1.InvalidPGN(this._text, -1, -1, i18n_1.i18n.INVALID_GAME_INDEX, gameIndex, this._gameLocations.length);
        }
        if (this._currentGameIndex !== gameIndex) {
            this._stream = new token_stream_1.TokenStream(this._text, this._gameLocations[gameIndex]);
        }
        this._currentGameIndex = -1;
        const result = doParseGame(this._stream);
        this._currentGameIndex = gameIndex + 1;
        return result;
    }
}
/**
 * Read a PGN string and return a {@link Database} object.
 */
function readDatabase(pgnString) {
    return new PGNDatabaseImpl(pgnString);
}
exports.readDatabase = readDatabase;
/**
 * Read exactly 1 {@link Game} within the given PGN string.
 */
function readOneGame(pgnString, gameIndex) {
    const stream = new token_stream_1.TokenStream(pgnString);
    let gameCounter = 0;
    while (gameCounter !== gameIndex) {
        if (stream.skipGame()) {
            ++gameCounter;
        }
        else {
            throw new exception_1.InvalidPGN(pgnString, -1, -1, i18n_1.i18n.INVALID_GAME_INDEX, gameIndex, gameCounter);
        }
    }
    return doParseGame(stream);
}
exports.readOneGame = readOneGame;

},{"../database":1,"../date_value":2,"../exception":3,"../game":4,"../helper":5,"../i18n":6,"../node_variation":9,"../position":11,"./token_stream":17}],16:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeGames = exports.writeGame = void 0;
const helper_1 = require("../helper");
const node_variation_1 = require("../node_variation");
const position_1 = require("../position");
const common_1 = require("../private_game/common");
function escapeHeaderValue(value) {
    return value.replace(/([\\"])/g, '\\$1');
}
function escapeCommentValue(value) {
    return value.replace(/([\\}])/g, '\\$1');
}
function formatNullableHeader(value) {
    if (value !== undefined) {
        value = (0, common_1.trimAndCollapseSpaces)(value);
    }
    return value ? escapeHeaderValue(value) : '?';
}
function formatRoundHeader(fullRound) {
    return fullRound !== null && fullRound !== void 0 ? fullRound : '?';
}
function formatDateHeader(date) {
    return date === undefined ? '????.??.??' : date.toPGNString();
}
function formatVariant(variant) {
    switch (variant) {
        case 'regular': return undefined;
        case 'chess960': return 'Fischerandom';
        case 'antichess': return 'Antichess';
        case 'horde': return 'Horde';
        default: return variant;
    }
}
function writeOptionalHeader(key, value) {
    if (value !== undefined) {
        value = (0, common_1.trimAndCollapseSpaces)(value);
    }
    return value ? `[${key} "${escapeHeaderValue(value)}"]\n` : '';
}
function writeOptionalIntegerHeader(key, value) {
    return value === undefined ? '' : `[${key} "${value}"]\n`;
}
/**
 * @returns `true` if the move number of the next move must be written.
 */
function writeAnnotations(node, skipLineAfterCommentIfLong, pushToken, skipLine) {
    // NAGs
    for (const nag of node.nags()) {
        pushToken('$' + nag, false, false);
    }
    // Prepare comment
    let comment = node.comment();
    if (comment !== undefined) {
        comment = (0, common_1.trimAndCollapseSpaces)(comment);
    }
    // Prepare tags
    const tags = node.tags();
    const tagValues = new Map();
    let nonEmptyTagFound = false;
    for (const tagKey of tags) {
        const tagValue = (0, common_1.trimAndCollapseSpaces)(node.tag(tagKey).replace(/[[\]]/g, '')); // Square-brackets are erased in tag values in PGN.
        if (tagValue) {
            tagValues.set(tagKey, tagValue);
            nonEmptyTagFound = true;
        }
    }
    // Tags & comments
    if (nonEmptyTagFound || comment) {
        if (comment && node.isLongComment() && node instanceof node_variation_1.Node) {
            skipLine();
        }
        pushToken('{', false, true);
        for (const tagKey of tags) {
            const tagValue = tagValues.get(tagKey);
            if (tagValue) {
                pushToken(`[%${tagKey} ${escapeCommentValue(tagValue)}]`, true, false);
            }
        }
        if (comment) {
            for (const token of escapeCommentValue(comment).split(' ')) {
                pushToken(token, false, false);
            }
        }
        pushToken('}', true, false);
        if (comment && node.isLongComment() && skipLineAfterCommentIfLong) {
            skipLine();
        }
        return true;
    }
    else {
        return false;
    }
}
/**
 * @returns `true` if the move number of the next move must be written.
 */
function writeNode(node, forceMoveNumber, isMainVariation, pushToken, skipLine) {
    if (node.moveColor() === 'w') {
        pushToken(node.fullMoveNumber() + '.', false, false);
    }
    else if (forceMoveNumber) {
        pushToken(node.fullMoveNumber() + '...', false, false);
    }
    pushToken(node.notation(), false, false);
    const variations = node.variations();
    let lastNonEmptyVariationIndex = -1;
    for (let k = variations.length - 1; k >= 0; --k) {
        if (variations[k].first() !== undefined) {
            lastNonEmptyVariationIndex = k;
            break;
        }
    }
    let nextForceMoveNumber = writeAnnotations(node, (isMainVariation || node.next() !== undefined) && lastNonEmptyVariationIndex < 0, pushToken, skipLine);
    for (let k = 0; k < variations.length; ++k) {
        const variation = variations[k];
        if (variation.first() === undefined) {
            continue;
        }
        if (variation.isLongVariation()) {
            skipLine();
        }
        pushToken('(', false, true);
        writeVariation(variation, false, pushToken, skipLine);
        pushToken(')', true, false);
        if (k === lastNonEmptyVariationIndex && variation.isLongVariation()) {
            skipLine();
        }
        nextForceMoveNumber = true;
    }
    return nextForceMoveNumber;
}
function writeVariation(variation, isMainVariation, pushToken, skipLine) {
    writeAnnotations(variation, true, pushToken, skipLine);
    let currentNode = variation.first();
    let forceMoveNumber = true;
    while (currentNode !== undefined) {
        forceMoveNumber = writeNode(currentNode, forceMoveNumber, isMainVariation, pushToken, skipLine);
        currentNode = currentNode.next();
    }
}
/**
 * Generate the PGN string corresponding to the given {@link Game} object.
 */
function writeGame(game, options) {
    let result = '';
    // Mandatory tags
    result += `[Event "${formatNullableHeader(game.event())}"]\n`;
    result += `[Site "${formatNullableHeader(game.site())}"]\n`;
    result += `[Date "${formatDateHeader(game.date())}"]\n`;
    result += `[Round "${formatRoundHeader(game.fullRound())}"]\n`;
    result += `[White "${formatNullableHeader(game.playerName('w'))}"]\n`;
    result += `[Black "${formatNullableHeader(game.playerName('b'))}"]\n`;
    result += `[Result "${game.result()}"]\n`;
    const variant = game.variant();
    const initialPosition = game.initialPosition();
    const hasFENHeader = !(0, helper_1.variantWithCanonicalStartPosition)(variant) || !position_1.Position.isEqual(initialPosition, new position_1.Position(variant))
        || game.initialFullMoveNumber() !== 1;
    // Additional tags (ASCII order by tag name)
    result += writeOptionalHeader('Annotator', game.annotator());
    result += writeOptionalIntegerHeader('BlackElo', game.playerElo('b'));
    result += writeOptionalHeader('BlackTitle', game.playerTitle('b'));
    result += writeOptionalHeader('ECO', game.eco());
    if (hasFENHeader) {
        result += `[FEN "${initialPosition.fen({ fullMoveNumber: game.initialFullMoveNumber(), regularFENIfPossible: true })}"]\n`;
    }
    result += writeOptionalHeader('Opening', game.opening());
    if (options.withPlyCount) {
        result += `[PlyCount "${game.plyCount()}"]\n`;
    }
    if (hasFENHeader) {
        result += '[SetUp "1"]\n';
    }
    result += writeOptionalHeader('SubVariation', game.openingSubVariation());
    result += writeOptionalHeader('Termination', game.termination());
    result += writeOptionalHeader('Variant', formatVariant(variant));
    result += writeOptionalHeader('Variation', game.openingVariation());
    result += writeOptionalIntegerHeader('WhiteElo', game.playerElo('w'));
    result += writeOptionalHeader('WhiteTitle', game.playerTitle('w'));
    // Separator
    result += '\n';
    // Movetext
    // --------
    let currentLine = '';
    let avoidNextSpace = false;
    function pushToken(token, avoidSpaceBefore, avoidSpaceAfter) {
        if (currentLine.length === 0) {
            currentLine = token;
        }
        else if (currentLine.length + token.length + (avoidNextSpace || avoidSpaceBefore ? 0 : 1) <= 80) {
            currentLine += (avoidNextSpace || avoidSpaceBefore ? '' : ' ') + token;
        }
        else {
            result += currentLine + '\n';
            currentLine = token;
        }
        avoidNextSpace = avoidSpaceAfter;
    }
    function skipLine() {
        result += currentLine + '\n'; // `currentLine` is always non-empty since there is never two consecutive calls to `skipLine()`
        result += '\n';
        currentLine = '';
        avoidNextSpace = false;
    }
    writeVariation(game.mainVariation(), true, pushToken, skipLine);
    pushToken(game.result(), false, false);
    result += currentLine + '\n'; // `currentLine` is non-empty here
    return result;
}
exports.writeGame = writeGame;
/**
 * Generate the PGN string corresponding to the given array of {@link Game} objects.
 */
function writeGames(games, options) {
    return games.map(game => writeGame(game, options)).join('\n\n');
}
exports.writeGames = writeGames;

},{"../helper":5,"../node_variation":9,"../position":11,"../private_game/common":12}],17:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenStream = void 0;
const exception_1 = require("../exception");
const i18n_1 = require("../i18n");
const common_1 = require("../private_game/common");
function regExpWrapper(re, needIncrementLineIndex) {
    const result = re;
    result.needIncrementLineIndex = needIncrementLineIndex !== undefined && needIncrementLineIndex;
    result.matchedIndex = -1;
    result.matched = null;
    return result;
}
// Movetext-related tokens are found within this interval.
const FIRST_MOVE_TEXT_TOKEN = 5 /* TokenType.MOVE_NUMBER */;
const LAST_MOVE_TEXT_TOKEN = 11 /* TokenType.END_OF_GAME */;
// Conversion table NAG -> numeric code
const SPECIAL_NAGS_LOOKUP = new Map();
SPECIAL_NAGS_LOOKUP.set('!!', 3); // very good move
SPECIAL_NAGS_LOOKUP.set('!', 1); // good move
SPECIAL_NAGS_LOOKUP.set('!?', 5); // interesting move
SPECIAL_NAGS_LOOKUP.set('?!', 6); // questionable move
SPECIAL_NAGS_LOOKUP.set('?', 2); // bad move
SPECIAL_NAGS_LOOKUP.set('??', 4); // very bad move
SPECIAL_NAGS_LOOKUP.set('+-', 18); // White has a decisive advantage
SPECIAL_NAGS_LOOKUP.set('+/-', 16); // White has a moderate advantage
SPECIAL_NAGS_LOOKUP.set('+/=', 14); // White has a slight advantage
SPECIAL_NAGS_LOOKUP.set('+=', 14); // (same)
SPECIAL_NAGS_LOOKUP.set('=', 10); // equal position
SPECIAL_NAGS_LOOKUP.set('~', 13); // unclear position
SPECIAL_NAGS_LOOKUP.set('inf', 13); // (same)
SPECIAL_NAGS_LOOKUP.set('=/+', 15); // Black has a slight advantage
SPECIAL_NAGS_LOOKUP.set('=+', 15); // (same)
SPECIAL_NAGS_LOOKUP.set('-/+', 17); // Black has a moderate advantage
SPECIAL_NAGS_LOOKUP.set('-+', 19); // Black has a decisive advantage
SPECIAL_NAGS_LOOKUP.set('RR', 145); // Editorial comment
SPECIAL_NAGS_LOOKUP.set('N', 146); // Novelty
/**
 * Stream of PGN tokens.
 */
class TokenStream {
    constructor(text, initialLocation) {
        /** Current position in the string. */
        this._pos = 0;
        /** Current line index in the string. */
        this._lineIndex = 1;
        /** Current token. */
        this._token = 0 /* TokenType.INVALID */;
        /** Current token value (if any). */
        this._tokenValue = null;
        /** Position of the current token in the string. */
        this._tokenCharacterIndex = -1;
        /** Line index of the current token in the string. */
        this._tokenLineIndex = -1;
        /** Whether an empty line has been encountered before the current token. */
        this._emptyLineBeforeToken = false;
        /** Whether an empty line will be encountered after the current token. */
        this._emptyLineAfterToken = false;
        // Space-like matchers
        this._matchSpaces = regExpWrapper(/[ \f\t\v]+/g);
        this._matchLineBreak = regExpWrapper(/\r?\n|\r/g, true);
        this._matchFastAdvance = regExpWrapper(/[^ \f\t\v\r\n"{][^ \f\t\v\r\n"{10*]*/g);
        // Token matchers
        this._matchBeginHeader = regExpWrapper(/\[/g);
        this._matchEndHeader = regExpWrapper(/\]/g);
        this._matchHeaderId = regExpWrapper(/(\w+)/g);
        this._matchEnterHeaderValue = regExpWrapper(/"/g);
        this._matchMoveNumber = regExpWrapper(/[0-9]+\.(?:\.\.)?/g);
        this._matchMove = regExpWrapper(/(?:O-O(?:-O)?|0-0(?:-0)?|[KQRBN][a-h]?[1-8]?x?[a-h][1-8]|(?:[a-h]x?)?[a-h][1-8](?:=?[KQRBNP])?)[+#]?|--/g);
        this._matchNag = regExpWrapper(/([!?][!?]?|\+\/?[-=]|[-=]\/?\+|=|inf|~|RR|N)|\$([1-9][0-9]*)/g);
        this._matchEnterComment = regExpWrapper(/\{/g);
        this._matchBeginVariation = regExpWrapper(/\(/g);
        this._matchEndVariation = regExpWrapper(/\)/g);
        this._matchEndOfGame = regExpWrapper(/1-0|0-1|1\/2-1\/2|\*/g);
        // Special modes
        this._headerValueMode = regExpWrapper(/((?:[^\\"\f\t\v\r\n]|\\[^\f\t\v\r\n])*)"/g);
        this._headerValueDegradedMode = regExpWrapper(/[^\r\n]*/g);
        this._commentMode = regExpWrapper(/((?:[^\\}]|\\(?:.|[\r\n]))*)\}/g, true);
        // Remove the BOM (byte order mark) if any.
        if (text.codePointAt(0) === 0xFEFF) {
            text = text.substring(1);
        }
        this._text = text;
        // Skip the beginning of the text if requested.
        if (initialLocation !== undefined) {
            this._pos = initialLocation.pos;
            this._lineIndex = initialLocation.lineIndex;
        }
    }
    /**
     * PGN string being parsed.
     */
    text() {
        return this._text;
    }
    /**
     * Current location within the stream.
     */
    currentLocation() {
        return { pos: this._pos, lineIndex: this._lineIndex };
    }
    /**
     * Whether there is an empty line just before the current token. WARNING: valid only after a call to `consumeToken()`.
     */
    emptyLineBeforeToken() {
        return this._emptyLineBeforeToken;
    }
    /**
     * Whether there is an empty line just after the current token. WARNING: valid only after a call to `consumeToken()`.
     */
    emptyLineAfterToken() {
        return this._emptyLineAfterToken;
    }
    /**
     * Current token type. WARNING: valid only after a call to `consumeToken()`.
     */
    token() {
        return this._token;
    }
    /**
     * Value associated to the current token, if any. WARNING: valid only after a call to `consumeToken()`.
     */
    tokenValue() {
        return this._tokenValue;
    }
    /**
     * Character index of the current token. WARNING: valid only after a call to `consumeToken()`.
     */
    tokenCharacterIndex() {
        return this._tokenCharacterIndex;
    }
    /**
     * Line index of the current token. WARNING: valid only after a call to `consumeToken()`.
     */
    tokenLineIndex() {
        return this._tokenLineIndex;
    }
    /**
     * Wether the current token is a token of the move-text section. WARNING: valid only after a call to `consumeToken()`.
     */
    isMoveTextSection() {
        return this._token >= FIRST_MOVE_TEXT_TOKEN && this._token <= LAST_MOVE_TEXT_TOKEN;
    }
    /**
     * Try to consume 1 token.
     *
     * @returns `true` if a token could have been read, `false` if the end of the text has been reached.
     * @throws {@link exception.InvalidPGN} if the text cannot be interpreted as a valid token.
     */
    consumeToken() {
        // Consume blank (i.e. meaning-less) characters
        this._emptyLineBeforeToken = this._token === 0 /* TokenType.INVALID */ || this._token === 11 /* TokenType.END_OF_GAME */ ? this.skipBlanks() : this._emptyLineAfterToken;
        if (this._pos >= this._text.length) {
            this._tokenCharacterIndex = this._text.length;
            this._tokenLineIndex = this._lineIndex;
            return false;
        }
        // Save the location of the token.
        this._tokenCharacterIndex = this._pos;
        this._tokenLineIndex = this._lineIndex;
        // Match a move number
        if (this.testAtPos(this._matchMoveNumber)) {
            this._token = 5 /* TokenType.MOVE_NUMBER */;
            this._tokenValue = null;
        }
        // Match a move or a null-move
        else if (this.testAtPos(this._matchMove)) {
            this._token = 6 /* TokenType.MOVE */;
            this._tokenValue = this._matchMove.matched[0];
        }
        // Match a NAG
        else if (this.testAtPos(this._matchNag)) {
            this._token = 7 /* TokenType.NAG */;
            this._tokenValue = this._matchNag.matched[2] === undefined ? SPECIAL_NAGS_LOOKUP.get(this._matchNag.matched[1]) :
                parseInt(this._matchNag.matched[2], 10);
        }
        // Match a comment
        else if (this.testAtPos(this._matchEnterComment)) {
            if (!this.testAtPos(this._commentMode)) {
                throw new exception_1.InvalidPGN(this._text, this._pos, this._lineIndex, i18n_1.i18n.INVALID_PGN_TOKEN);
            }
            this._token = 8 /* TokenType.COMMENT */;
            this._tokenValue = parseCommentValue(this._commentMode.matched[1]);
        }
        // Match the beginning of a variation
        else if (this.testAtPos(this._matchBeginVariation)) {
            this._token = 9 /* TokenType.BEGIN_VARIATION */;
            this._tokenValue = null;
        }
        // Match the end of a variation
        else if (this.testAtPos(this._matchEndVariation)) {
            this._token = 10 /* TokenType.END_VARIATION */;
            this._tokenValue = null;
        }
        // Match a end-of-game marker
        else if (this.testAtPos(this._matchEndOfGame)) {
            this._token = 11 /* TokenType.END_OF_GAME */;
            this._tokenValue = this._matchEndOfGame.matched[0];
        }
        // Match the beginning of a game header
        else if (this.testAtPos(this._matchBeginHeader)) {
            this._token = 1 /* TokenType.BEGIN_HEADER */;
            this._tokenValue = null;
        }
        // Match the end of a game header
        else if (this.testAtPos(this._matchEndHeader)) {
            this._token = 2 /* TokenType.END_HEADER */;
            this._tokenValue = null;
        }
        // Match the ID of a game header
        else if (this.testAtPos(this._matchHeaderId)) {
            this._token = 3 /* TokenType.HEADER_ID */;
            this._tokenValue = this._matchHeaderId.matched[1];
        }
        // Match the value of a game header
        else if (this.testAtPos(this._matchEnterHeaderValue)) {
            if (!this.testAtPos(this._headerValueMode)) {
                throw new exception_1.InvalidPGN(this._text, this._pos, this._lineIndex, i18n_1.i18n.INVALID_PGN_TOKEN);
            }
            this._token = 4 /* TokenType.HEADER_VALUE */;
            this._tokenValue = parseHeaderValue(this._headerValueMode.matched[1]);
        }
        // Otherwise, the string is badly formatted with respect to the PGN syntax
        else {
            throw new exception_1.InvalidPGN(this._text, this._pos, this._lineIndex, i18n_1.i18n.INVALID_PGN_TOKEN);
        }
        this._emptyLineAfterToken = this._token === 11 /* TokenType.END_OF_GAME */ ? false : this.skipBlanks();
        return true;
    }
    /**
     * Try to skip all the tokens until a END_OF_GAME token or the end of the file is encountered.
     *
     * @returns `true` if any token have been found, `false` if the end of the file has been reached without finding any token.
     */
    skipGame() {
        let atLeastOneTokenFound = false;
        this._token = 0 /* TokenType.INVALID */;
        while (true) {
            // Consume blank (i.e. meaning-less) characters
            this.skipBlanks();
            if (this._pos >= this._text.length) {
                return atLeastOneTokenFound;
            }
            atLeastOneTokenFound = true;
            // Skip comments.
            if (this.testAtPos(this._matchEnterComment)) {
                if (!this.testAtPos(this._commentMode)) {
                    this._pos = this._text.length;
                    return true;
                }
            }
            // Skip header values.
            else if (this.testAtPos(this._matchEnterHeaderValue)) {
                if (!this.testAtPos(this._headerValueMode)) {
                    this.testAtPos(this._headerValueDegradedMode); // Always true as `_headerValueDegradedMode` matches the empty string.
                }
            }
            // Match a end-of-game marker.
            else if (this.testAtPos(this._matchEndOfGame)) {
                return true;
            }
            // Skip everything else until the next space or comment/header-value beginning.
            else {
                this.testAtPos(this._matchFastAdvance); // Always true given the other regexes `_matchEnterComment` and `_matchEnterHeaderValue`.
            }
        }
    }
    /**
     * Advance until the first non-blank character.
     *
     * @returns `true` if an empty line has been encountered.
     */
    skipBlanks() {
        let newLineCount = 0;
        while (this._pos < this._text.length) {
            if (this.testAtPos(this._matchSpaces)) {
                // Nothing to do...
            }
            else if (this.testAtPos(this._matchLineBreak)) {
                ++newLineCount;
            }
            else {
                break;
            }
        }
        // An empty line was encountered if and only if at least 2 line breaks were found.
        return newLineCount >= 2;
    }
    /**
     * Try to match the given regular expression at the current position, and increment the stream cursor `this._pos`
     * and the line counter `this._lineIndex` in case of a match.
     */
    testAtPos(re) {
        if (re.matchedIndex < this._pos) {
            re.lastIndex = this._pos;
            re.matched = re.exec(this._text);
            re.matchedIndex = re.matched === null ? this._text.length : re.matched.index;
        }
        if (re.matchedIndex === this._pos) {
            this._pos = re.lastIndex;
            if (re.needIncrementLineIndex) {
                const reLineBreak = /\r?\n|\r/g;
                while (reLineBreak.exec(re.matched[0])) {
                    ++this._lineIndex;
                }
            }
            return true;
        }
        else {
            return false;
        }
    }
}
exports.TokenStream = TokenStream;
/**
 * Parse a header value, unescaping special characters.
 */
function parseHeaderValue(rawHeaderValue) {
    return (0, common_1.trimAndCollapseSpaces)(rawHeaderValue.replace(/\\([\\"])/g, '$1'));
}
/**
 * Parse a comment, unescaping special characters, and looking for the `[%key value]` tags.
 */
function parseCommentValue(rawComment) {
    rawComment = rawComment.replace(/\\([\\}])/g, '$1');
    // Find and remove the tags from the raw comment.
    const tags = new Map();
    let comment = rawComment.replace(/\[%(\w+)\s([^[\]]*)\]/g, (_, p1, p2) => {
        p2 = (0, common_1.trimAndCollapseSpaces)(p2);
        if (p2 !== '') {
            tags.set(p1, p2);
        }
        return ' ';
    });
    // Trim the comment and collapse sequences of space characters into 1 character only.
    comment = (0, common_1.trimAndCollapseSpaces)(comment);
    if (comment === '') {
        comment = undefined;
    }
    // Return the result
    return { comment: comment, tags: tags };
}

},{"../exception":3,"../i18n":6,"../private_game/common":12}],18:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAttacks = exports.isAttacked = exports.ATTACK_DIRECTIONS = void 0;
/**
 * Attack directions per colored piece.
 */
exports.ATTACK_DIRECTIONS = [
    [-17, -16, -15, -1, 1, 15, 16, 17],
    [-17, -16, -15, -1, 1, 15, 16, 17],
    [-17, -16, -15, -1, 1, 15, 16, 17],
    [-17, -16, -15, -1, 1, 15, 16, 17],
    [-16, -1, 1, 16],
    [-16, -1, 1, 16],
    [-17, -15, 15, 17],
    [-17, -15, 15, 17],
    [-33, -31, -18, -14, 14, 18, 31, 33],
    [-33, -31, -18, -14, 14, 18, 31, 33],
    [15, 17],
    [-17, -15] // black pawn
];
// -----------------------------------------------------------------------------
// isAttacked
// -----------------------------------------------------------------------------
/**
 * Check if any piece of the given color attacks a given square.
 */
function isAttacked(position, square, attackerColor) {
    return isAttackedByNonSliding(position, square, 0 /* PieceImpl.KING */ * 2 + attackerColor) ||
        isAttackedByNonSliding(position, square, 4 /* PieceImpl.KNIGHT */ * 2 + attackerColor) ||
        isAttackedByNonSliding(position, square, 5 /* PieceImpl.PAWN */ * 2 + attackerColor) ||
        isAttackedBySliding(position, square, 2 /* PieceImpl.ROOK */ * 2 + attackerColor, 1 /* PieceImpl.QUEEN */ * 2 + attackerColor) ||
        isAttackedBySliding(position, square, 3 /* PieceImpl.BISHOP */ * 2 + attackerColor, 1 /* PieceImpl.QUEEN */ * 2 + attackerColor);
}
exports.isAttacked = isAttacked;
function isAttackedByNonSliding(position, square, nonSlidingAttacker) {
    const directions = exports.ATTACK_DIRECTIONS[nonSlidingAttacker];
    for (let i = 0; i < directions.length; ++i) {
        const sq = square - directions[i];
        if ((sq & 0x88) === 0 && position.board[sq] === nonSlidingAttacker) {
            return true;
        }
    }
    return false;
}
function isAttackedBySliding(position, square, slidingAttacker, queenAttacker) {
    const directions = exports.ATTACK_DIRECTIONS[slidingAttacker];
    for (let i = 0; i < directions.length; ++i) {
        let sq = square;
        while (true) {
            sq -= directions[i];
            if ((sq & 0x88) === 0) {
                const cp = position.board[sq];
                if (cp === -1 /* SpI.EMPTY */) {
                    continue;
                }
                else if (cp === slidingAttacker || cp === queenAttacker) {
                    return true;
                }
            }
            break;
        }
    }
    return false;
}
// -----------------------------------------------------------------------------
// getAttacks
// -----------------------------------------------------------------------------
/**
 * Return the squares from which a piece of the given color attacks a given square.
 */
function getAttacks(position, square, attackerColor) {
    const result = [];
    findNonSlidingAttacks(position, square, result, 0 /* PieceImpl.KING */ * 2 + attackerColor);
    findNonSlidingAttacks(position, square, result, 4 /* PieceImpl.KNIGHT */ * 2 + attackerColor);
    findNonSlidingAttacks(position, square, result, 5 /* PieceImpl.PAWN */ * 2 + attackerColor);
    findSlidingAttacks(position, square, result, 2 /* PieceImpl.ROOK */ * 2 + attackerColor, 1 /* PieceImpl.QUEEN */ * 2 + attackerColor);
    findSlidingAttacks(position, square, result, 3 /* PieceImpl.BISHOP */ * 2 + attackerColor, 1 /* PieceImpl.QUEEN */ * 2 + attackerColor);
    return result;
}
exports.getAttacks = getAttacks;
function findNonSlidingAttacks(position, square, result, nonSlidingAttacker) {
    const directions = exports.ATTACK_DIRECTIONS[nonSlidingAttacker];
    for (let i = 0; i < directions.length; ++i) {
        const sq = square - directions[i];
        if ((sq & 0x88) === 0 && position.board[sq] === nonSlidingAttacker) {
            result.push(sq);
        }
    }
}
function findSlidingAttacks(position, square, result, slidingAttacker, queenAttacker) {
    const directions = exports.ATTACK_DIRECTIONS[slidingAttacker];
    for (let i = 0; i < directions.length; ++i) {
        let sq = square;
        while (true) {
            sq -= directions[i];
            if ((sq & 0x88) === 0) {
                const cp = position.board[sq];
                if (cp === -1 /* SpI.EMPTY */) {
                    continue;
                }
                else if (cp === slidingAttacker || cp === queenAttacker) {
                    result.push(sq);
                }
            }
            break;
        }
    }
}

},{}],19:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.squareColorImpl = exports.figurineFromString = exports.figurineToString = exports.coloredPieceFromString = exports.coloredPieceToString = exports.squareFromString = exports.squareToString = exports.variantFromString = exports.resultFromString = exports.rankFromString = exports.fileFromString = exports.pieceFromString = exports.colorFromString = exports.variantToString = exports.resultToString = exports.rankToString = exports.fileToString = exports.pieceToString = exports.colorToString = void 0;
const COLOR_SYMBOL = [...'wb'];
const PIECE_SYMBOL = [...'kqrbnp'];
const FILE_SYMBOL = [...'abcdefgh'];
const RANK_SYMBOL = [...'12345678'];
const RESULT_SYMBOL = ['1-0', '0-1', '1/2-1/2', '*'];
const VARIANT_SYMBOL = ['regular', 'chess960', 'no-king', 'white-king-only', 'black-king-only', 'antichess', 'horde'];
const FIGURINE_SYMBOL = [...'\u2654\u265a\u2655\u265b\u2656\u265c\u2657\u265d\u2658\u265e\u2659\u265f'];
function colorToString(color) { return COLOR_SYMBOL[color]; }
exports.colorToString = colorToString;
function pieceToString(piece) { return PIECE_SYMBOL[piece]; }
exports.pieceToString = pieceToString;
function fileToString(file) { return FILE_SYMBOL[file]; }
exports.fileToString = fileToString;
function rankToString(rank) { return RANK_SYMBOL[rank]; }
exports.rankToString = rankToString;
function resultToString(result) { return RESULT_SYMBOL[result]; }
exports.resultToString = resultToString;
function variantToString(variant) { return VARIANT_SYMBOL[variant]; }
exports.variantToString = variantToString;
function colorFromString(color) { return typeof color === 'string' ? COLOR_SYMBOL.indexOf(color) : -1; }
exports.colorFromString = colorFromString;
function pieceFromString(piece) { return typeof piece === 'string' ? PIECE_SYMBOL.indexOf(piece) : -1; }
exports.pieceFromString = pieceFromString;
function fileFromString(file) { return typeof file === 'string' ? FILE_SYMBOL.indexOf(file) : -1; }
exports.fileFromString = fileFromString;
function rankFromString(rank) { return typeof rank === 'string' ? RANK_SYMBOL.indexOf(rank) : -1; }
exports.rankFromString = rankFromString;
function resultFromString(result) { return typeof result === 'string' ? RESULT_SYMBOL.indexOf(result) : -1; }
exports.resultFromString = resultFromString;
function variantFromString(variant) { return typeof variant === 'string' ? VARIANT_SYMBOL.indexOf(variant) : -1; }
exports.variantFromString = variantFromString;
function squareToString(square) {
    return FILE_SYMBOL[square % 16] + RANK_SYMBOL[Math.trunc(square / 16)];
}
exports.squareToString = squareToString;
function squareFromString(square) {
    if (typeof square !== 'string' || !/^[a-h][1-8]$/.test(square)) {
        return -1;
    }
    const file = FILE_SYMBOL.indexOf(square[0]);
    const rank = RANK_SYMBOL.indexOf(square[1]);
    return rank * 16 + file;
}
exports.squareFromString = squareFromString;
function coloredPieceToString(cp) {
    return COLOR_SYMBOL[cp % 2] + PIECE_SYMBOL[Math.trunc(cp / 2)];
}
exports.coloredPieceToString = coloredPieceToString;
function coloredPieceFromString(cp) {
    if (typeof cp !== 'string' || !/^[wb][kqrbnp]$/.test(cp)) {
        return -1;
    }
    const color = COLOR_SYMBOL.indexOf(cp[0]);
    const piece = PIECE_SYMBOL.indexOf(cp[1]);
    return piece * 2 + color;
}
exports.coloredPieceFromString = coloredPieceFromString;
function figurineToString(cp) {
    return FIGURINE_SYMBOL[cp];
}
exports.figurineToString = figurineToString;
function figurineFromString(cp) {
    return FIGURINE_SYMBOL.indexOf(String(cp));
}
exports.figurineFromString = figurineFromString;
function squareColorImpl(square) {
    return (~square ^ (square >> 4)) & 0x1;
}
exports.squareColorImpl = squareColorImpl;

},{}],20:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseFEN = exports.getFEN = exports.ascii = void 0;
const base_types_impl_1 = require("./base_types_impl");
const impl_1 = require("./impl");
const legality_1 = require("./legality");
const exception_1 = require("../exception");
const i18n_1 = require("../i18n");
const FEN_PIECE_SYMBOL = [...'KkQqRrBbNnPp'];
const EN_PASSANT_RANK = ['6', '3'];
/**
 * Return a human-readable string representing the position. This string is multi-line,
 * and is intended to be displayed in a fixed-width font (similarly to an ASCII-art picture).
 */
function ascii(position) {
    // Board scanning
    let result = '+---+---+---+---+---+---+---+---+\n';
    for (let r = 7; r >= 0; --r) {
        for (let c = 0; c < 8; ++c) {
            const cp = position.board[r * 16 + c];
            result += '| ' + (cp === -1 /* SpI.EMPTY */ ? ' ' : FEN_PIECE_SYMBOL[cp]) + ' ';
        }
        result += '|\n';
        result += '+---+---+---+---+---+---+---+---+\n';
    }
    // Flags
    result += (0, base_types_impl_1.colorToString)(position.turn) + ' ' + castlingToString(position) + ' ' + enPassantToString(position);
    if (position.variant !== 0 /* GameVariantImpl.REGULAR_CHESS */) {
        result += ' (' + (0, base_types_impl_1.variantToString)(position.variant) + ')';
    }
    return result;
}
exports.ascii = ascii;
function getFEN(position, fiftyMoveClock = 0, fullMoveNumber = 1, regularFENIfPossible = false) {
    let result = '';
    // Board scanning
    for (let r = 7; r >= 0; --r) {
        let emptyCount = 0;
        for (let c = 0; c < 8; ++c) {
            const cp = position.board[r * 16 + c];
            if (cp === -1 /* SpI.EMPTY */) {
                ++emptyCount;
            }
            else {
                if (emptyCount > 0) {
                    result += emptyCount;
                    emptyCount = 0;
                }
                result += FEN_PIECE_SYMBOL[cp];
            }
        }
        if (emptyCount > 0) {
            result += emptyCount;
        }
        if (r > 0) {
            result += '/';
        }
    }
    // Flags + additional move counters
    result += ' ' + (0, base_types_impl_1.colorToString)(position.turn) + ' ' + castlingToString(position, regularFENIfPossible) + ' ' + enPassantToString(position);
    result += ' ' + fiftyMoveClock + ' ' + fullMoveNumber;
    return result;
}
exports.getFEN = getFEN;
/**
 * @param regularFENIfPossible - For Chess960, if `true`, format the flags as `KQkq` (regular FEN style) if possible
 *                               (instead of `AB...Hab...h` which is used by default, i.e. X-FEN style).
 *                               For the other variants, this flag has no effect, as regulary FEN style is always used.
 */
function castlingToString(position, regularFENIfPossible = false) {
    (0, legality_1.refreshEffectiveCastling)(position);
    if (position.variant === 1 /* GameVariantImpl.CHESS960 */) {
        if (regularFENIfPossible) {
            const whiteRegularFlags = regularFENCaslingFlagIfPossible(position, 0 /* ColorImpl.WHITE */);
            const blackRegularFlags = regularFENCaslingFlagIfPossible(position, 1 /* ColorImpl.BLACK */);
            if (whiteRegularFlags !== false && blackRegularFlags !== false) {
                return whiteRegularFlags === '' && blackRegularFlags === '' ? '-' : whiteRegularFlags.toUpperCase() + blackRegularFlags;
            }
        }
        let whiteFlags = '';
        let blackFlags = '';
        for (let file = 0; file < 8; ++file) {
            if (position.effectiveCastling[0 /* ColorImpl.WHITE */] & 1 << file) {
                whiteFlags += (0, base_types_impl_1.fileToString)(file);
            }
            if (position.effectiveCastling[1 /* ColorImpl.BLACK */] & 1 << file) {
                blackFlags += (0, base_types_impl_1.fileToString)(file);
            }
        }
        return whiteFlags === '' && blackFlags === '' ? '-' : whiteFlags.toUpperCase() + blackFlags;
    }
    else {
        let result = '';
        if (position.effectiveCastling[0 /* ColorImpl.WHITE */] & 0x80) {
            result += 'K';
        }
        if (position.effectiveCastling[0 /* ColorImpl.WHITE */] & 0x01) {
            result += 'Q';
        }
        if (position.effectiveCastling[1 /* ColorImpl.BLACK */] & 0x80) {
            result += 'k';
        }
        if (position.effectiveCastling[1 /* ColorImpl.BLACK */] & 0x01) {
            result += 'q';
        }
        return result === '' ? '-' : result;
    }
}
function regularFENCaslingFlagIfPossible(position, color) {
    // Decompose the castling flags into:
    //
    // +---------------+---+--------------+
    // | queenSideMask | 0 | kingSideMask |
    // +---------------+---+--------------+
    //   ^               ^              ^
    // File a        King file        File h
    //
    const kingFileMask = 1 << (position.king[color] % 16);
    const kingSideMask = position.effectiveCastling[color] & ~(kingFileMask | (kingFileMask - 1));
    const queenSideMask = position.effectiveCastling[color] & (kingFileMask - 1);
    let fenFlag = '';
    const firstSquare = 112 * color;
    const lastSquare = 112 * color + 7;
    const targetRook = 2 /* PieceImpl.ROOK */ * 2 + color;
    // Search for the rooks on king-side.
    if (kingSideMask !== 0) {
        let rookFound = false;
        for (let sq = position.king[color] + 1; sq <= lastSquare; ++sq) {
            if (position.board[sq] === targetRook) {
                if (rookFound) { // Ensure there is only 1 rook on the king side.
                    return false;
                }
                else {
                    rookFound = true;
                }
            }
        }
        fenFlag += 'k';
    }
    // Search for the rooks on queen-side.
    if (queenSideMask !== 0) {
        let rookFound = false;
        for (let sq = position.king[color] - 1; sq >= firstSquare; --sq) {
            if (position.board[sq] === targetRook) {
                if (rookFound) { // Ensure there is only 1 rook on the queen side.
                    return false;
                }
                else {
                    rookFound = true;
                }
            }
        }
        fenFlag += 'q';
    }
    return fenFlag;
}
function enPassantToString(position) {
    (0, legality_1.refreshEffectiveEnPassant)(position);
    return position.effectiveEnPassant < 0 ? '-' : (0, base_types_impl_1.fileToString)(position.effectiveEnPassant) + EN_PASSANT_RANK[position.turn];
}
function parseFEN(variant, fen, strict) {
    // Trim the input string and split it into 6 fields.
    const fields = strict ? fen.split(' ') : fen.replace(/^\s+|\s+$/g, '').split(/\s+/);
    if (fields.length !== 6) {
        throw new exception_1.InvalidFEN(fen, i18n_1.i18n.WRONG_NUMBER_OF_FEN_FIELDS);
    }
    // The first field (that represents the board) is split in 8 sub-fields.
    const rankFields = fields[0].split('/');
    if (rankFields.length !== 8) {
        throw new exception_1.InvalidFEN(fen, i18n_1.i18n.WRONG_NUMBER_OF_SUBFIELDS_IN_BOARD_FIELD);
    }
    // Initialize the position
    const position = (0, impl_1.makeEmpty)(variant);
    position.legal = null;
    position.effectiveCastling = null;
    position.effectiveEnPassant = null;
    // Board parsing
    for (let r = 7; r >= 0; --r) {
        const rankField = rankFields[7 - r];
        let i = 0;
        let c = 0;
        while (i < rankField.length && c < 8) {
            const s = rankField[i];
            const cp = FEN_PIECE_SYMBOL.indexOf(s);
            // The current character is in the range [1-8] -> skip the corresponding number of squares.
            if (/^[1-8]$/.test(s)) {
                c += parseInt(s, 10);
            }
            // The current character corresponds to a colored piece symbol -> set the current square accordingly.
            else if (cp >= 0) {
                position.board[r * 16 + c] = cp;
                ++c;
            }
            // Otherwise -> parsing error.
            else {
                throw new exception_1.InvalidFEN(fen, i18n_1.i18n.UNEXPECTED_CHARACTER_IN_BOARD_FIELD, s);
            }
            // Increment the character counter.
            ++i;
        }
        // Ensure that the current sub-field deals with all the squares of the current rank.
        if (i !== rankField.length || c !== 8) {
            throw new exception_1.InvalidFEN(fen, i18n_1.i18n.UNEXPECTED_END_OF_SUBFIELD_IN_BOARD_FIELD, 8 - r);
        }
    }
    // Turn parsing
    position.turn = (0, base_types_impl_1.colorFromString)(fields[1]);
    if (position.turn < 0) {
        throw new exception_1.InvalidFEN(fen, i18n_1.i18n.INVALID_TURN_FIELD);
    }
    // Castling rights parsing
    const castling = variant === 1 /* GameVariantImpl.CHESS960 */ ? castlingFromStringXFEN(fields[2], strict, position.board) : castlingFromStringFEN(fields[2], strict);
    if (castling === null) {
        throw new exception_1.InvalidFEN(fen, i18n_1.i18n.INVALID_CASTLING_FIELD);
    }
    else {
        position.castling = castling;
    }
    // En-passant rights parsing
    const enPassantField = fields[3];
    if (enPassantField !== '-') {
        if (!/^[a-h][36]$/.test(enPassantField)) {
            throw new exception_1.InvalidFEN(fen, i18n_1.i18n.INVALID_EN_PASSANT_FIELD);
        }
        position.enPassant = (0, base_types_impl_1.fileFromString)(enPassantField[0]);
        if (strict) {
            if (enPassantField[1] !== EN_PASSANT_RANK[position.turn]) {
                throw new exception_1.InvalidFEN(fen, i18n_1.i18n.WRONG_RANK_IN_EN_PASSANT_FIELD);
            }
            (0, legality_1.refreshEffectiveEnPassant)(position);
            if (position.enPassant !== position.effectiveEnPassant) {
                throw new exception_1.InvalidFEN(fen, i18n_1.i18n.INEFFECTIVE_EN_PASSANT_FIELD, (0, base_types_impl_1.fileToString)(position.enPassant));
            }
        }
    }
    // Move counting flags parsing
    const moveCountingRegex = strict ? /^(?:0|[1-9][0-9]*)$/ : /^[0-9]+$/;
    if (!moveCountingRegex.test(fields[4])) {
        throw new exception_1.InvalidFEN(fen, i18n_1.i18n.INVALID_HALF_MOVE_COUNT_FIELD);
    }
    if (!moveCountingRegex.test(fields[5])) {
        throw new exception_1.InvalidFEN(fen, i18n_1.i18n.INVALID_MOVE_NUMBER_FIELD);
    }
    return { position: position, fiftyMoveClock: parseInt(fields[4], 10), fullMoveNumber: parseInt(fields[5], 10) };
}
exports.parseFEN = parseFEN;
function castlingFromStringFEN(castling, strict) {
    const result = [0, 0];
    if (castling === '-') {
        return result;
    }
    if (!(strict ? /^K?Q?k?q?$/ : /^[KQkq]*$/).test(castling)) {
        return null;
    }
    if (castling.indexOf('K') >= 0) {
        result[0 /* ColorImpl.WHITE */] |= 1 << 7;
    }
    if (castling.indexOf('Q') >= 0) {
        result[0 /* ColorImpl.WHITE */] |= 1 << 0;
    }
    if (castling.indexOf('k') >= 0) {
        result[1 /* ColorImpl.BLACK */] |= 1 << 7;
    }
    if (castling.indexOf('q') >= 0) {
        result[1 /* ColorImpl.BLACK */] |= 1 << 0;
    }
    return result;
}
function castlingFromStringXFEN(castling, strict, board) {
    const result = [0, 0];
    if (castling === '-') {
        return result;
    }
    if (!(strict ? /^[A-H]{0,2}[a-h]{0,2}$/ : /^[A-Ha-h]*|[KQkq]*$/).test(castling)) {
        return null;
    }
    function searchQueenSideRook(color) {
        const targetRook = 2 /* PieceImpl.ROOK */ * 2 + color;
        const targetKing = 0 /* PieceImpl.KING */ * 2 + color;
        for (let sq = 112 * color; sq < 112 * color + 8; ++sq) {
            if (board[sq] === targetRook) {
                return sq % 8;
            }
            else if (board[sq] === targetKing) {
                break;
            }
        }
        return 0;
    }
    function searchKingSideRook(color) {
        const targetRook = 2 /* PieceImpl.ROOK */ * 2 + color;
        const targetKing = 0 /* PieceImpl.KING */ * 2 + color;
        for (let sq = 112 * color + 7; sq >= 112 * color; --sq) {
            if (board[sq] === targetRook) {
                return sq % 8;
            }
            else if (board[sq] === targetKing) {
                break;
            }
        }
        return 7;
    }
    if (!strict) {
        if (castling.indexOf('K') >= 0) {
            result[0 /* ColorImpl.WHITE */] |= 1 << searchKingSideRook(0 /* ColorImpl.WHITE */);
        }
        if (castling.indexOf('Q') >= 0) {
            result[0 /* ColorImpl.WHITE */] |= 1 << searchQueenSideRook(0 /* ColorImpl.WHITE */);
        }
        if (castling.indexOf('k') >= 0) {
            result[1 /* ColorImpl.BLACK */] |= 1 << searchKingSideRook(1 /* ColorImpl.BLACK */);
        }
        if (castling.indexOf('q') >= 0) {
            result[1 /* ColorImpl.BLACK */] |= 1 << searchQueenSideRook(1 /* ColorImpl.BLACK */);
        }
    }
    for (let file = 0; file < 8; ++file) {
        const s = (0, base_types_impl_1.fileToString)(file);
        if (castling.indexOf(s.toUpperCase()) >= 0) {
            result[0 /* ColorImpl.WHITE */] |= 1 << file;
        }
        if (castling.indexOf(s) >= 0) {
            result[1 /* ColorImpl.BLACK */] |= 1 << file;
        }
    }
    return result;
}

},{"../exception":3,"../i18n":6,"./base_types_impl":19,"./impl":21,"./legality":22}],21:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeCopy = exports.make960FromScharnagl = exports.makeInitial = exports.makeEmpty = exports.hasCanonicalStartPosition = void 0;
const EMPTY_BOARD = [
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */,
];
const REGULAR_START_BOARD = [
    4 /* CpI.WR */, 8 /* CpI.WN */, 6 /* CpI.WB */, 2 /* CpI.WQ */, 0 /* CpI.WK */, 6 /* CpI.WB */, 8 /* CpI.WN */, 4 /* CpI.WR */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    5 /* CpI.BR */, 9 /* CpI.BN */, 7 /* CpI.BB */, 3 /* CpI.BQ */, 1 /* CpI.BK */, 7 /* CpI.BB */, 9 /* CpI.BN */, 5 /* CpI.BR */,
];
const HORDE_START_BOARD = [
    10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, 10 /* CpI.WP */, 10 /* CpI.WP */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, 10 /* CpI.WP */, 10 /* CpI.WP */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
    5 /* CpI.BR */, 9 /* CpI.BN */, 7 /* CpI.BB */, 3 /* CpI.BQ */, 1 /* CpI.BK */, 7 /* CpI.BB */, 9 /* CpI.BN */, 5 /* CpI.BR */,
];
const START_POSITION_INFO = [
    {
        board: REGULAR_START_BOARD,
        castling: [129 /* (1 << A-file) | (1 << H-file) */, 129 /* (1 << A-file) | (1 << H-file) */],
        king: [4 /* SquareImpl.E1 */, 116 /* SquareImpl.E8 */],
    },
    null,
    null,
    null,
    null,
    {
        board: REGULAR_START_BOARD,
        castling: [0, 0],
        king: [-1, -1],
    },
    {
        board: HORDE_START_BOARD,
        castling: [0, 129 /* (1 << A-file) | (1 << H-file) */],
        king: [-1, 116 /* SquareImpl.E8 */],
    },
];
function hasCanonicalStartPosition(variant) {
    return START_POSITION_INFO[variant] !== null;
}
exports.hasCanonicalStartPosition = hasCanonicalStartPosition;
function makeEmpty(variant) {
    return {
        board: EMPTY_BOARD.slice(),
        turn: 0 /* ColorImpl.WHITE */,
        castling: [0, 0],
        enPassant: -1,
        variant: variant,
        legal: variant === 2 /* GameVariantImpl.NO_KING */,
        king: [-1, -1],
        effectiveCastling: [0, 0],
        effectiveEnPassant: -1,
    };
}
exports.makeEmpty = makeEmpty;
/**
 * @param variant - Must be a variant with a canonical start position.
 */
function makeInitial(variant) {
    const info = START_POSITION_INFO[variant]; // WARNING: applicable only to variants with a canonical start position.
    return {
        board: info.board.slice(),
        turn: 0 /* ColorImpl.WHITE */,
        castling: info.castling.slice(),
        enPassant: -1,
        variant: variant,
        legal: true,
        king: info.king.slice(),
        effectiveCastling: info.castling.slice(),
        effectiveEnPassant: -1,
    };
}
exports.makeInitial = makeInitial;
/**
 * Chess960 initial position, following the numbering scheme proposed by Reinhard Scharnagl (see for instance https://chess960.net/start-positions/).
 *
 * @param scharnaglCode - Integer between 0 and 959 inclusive.
 */
function make960FromScharnagl(scharnaglCode) {
    const info = decodeScharnagl(scharnaglCode);
    const rank1 = info.pieceScheme.map(piece => piece * 2 + 0 /* ColorImpl.WHITE */);
    const rank8 = info.pieceScheme.map(piece => piece * 2 + 1 /* ColorImpl.BLACK */);
    return {
        board: [
            rank1[0], rank1[1], rank1[2], rank1[3], rank1[4], rank1[5], rank1[6], rank1[7], -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
            10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, 10 /* CpI.WP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
            -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
            -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
            -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
            -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -1 /* SpI.EMPTY */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
            11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, 11 /* CpI.BP */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */, -2 /* SpI.INVALID */,
            rank8[0], rank8[1], rank8[2], rank8[3], rank8[4], rank8[5], rank8[6], rank8[7],
        ],
        turn: 0 /* ColorImpl.WHITE */,
        castling: [info.castling, info.castling],
        enPassant: -1,
        variant: 1 /* GameVariantImpl.CHESS960 */,
        legal: true,
        king: [0 /* SquareImpl.A1 */ + info.kingFile, 112 /* SquareImpl.A8 */ + info.kingFile],
        effectiveCastling: [info.castling, info.castling],
        effectiveEnPassant: -1,
    };
}
exports.make960FromScharnagl = make960FromScharnagl;
/**
 * @param scharnaglCode - Integer between 0 and 959 inclusive.
 */
function decodeScharnagl(scharnaglCode) {
    const scheme = [-1, -1, -1, -1, -1, -1, -1, -1];
    let castling = 0;
    let kingFile = -1;
    function forEachEmpty(fun) {
        let emptyIndex = 0;
        for (let file = 0; file < 8; ++file) {
            if (scheme[file] >= 0) {
                continue;
            }
            fun(file, emptyIndex);
            ++emptyIndex;
        }
    }
    function setAt(piece, emptyIndexTarget1, emptyIndexTarget2) {
        forEachEmpty((file, emptyIndex) => {
            if (emptyIndex === emptyIndexTarget1 || emptyIndex === emptyIndexTarget2) {
                scheme[file] = piece;
            }
        });
    }
    // Light-square bishop
    scheme[(scharnaglCode % 4) * 2 + 1] = 3 /* PieceImpl.BISHOP */;
    scharnaglCode = Math.trunc(scharnaglCode / 4);
    // Dark-square bishop
    scheme[(scharnaglCode % 4) * 2] = 3 /* PieceImpl.BISHOP */;
    scharnaglCode = Math.trunc(scharnaglCode / 4);
    // Queen
    setAt(1 /* PieceImpl.QUEEN */, scharnaglCode % 6, -1);
    scharnaglCode = Math.trunc(scharnaglCode / 6);
    // Knights
    switch (scharnaglCode) { // `scharnaglCode` is guaranteed here to be between 0 and 9 inclusive
        case 0:
            setAt(4 /* PieceImpl.KNIGHT */, 0, 1);
            break;
        case 1:
            setAt(4 /* PieceImpl.KNIGHT */, 0, 2);
            break;
        case 2:
            setAt(4 /* PieceImpl.KNIGHT */, 0, 3);
            break;
        case 3:
            setAt(4 /* PieceImpl.KNIGHT */, 0, 4);
            break;
        case 4:
            setAt(4 /* PieceImpl.KNIGHT */, 1, 2);
            break;
        case 5:
            setAt(4 /* PieceImpl.KNIGHT */, 1, 3);
            break;
        case 6:
            setAt(4 /* PieceImpl.KNIGHT */, 1, 4);
            break;
        case 7:
            setAt(4 /* PieceImpl.KNIGHT */, 2, 3);
            break;
        case 8:
            setAt(4 /* PieceImpl.KNIGHT */, 2, 4);
            break;
        case 9:
            setAt(4 /* PieceImpl.KNIGHT */, 3, 4);
            break;
    }
    // Rooks and king
    forEachEmpty((file, emptyIndex) => {
        if (emptyIndex === 1) {
            scheme[file] = 0 /* PieceImpl.KING */;
            kingFile = file;
        }
        else {
            scheme[file] = 2 /* PieceImpl.ROOK */;
            castling |= 1 << file;
        }
    });
    return {
        pieceScheme: scheme,
        castling: castling,
        kingFile: kingFile
    };
}
function makeCopy(position) {
    return {
        board: position.board.slice(),
        turn: position.turn,
        castling: position.castling.slice(),
        enPassant: position.enPassant,
        variant: position.variant,
        legal: position.legal,
        king: position.king.slice(),
        effectiveCastling: position.effectiveCastling === null ? null : position.effectiveCastling.slice(),
        effectiveEnPassant: position.effectiveEnPassant,
    };
}
exports.makeCopy = makeCopy;

},{}],22:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEqual = exports.refreshEffectiveEnPassant = exports.refreshEffectiveCastling = exports.isKingSafeAfterMove = exports.refreshLegalFlagAndKingSquares = exports.isLegal = void 0;
const attacks_1 = require("./attacks");
/**
 * Check whether the given position is legal or not.
 *
 * See {@link Position.isLegal} for the description of the check points enforced in this function.
 */
function isLegal(position) {
    refreshLegalFlagAndKingSquares(position);
    return position.legal;
}
exports.isLegal = isLegal;
/**
 * Refresh the legal flag of the given position if it is set to null
 * (which means that the legality state of the position is unknown).
 *
 * Together with the legal flag, the reference to the squares where the white and
 * black kings lie is updated by this function.
 */
function refreshLegalFlagAndKingSquares(position) {
    if (position.legal !== null) {
        return;
    }
    position.legal = false;
    // Condition (1)
    const whiteKingOK = refreshKingSquare(position, 0 /* ColorImpl.WHITE */);
    const blackKingOK = refreshKingSquare(position, 1 /* ColorImpl.BLACK */);
    if (!whiteKingOK || !blackKingOK) {
        return;
    }
    // Extension of (1) for variants that allow a player to have no piece at all...
    if (position.variant === 5 /* GameVariantImpl.ANTICHESS */) {
        if (!hasAtLeastOnePiece(position, 1 - position.turn)) { // The player that has just played must have at least one piece in antichess.
            return;
        }
    }
    else if (position.variant === 6 /* GameVariantImpl.HORDE */) {
        if (position.turn === 1 /* ColorImpl.BLACK */ && !hasAtLeastOnePiece(position, 0 /* ColorImpl.WHITE */)) { // White must have at least one piece if he/she has just played in horde chess.
            return;
        }
    }
    // Condition (2)
    if (position.king[1 - position.turn] >= 0 && (0, attacks_1.isAttacked)(position, position.king[1 - position.turn], position.turn)) {
        return;
    }
    // Condition (3)
    const forbiddenCPWhite1 = position.variant === 6 /* GameVariantImpl.HORDE */ ? -2 /* SpI.INVALID */ : 10 /* CpI.WP */;
    for (let c = 0; c < 8; ++c) {
        const cp1 = position.board[0 /* SquareImpl.A1 */ + c];
        const cp8 = position.board[112 /* SquareImpl.A8 */ + c];
        if (cp1 === forbiddenCPWhite1 || cp8 === 10 /* CpI.WP */ || cp1 === 11 /* CpI.BP */ || cp8 === 11 /* CpI.BP */) {
            return;
        }
    }
    // At this point, all the conditions (1) to (4) hold, so the position can be flagged as legal.
    position.legal = true;
}
exports.refreshLegalFlagAndKingSquares = refreshLegalFlagAndKingSquares;
/**
 * Detect the kings of the given color that are present on the chess board.
 *
 * @returns `true` if the number of found king(s) corresponds is compatible with a legal position according to the given variant.
 */
function refreshKingSquare(position, color) {
    const target = 0 /* PieceImpl.KING */ * 2 + color;
    position.king[color] = -1;
    // Expectation: king may be present (even several times), and it has no royal power.
    if (position.variant === 5 /* GameVariantImpl.ANTICHESS */) {
        return true;
    }
    // Expectation: no king of the given color is supposed to be present on the board.
    else if (position.variant === 2 /* GameVariantImpl.NO_KING */ || position.variant === 4 /* GameVariantImpl.BLACK_KING_ONLY */ - color ||
        (position.variant === 6 /* GameVariantImpl.HORDE */ && color === 0 /* ColorImpl.WHITE */)) {
        for (let sq = 0; sq < 120; sq += (sq & 0x7) === 7 ? 9 : 1) {
            if (position.board[sq] === target) {
                return false;
            }
        }
        return true;
    }
    // Expectation: exactly 1 king of the given color is supposed to be present on the board, and it has royal power.
    else {
        for (let sq = 0; sq < 120; sq += (sq & 0x7) === 7 ? 9 : 1) {
            if (position.board[sq] === target) {
                // If the targeted king is detected on the square sq, two situations may occur:
                // 1) No king was detected on the previously visited squares: then the current
                //    square is saved, and loop over the next board squares goes on.
                if (position.king[color] < 0) {
                    position.king[color] = sq;
                }
                // 2) Another king was detected on the previously visited squares: then the buffer position.king[color]
                //    is set to the invalid state (-1), and the loop is interrupted.
                else {
                    position.king[color] = -1;
                    return false;
                }
            }
        }
        return position.king[color] >= 0;
    }
}
/**
 * Detect whether the player with the given color has at least one piece or not.
 */
function hasAtLeastOnePiece(position, color) {
    for (let sq = 0; sq < 120; sq += (sq & 0x7) === 7 ? 9 : 1) {
        if (position.board[sq] !== -1 /* SpI.EMPTY */ && position.board[sq] % 2 === color) {
            return true;
        }
    }
    return false;
}
/**
 * Check whether the current player king is in check after moving from `from` to `to`.
 *
 * This function implements the verification steps (7) to (9) as defined in {@link isMoveLegal}.
 *
 * Precondition: {@link refreshLegalFlagAndKingSquares} must have been invoked beforehand.
 *
 * @param enPassantSquare - Index of the square where the "en-passant" taken pawn lies if any, `-1` otherwise.
 */
function isKingSafeAfterMove(position, from, to, enPassantSquare = -1) {
    if (position.king[position.turn] < 0) {
        return true;
    }
    const fromContent = position.board[from];
    const toContent = position.board[to];
    const movingPiece = Math.trunc(fromContent / 2);
    // Step (7) -> Execute the displacement (castling moves are processed separately).
    position.board[to] = fromContent;
    position.board[from] = -1 /* SpI.EMPTY */;
    if (enPassantSquare >= 0) {
        position.board[enPassantSquare] = -1 /* SpI.EMPTY */;
    }
    // Step (8) -> Is the king safe after the displacement?
    try {
        return !(0, attacks_1.isAttacked)(position, movingPiece === 0 /* PieceImpl.KING */ ? to : position.king[position.turn], 1 - position.turn);
    }
    // Step (9) -> Reverse the displacement.
    finally {
        position.board[from] = fromContent;
        position.board[to] = toContent;
        if (enPassantSquare >= 0) {
            position.board[enPassantSquare] = 5 /* PieceImpl.PAWN */ * 2 + 1 - position.turn;
        }
    }
}
exports.isKingSafeAfterMove = isKingSafeAfterMove;
/**
 * Refresh the effective castling flags of the given position if they are set to null
 * (which means that their states are unknown).
 */
function refreshEffectiveCastling(position) {
    if (position.effectiveCastling !== null) {
        return;
    }
    // Detect the location of the king and make sure it has royal power.
    // (no royal power, no castling...)
    refreshLegalFlagAndKingSquares(position);
    // Actual computation.
    position.effectiveCastling = position.variant === 1 /* GameVariantImpl.CHESS960 */ ?
        [computeEffectiveCastlingForChess960(position, 0), computeEffectiveCastlingForChess960(position, 1)] :
        [computeEffectiveCastlingForRegularChess(position, 0), computeEffectiveCastlingForRegularChess(position, 1)];
}
exports.refreshEffectiveCastling = refreshEffectiveCastling;
function computeEffectiveCastlingForRegularChess(position, color) {
    const rankOffset = 112 * color;
    if (position.king[color] !== rankOffset + 4 || position.castling[color] === 0) {
        return 0;
    }
    const targetRook = 2 /* PieceImpl.ROOK */ * 2 + color;
    let result = 0;
    if ((position.castling[color] & 0x01) !== 0 && position.board[rankOffset] === targetRook) { // queen-side castling
        result |= 0x01;
    }
    if ((position.castling[color] & 0x80) !== 0 && position.board[rankOffset + 7] === targetRook) { // king-side castling
        result |= 0x80;
    }
    return result;
}
function computeEffectiveCastlingForChess960(position, color) {
    const rankOffset = 112 * color;
    if (position.king[color] <= rankOffset || position.king[color] >= rankOffset + 7 || position.castling[color] === 0) { // The king must not be in the corners.
        return 0;
    }
    const targetRook = 2 /* PieceImpl.ROOK */ * 2 + color;
    let result = 0;
    // Queen-side castling.
    let queenSideRookFile = -1;
    for (let file = position.king[color] % 16 - 1; file >= 0; --file) {
        if ((position.castling[color] & 1 << file) === 0 || position.board[rankOffset + file] !== targetRook) {
            continue;
        }
        if (queenSideRookFile < 0) {
            queenSideRookFile = file;
        }
        else {
            queenSideRookFile = -1;
            break;
        }
    }
    if (queenSideRookFile >= 0) {
        result |= 1 << queenSideRookFile;
    }
    // King-side castling.
    let kingSideRookFile = -1;
    for (let file = position.king[color] % 16 + 1; file < 8; ++file) {
        if ((position.castling[color] & 1 << file) === 0 || position.board[rankOffset + file] !== targetRook) {
            continue;
        }
        if (kingSideRookFile < 0) {
            kingSideRookFile = file;
        }
        else {
            kingSideRookFile = -1;
            break;
        }
    }
    if (kingSideRookFile >= 0) {
        result |= 1 << kingSideRookFile;
    }
    return result;
}
/**
 * Refresh the effective en-passant flag of the given position if it is set to null
 * (which means that its state is unknown).
 */
function refreshEffectiveEnPassant(position) {
    if (position.effectiveEnPassant !== null) {
        return;
    }
    position.effectiveEnPassant = -1;
    // If the en-passant flag is unset, so is the effective en-passant flag.
    if (position.enPassant < 0) {
        return;
    }
    // Geometric condition: for the effective en-passant flag to be set for instance to file E, assuming black is about to play:
    // - e2 and e3 must be empty,
    // - there must be a white pawn on e4,
    // - and there must be at least one black pawn on d4 or f4.
    const square2 = (6 - position.turn * 5) * 16 + position.enPassant;
    const square3 = (5 - position.turn * 3) * 16 + position.enPassant;
    const square4 = (4 - position.turn) * 16 + position.enPassant;
    const capturingPawn = 5 /* PieceImpl.PAWN */ * 2 + position.turn;
    const capturedPawn = 5 /* PieceImpl.PAWN */ * 2 + 1 - position.turn;
    if (position.board[square2] !== -1 /* SpI.EMPTY */ || position.board[square3] !== -1 /* SpI.EMPTY */ || position.board[square4] !== capturedPawn) {
        return;
    }
    const hasCapturingPawnBefore = ((square4 - 1) & 0x88) === 0 && position.board[square4 - 1] === capturingPawn;
    const hasCapturingPawnAfter = ((square4 + 1) & 0x88) === 0 && position.board[square4 + 1] === capturingPawn;
    if (!hasCapturingPawnBefore && !hasCapturingPawnAfter) {
        return;
    }
    // If en-passant is geometrically valid, ensure that it do not let the king in check.
    refreshLegalFlagAndKingSquares(position);
    if (!(hasCapturingPawnBefore && isKingSafeAfterMove(position, square4 - 1, square3, square4)) &&
        !(hasCapturingPawnAfter && isKingSafeAfterMove(position, square4 + 1, square3, square4))) {
        return;
    }
    // At this point, the en-passant flag can be considered as effective.
    position.effectiveEnPassant = position.enPassant;
}
exports.refreshEffectiveEnPassant = refreshEffectiveEnPassant;
function isEqual(pos1, pos2) {
    if (pos1.turn !== pos2.turn || pos1.variant !== pos2.variant) {
        return false;
    }
    for (let sq = 0; sq < 120; sq += (sq & 0x7) === 7 ? 9 : 1) {
        if (pos1.board[sq] !== pos2.board[sq]) {
            return false;
        }
    }
    // No check on `.legal` and `.king` as they are computed attributes.
    // Ignore `.castling`, compare `.effectiveCastling` instead.
    refreshEffectiveCastling(pos1);
    refreshEffectiveCastling(pos2);
    if (pos1.effectiveCastling[0 /* ColorImpl.WHITE */] !== pos2.effectiveCastling[0 /* ColorImpl.WHITE */] ||
        pos1.effectiveCastling[1 /* ColorImpl.BLACK */] !== pos2.effectiveCastling[1 /* ColorImpl.BLACK */]) {
        return false;
    }
    // Ignore `.enPassant`, compare `.effectiveEnPassant` instead.
    refreshEffectiveEnPassant(pos1);
    refreshEffectiveEnPassant(pos2);
    return pos1.effectiveEnPassant === pos2.effectiveEnPassant;
}
exports.isEqual = isEqual;

},{"./attacks":18}],23:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MoveDescriptorImpl = void 0;
const base_types_impl_1 = require("./base_types_impl");
const exception_1 = require("../exception");
const move_descriptor_1 = require("../move_descriptor");
const CASTLING_FLAG = 0x01;
const EN_PASSANT_FLAG = 0x02;
const CAPTURE_FLAG = 0x04;
const PROMOTION_FLAG = 0x08;
/**
 * Implementation of {@link MoveDescriptor}.
 */
class MoveDescriptorImpl extends move_descriptor_1.MoveDescriptor {
    /**
     * Instantiate a normal (aka. non-en-passant, non-promotion, non-castling) move.
     */
    static make(from, to, movingColoredPiece, capturedColoredPiece) {
        const flags = capturedColoredPiece === -1 /* SpI.EMPTY */ ? 0x00 : CAPTURE_FLAG;
        return new MoveDescriptorImpl(flags, from, to, movingColoredPiece, movingColoredPiece, capturedColoredPiece, -1, -1);
    }
    /**
     * Instantiate a castling move.
     */
    static makeCastling(from, to, rookFrom, rookTo, color) {
        const movingColoredKing = 0 /* PieceImpl.KING */ * 2 + color;
        const movingColoredRook = 2 /* PieceImpl.ROOK */ * 2 + color;
        return new MoveDescriptorImpl(CASTLING_FLAG, from, to, movingColoredKing, movingColoredKing, movingColoredRook, rookFrom, rookTo);
    }
    /**
     * Instantiate a *en-passant* capture.
     */
    static makeEnPassant(from, to, enPassantSquare, color) {
        const flags = EN_PASSANT_FLAG | CAPTURE_FLAG;
        const movingColoredPawn = 5 /* PieceImpl.PAWN */ * 2 + color;
        const capturedColoredPawn = 5 /* PieceImpl.PAWN */ * 2 + 1 - color;
        return new MoveDescriptorImpl(flags, from, to, movingColoredPawn, movingColoredPawn, capturedColoredPawn, enPassantSquare, -1);
    }
    /**
     * Instantiate a promotion.
     */
    static makePromotion(from, to, color, capturedColoredPiece, promotion) {
        const flags = PROMOTION_FLAG | (capturedColoredPiece === -1 /* SpI.EMPTY */ ? 0x00 : CAPTURE_FLAG);
        const movingColoredPawn = 5 /* PieceImpl.PAWN */ * 2 + color;
        const finalColoredPiece = promotion * 2 + color;
        return new MoveDescriptorImpl(flags, from, to, movingColoredPawn, finalColoredPiece, capturedColoredPiece, -1, -1);
    }
    constructor(flags, from, to, movingColoredPiece, finalColoredPiece, optionalColoredPiece, optionalSquare1, optionalSquare2) {
        super();
        this._flags = flags;
        this._from = from;
        this._to = to;
        this._movingColoredPiece = movingColoredPiece;
        this._finalColoredPiece = finalColoredPiece;
        this._optionalColoredPiece = optionalColoredPiece; // Captured (colored) piece in case of capture, moving (colored) rook in case of castling.
        this._optionalSquare1 = optionalSquare1; // Rook-from or en-passant square.
        this._optionalSquare2 = optionalSquare2; // Rook-to.
    }
    isCastling() {
        return (this._flags & CASTLING_FLAG) !== 0;
    }
    isEnPassant() {
        return (this._flags & EN_PASSANT_FLAG) !== 0;
    }
    isCapture() {
        return (this._flags & CAPTURE_FLAG) !== 0;
    }
    isPromotion() {
        return (this._flags & PROMOTION_FLAG) !== 0;
    }
    from() {
        return (0, base_types_impl_1.squareToString)(this._from);
    }
    to() {
        return (0, base_types_impl_1.squareToString)(this._to);
    }
    color() {
        return (0, base_types_impl_1.colorToString)(this._movingColoredPiece % 2);
    }
    movingPiece() {
        return (0, base_types_impl_1.pieceToString)(Math.trunc(this._movingColoredPiece / 2));
    }
    movingColoredPiece() {
        return (0, base_types_impl_1.coloredPieceToString)(this._movingColoredPiece);
    }
    capturedPiece() {
        if (!this.isCapture()) {
            throw new exception_1.IllegalArgument('MoveDescriptor.capturedPiece()');
        }
        return (0, base_types_impl_1.pieceToString)(Math.trunc(this._optionalColoredPiece / 2));
    }
    capturedColoredPiece() {
        if (!this.isCapture()) {
            throw new exception_1.IllegalArgument('MoveDescriptor.capturedColoredPiece()');
        }
        return (0, base_types_impl_1.coloredPieceToString)(this._optionalColoredPiece);
    }
    rookFrom() {
        if (!this.isCastling()) {
            throw new exception_1.IllegalArgument('MoveDescriptor.rookFrom()');
        }
        return (0, base_types_impl_1.squareToString)(this._optionalSquare1);
    }
    rookTo() {
        if (!this.isCastling()) {
            throw new exception_1.IllegalArgument('MoveDescriptor.rookTo()');
        }
        return (0, base_types_impl_1.squareToString)(this._optionalSquare2);
    }
    enPassantSquare() {
        if (!this.isEnPassant()) {
            throw new exception_1.IllegalArgument('MoveDescriptor.enPassantSquare()');
        }
        return (0, base_types_impl_1.squareToString)(this._optionalSquare1);
    }
    promotion() {
        if (!this.isPromotion()) {
            throw new exception_1.IllegalArgument('MoveDescriptor.promotion()');
        }
        return (0, base_types_impl_1.pieceToString)(Math.trunc(this._finalColoredPiece / 2));
    }
    coloredPromotion() {
        if (!this.isPromotion()) {
            throw new exception_1.IllegalArgument('MoveDescriptor.coloredPromotion()');
        }
        return (0, base_types_impl_1.coloredPieceToString)(this._finalColoredPiece);
    }
}
exports.MoveDescriptorImpl = MoveDescriptorImpl;

},{"../exception":3,"../move_descriptor":8,"./base_types_impl":19}],24:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.playNullMove = exports.isNullMoveLegal = exports.play = exports.isMoveLegal = exports.isCastlingMoveLegal = exports.isCaptureMandatory = exports.moves = exports.hasMove = exports.isDead = exports.isStalemate = exports.isCheckmate = exports.isCheck = void 0;
const attacks_1 = require("./attacks");
const base_types_impl_1 = require("./base_types_impl");
const legality_1 = require("./legality");
const move_descriptor_impl_1 = require("./move_descriptor_impl");
/* eslint-disable no-mixed-spaces-and-tabs, indent */
/**
 * Displacement lookup per square index difference.
 */
const DISPLACEMENT_LOOKUP = [
    204, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 204, 0,
    0, 204, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 204, 0, 0,
    0, 0, 204, 0, 0, 0, 0, 60, 0, 0, 0, 0, 204, 0, 0, 0,
    0, 0, 0, 204, 0, 0, 0, 60, 0, 0, 0, 204, 0, 0, 0, 0,
    0, 0, 0, 0, 204, 0, 0, 60, 0, 0, 204, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 204, 768, 60, 768, 204, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 768, 2255, 2111, 2255, 768, 0, 0, 0, 0, 0, 0,
    60, 60, 60, 60, 60, 60, 63, 0, 63, 60, 60, 60, 60, 60, 60, 0,
    0, 0, 0, 0, 0, 768, 1231, 1087, 1231, 768, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 204, 768, 60, 768, 204, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 204, 0, 0, 60, 0, 0, 204, 0, 0, 0, 0, 0,
    0, 0, 0, 204, 0, 0, 0, 60, 0, 0, 0, 204, 0, 0, 0, 0,
    0, 0, 204, 0, 0, 0, 0, 60, 0, 0, 0, 0, 204, 0, 0, 0,
    0, 204, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 204, 0, 0,
    204, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 204, 0
];
/**
 * Sliding direction
 */
const SLIDING_DIRECTION = [
    -17, 0, 0, 0, 0, 0, 0, -16, 0, 0, 0, 0, 0, 0, -15, 0,
    0, -17, 0, 0, 0, 0, 0, -16, 0, 0, 0, 0, 0, -15, 0, 0,
    0, 0, -17, 0, 0, 0, 0, -16, 0, 0, 0, 0, -15, 0, 0, 0,
    0, 0, 0, -17, 0, 0, 0, -16, 0, 0, 0, -15, 0, 0, 0, 0,
    0, 0, 0, 0, -17, 0, 0, -16, 0, 0, -15, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, -17, 0, -16, 0, -15, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, -17, -16, -15, 0, 0, 0, 0, 0, 0, 0,
    -1, -1, -1, -1, -1, -1, -1, 0, 1, 1, 1, 1, 1, 1, 1, 0,
    0, 0, 0, 0, 0, 0, 15, 16, 17, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 15, 0, 16, 0, 17, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 15, 0, 0, 16, 0, 0, 17, 0, 0, 0, 0, 0,
    0, 0, 0, 15, 0, 0, 0, 16, 0, 0, 0, 17, 0, 0, 0, 0,
    0, 0, 15, 0, 0, 0, 0, 16, 0, 0, 0, 0, 17, 0, 0, 0,
    0, 15, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 17, 0, 0,
    15, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 17, 0
];
/* eslint-enable no-mixed-spaces-and-tabs, indent */
/**
 * Whether there is at least one piece with the given color in the given position.
 */
function hasAtLeastOnePiece(position, color) {
    for (let sq = 0; sq < 120; sq += (sq & 0x7) === 7 ? 9 : 1) {
        if (position.board[sq] !== -1 /* SpI.EMPTY */ && position.board[sq] % 2 === color) {
            return true;
        }
    }
    return false;
}
/**
 * Return `true` if the king of the player to play HAS ROYAL POWER and IS ATTACKED.
 */
function isKingToMoveAttacked(position) {
    return position.king[position.turn] >= 0 && (0, attacks_1.isAttacked)(position, position.king[position.turn], 1 - position.turn);
}
/**
 * Whether the given position is legal and the player to play is in check.
 */
function isCheck(position) {
    return (0, legality_1.isLegal)(position) && isKingToMoveAttacked(position);
}
exports.isCheck = isCheck;
/**
 * Whether the given position is legal and the player to play is checkmated.
 */
function isCheckmate(position) {
    if (!(0, legality_1.isLegal)(position) || hasMove(position)) {
        return false;
    }
    if (position.variant === 5 /* GameVariantImpl.ANTICHESS */) {
        return true;
    }
    else if (position.variant === 6 /* GameVariantImpl.HORDE */ && position.turn === 0 /* ColorImpl.WHITE */) {
        return !hasAtLeastOnePiece(position, 0 /* ColorImpl.WHITE */);
    }
    else {
        return isKingToMoveAttacked(position);
    }
}
exports.isCheckmate = isCheckmate;
/**
 * Whether the given position is legal and the player to play is stalemated.
 */
function isStalemate(position) {
    if (!(0, legality_1.isLegal)(position) || hasMove(position)) {
        return false;
    }
    if (position.variant === 5 /* GameVariantImpl.ANTICHESS */) {
        return true;
    }
    else if (position.variant === 6 /* GameVariantImpl.HORDE */ && position.turn === 0 /* ColorImpl.WHITE */) {
        return hasAtLeastOnePiece(position, 0 /* ColorImpl.WHITE */);
    }
    else {
        return !isKingToMoveAttacked(position);
    }
}
exports.isStalemate = isStalemate;
/**
 * Whether the given position is legal and there is insufficient material on board for checkmate.
 */
function isDead(position, uscfRules) {
    if (!(0, legality_1.isLegal)(position)) {
        return false;
    }
    if (position.variant === 0 /* GameVariantImpl.REGULAR_CHESS */ || position.variant === 1 /* GameVariantImpl.CHESS960 */) {
        return uscfRules ? isDeadWithUSCFRules(position) : isDeadWithFIDERules(position);
    }
    else {
        return false;
    }
}
exports.isDead = isDead;
function isDeadWithFIDERules(position) {
    let bishopOrKnightAlreadyFound = false;
    let bishopSquareColor = -1;
    for (let sq = 0; sq < 120; sq += (sq & 0x7) === 7 ? 9 : 1) {
        const cp = position.board[sq];
        if (cp === -1 /* SpI.EMPTY */) {
            continue;
        }
        const piece = Math.trunc(cp / 2);
        // Ignore any bishop if another bishop has already been found on a square of the same color.
        if (piece === 3 /* PieceImpl.BISHOP */) {
            const currentSquareColor = (0, base_types_impl_1.squareColorImpl)(sq);
            if (bishopSquareColor === currentSquareColor) {
                continue;
            }
            bishopSquareColor = currentSquareColor;
        }
        // Ensure that at most 1 bishop or knight is encountered, whatever its color.
        if (piece === 3 /* PieceImpl.BISHOP */ || piece === 4 /* PieceImpl.KNIGHT */) {
            if (bishopOrKnightAlreadyFound) {
                return false;
            }
            bishopOrKnightAlreadyFound = true;
        }
        // Not a dead position if a pawn, a rook or a queen is encountered.
        else if (piece !== 0 /* PieceImpl.KING */) {
            return false;
        }
    }
    return true;
}
function isDeadWithUSCFRules(position) {
    const materialScore = [0, 0];
    const bishopSquareColor = [-1, -1];
    for (let sq = 0; sq < 120; sq += (sq & 0x7) === 7 ? 9 : 1) {
        const cp = position.board[sq];
        if (cp === -1 /* SpI.EMPTY */) {
            continue;
        }
        const color = cp % 2;
        const piece = Math.trunc(cp / 2);
        // Ignore any bishop if another bishop of the same color has already been found on a square of the same color.
        if (piece === 3 /* PieceImpl.BISHOP */) {
            const currentSquareColor = (0, base_types_impl_1.squareColorImpl)(sq);
            if (bishopSquareColor[color] === currentSquareColor) {
                continue;
            }
            bishopSquareColor[color] = currentSquareColor;
        }
        // Increase score by 1 for a knight, and by 2 for a bishop. A score of 3 (or more) for any player means that the position is not dead.
        if (piece === 3 /* PieceImpl.BISHOP */ || piece === 4 /* PieceImpl.KNIGHT */) {
            materialScore[color] += piece === 3 /* PieceImpl.BISHOP */ ? 2 : 1;
            if (materialScore[color] >= 3) {
                return false;
            }
        }
        // Not a dead position if a pawn, a rook or a queen is encountered.
        else if (piece !== 0 /* PieceImpl.KING */) {
            return false;
        }
    }
    return true;
}
/**
 * Whether there is at least 1 possible move in the given position.
 *
 * @returns `false` if the position is not legal.
 */
function hasMove(position) {
    class MoveFound {
    }
    try {
        generateMoves(position, () => { throw new MoveFound(); });
        return false;
    }
    catch (err) {
        // istanbul ignore else
        if (err instanceof MoveFound) {
            return true;
        }
        else {
            throw err;
        }
    }
}
exports.hasMove = hasMove;
/**
 * Return all the legal moves in the given position.
 */
function moves(position) {
    const result = [];
    generateMoves(position, moveDescriptor => { result.push(moveDescriptor); });
    return result;
}
exports.moves = moves;
/**
 * Generate all the legal moves of the given position.
 */
function generateMoves(position, moveDescriptorConsumer) {
    // Ensure that the position is legal.
    if (!(0, legality_1.isLegal)(position)) {
        return;
    }
    // In some variants, capture may be mandatory (typically in antichess).
    const nonCaptureIsAllowed = !isCaptureMandatory(position);
    // Generate castling moves
    (0, legality_1.refreshEffectiveCastling)(position);
    if (nonCaptureIsAllowed && position.effectiveCastling[position.turn] !== 0) {
        const rankOffset = 112 * position.turn;
        for (let file = 0; file < 8; ++file) {
            if ((position.effectiveCastling[position.turn] & 1 << file) !== 0) {
                const rookFrom = rankOffset + file;
                const rookTo = rankOffset + (rookFrom < position.king[position.turn] ? 3 : 5);
                const to = rankOffset + (rookFrom < position.king[position.turn] ? 2 : 6);
                if (isCastlingLegal(position, position.king[position.turn], to, rookFrom, rookTo)) {
                    moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.makeCastling(position.king[position.turn], to, rookFrom, rookTo, position.turn));
                }
            }
        }
    }
    // Generate en-passant captures
    (0, legality_1.refreshEffectiveEnPassant)(position);
    if (position.effectiveEnPassant >= 0) {
        const square3 = (5 - position.turn * 3) * 16 + position.effectiveEnPassant;
        const square4 = (4 - position.turn) * 16 + position.effectiveEnPassant;
        const capturingPawn = 5 /* PieceImpl.PAWN */ * 2 + position.turn;
        if (((square4 - 1) & 0x88) === 0 && position.board[square4 - 1] === capturingPawn && (0, legality_1.isKingSafeAfterMove)(position, square4 - 1, square3, square4)) {
            moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.makeEnPassant(square4 - 1, square3, square4, position.turn));
        }
        if (((square4 + 1) & 0x88) === 0 && position.board[square4 + 1] === capturingPawn && (0, legality_1.isKingSafeAfterMove)(position, square4 + 1, square3, square4)) {
            moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.makeEnPassant(square4 + 1, square3, square4, position.turn));
        }
    }
    // For all potential 'from' square...
    for (let from = 0; from < 120; from += (from & 0x7) === 7 ? 9 : 1) {
        // Nothing to do if the current square does not contain a piece of the right color.
        const fromContent = position.board[from];
        const movingPiece = Math.trunc(fromContent / 2);
        if (fromContent === -1 /* SpI.EMPTY */ || fromContent % 2 !== position.turn) {
            continue;
        }
        // Generate moves for pawns
        if (movingPiece === 5 /* PieceImpl.PAWN */) {
            // Regular capturing moves (en-passant not handled here)
            const attackDirections = attacks_1.ATTACK_DIRECTIONS[fromContent];
            for (let i = 0; i < attackDirections.length; ++i) {
                const to = from + attackDirections[i];
                if ((to & 0x88) === 0 && position.board[to] !== -1 /* SpI.EMPTY */ && position.board[to] % 2 !== position.turn && (0, legality_1.isKingSafeAfterMove)(position, from, to)) {
                    generateRegularPawnMoveOrPromotion(position, from, to, moveDescriptorConsumer);
                }
            }
            // Non-capturing moves
            if (nonCaptureIsAllowed) {
                const moveDirection = 16 - position.turn * 32;
                let to = from + moveDirection;
                if (position.board[to] === -1 /* SpI.EMPTY */) {
                    if ((0, legality_1.isKingSafeAfterMove)(position, from, to)) {
                        generateRegularPawnMoveOrPromotion(position, from, to, moveDescriptorConsumer);
                    }
                    // 2-square pawn move
                    const firstSquareOfArea = position.turn * 96; // a1 for white, a7 for black (2-square pawn move is allowed from 1st row at horde chess)
                    if (from >= firstSquareOfArea && from < firstSquareOfArea + 24) {
                        to += moveDirection;
                        if (position.board[to] === -1 /* SpI.EMPTY */ && (0, legality_1.isKingSafeAfterMove)(position, from, to)) {
                            moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.make(from, to, fromContent, -1 /* SpI.EMPTY */));
                        }
                    }
                }
            }
        }
        // Generate moves for non-sliding non-pawn pieces
        else if (movingPiece === 4 /* PieceImpl.KNIGHT */ || movingPiece === 0 /* PieceImpl.KING */) {
            const directions = attacks_1.ATTACK_DIRECTIONS[fromContent];
            for (let i = 0; i < directions.length; ++i) {
                const to = from + directions[i];
                if ((to & 0x88) === 0) {
                    const toContent = position.board[to];
                    if ((toContent === -1 /* SpI.EMPTY */ ? nonCaptureIsAllowed : toContent % 2 !== position.turn) && (0, legality_1.isKingSafeAfterMove)(position, from, to)) {
                        moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.make(from, to, fromContent, toContent));
                    }
                }
            }
        }
        // Generate moves for sliding pieces
        else {
            const directions = attacks_1.ATTACK_DIRECTIONS[fromContent];
            for (let i = 0; i < directions.length; ++i) {
                for (let to = from + directions[i]; (to & 0x88) === 0; to += directions[i]) {
                    const toContent = position.board[to];
                    if ((toContent === -1 /* SpI.EMPTY */ ? nonCaptureIsAllowed : toContent % 2 !== position.turn) && (0, legality_1.isKingSafeAfterMove)(position, from, to)) {
                        moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.make(from, to, fromContent, toContent));
                    }
                    if (toContent !== -1 /* SpI.EMPTY */) {
                        break;
                    }
                }
            }
        }
    }
}
/**
 * Generate the move descriptors corresponding to a pawn move from `from` to `to`, excluding 2-square pawn moves and en-passant captures.
 */
function generateRegularPawnMoveOrPromotion(position, from, to, moveDescriptorConsumer) {
    const toContent = position.board[to];
    if (to < 8 || to >= 112) {
        moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.makePromotion(from, to, position.turn, toContent, 1 /* PieceImpl.QUEEN */));
        moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.makePromotion(from, to, position.turn, toContent, 2 /* PieceImpl.ROOK */));
        moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.makePromotion(from, to, position.turn, toContent, 3 /* PieceImpl.BISHOP */));
        moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.makePromotion(from, to, position.turn, toContent, 4 /* PieceImpl.KNIGHT */));
        if (position.variant === 5 /* GameVariantImpl.ANTICHESS */) {
            moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.makePromotion(from, to, position.turn, toContent, 0 /* PieceImpl.KING */));
        }
    }
    else {
        moveDescriptorConsumer(move_descriptor_impl_1.MoveDescriptorImpl.make(from, to, 5 /* PieceImpl.PAWN */ * 2 + position.turn, toContent));
    }
}
/**
 * For antichess, return `true` if the current player can capture something. For other variants, always returns `false`.
 *
 * Precondition: the position must be legal.
 */
function isCaptureMandatory(position) {
    if (position.variant !== 5 /* GameVariantImpl.ANTICHESS */) {
        return false;
    }
    // Look for regular captures
    for (let sq = 0; sq < 120; sq += (sq & 0x7) === 7 ? 9 : 1) {
        const cp = position.board[sq];
        if (cp !== -1 /* SpI.EMPTY */ && cp % 2 !== position.turn && (0, attacks_1.isAttacked)(position, sq, position.turn)) {
            return true;
        }
    }
    // Look for "en-passant" captures
    (0, legality_1.refreshEffectiveEnPassant)(position);
    if (position.effectiveEnPassant >= 0) {
        return true;
    }
    return false;
}
exports.isCaptureMandatory = isCaptureMandatory;
/**
 * Delegated method for checking whether a castling move is legal or not. WARNING: in case of Chess960, `to` represents the origin square of the rook (KxR).
 *
 * Precondition: {@link refreshEffectiveCastling} must have been invoked beforehand.
 */
function isCastlingMoveLegal(position, from, to) {
    let rookFrom = -1;
    let rookTo = -1;
    // Validate `from` and `to`, check the castling flags, and compute the origin and destination squares of the rook.
    if (position.variant === 1 /* GameVariantImpl.CHESS960 */) {
        const castleFile = to % 16;
        const castleRank = Math.trunc(to / 16);
        if (castleRank !== position.turn * 7 || (position.effectiveCastling[position.turn] & (1 << castleFile)) === 0) {
            return false;
        }
        rookFrom = to;
        rookTo = (from > to ? 3 : 5) + 112 * position.turn;
        to = (from > to ? 2 : 6) + 112 * position.turn;
    }
    else if (to === 2 + position.turn * 112) { // queen-side castling
        if ((position.effectiveCastling[position.turn] & 1) === 0) {
            return false;
        }
        rookFrom = 112 * position.turn;
        rookTo = 3 + 112 * position.turn;
    }
    else if (to === 6 + position.turn * 112) { // king-side castling
        if ((position.effectiveCastling[position.turn] & (1 << 7)) === 0) {
            return false;
        }
        rookFrom = 7 + 112 * position.turn;
        rookTo = 5 + 112 * position.turn;
    }
    else {
        return false;
    }
    // Generate the descriptor if the castling is actually legal.
    return isCastlingLegal(position, from, to, rookFrom, rookTo) ? move_descriptor_impl_1.MoveDescriptorImpl.makeCastling(from, to, rookFrom, rookTo, position.turn) : false;
}
exports.isCastlingMoveLegal = isCastlingMoveLegal;
function isCastlingLegal(position, from, to, rookFrom, rookTo) {
    // Free the king and rook square (mandatory for attack detection).
    position.board[from] = -1 /* SpI.EMPTY */;
    position.board[rookFrom] = -1 /* SpI.EMPTY */;
    try {
        // Ensure that each square on the trajectory is empty.
        for (let sq = Math.min(from, to, rookFrom, rookTo); sq <= Math.max(from, to, rookFrom, rookTo); ++sq) {
            if (position.board[sq] !== -1 /* SpI.EMPTY */) {
                return false;
            }
        }
        // The origin and destination squares of the king, and the square between them must not be attacked.
        const byWho = 1 - position.turn;
        for (let sq = Math.min(from, to); sq <= Math.max(from, to); ++sq) {
            if ((0, attacks_1.isAttacked)(position, sq, byWho)) {
                return false;
            }
        }
        // OK, the castling is legal.
        return true;
    }
    finally {
        position.board[from] = 0 /* PieceImpl.KING */ * 2 + position.turn;
        position.board[rookFrom] = 2 /* PieceImpl.ROOK */ * 2 + position.turn;
    }
}
/**
 * Core algorithm to determine whether a move is legal or not. The verification flow is the following:
 *
 *  1. Ensure that the position itself is legal.
 *  2. Ensure that the origin square contains a piece (denoted as the moving-piece)
 *     whose color is the same than the color of the player about to play.
 *  3. Special routine for castling detection.
 *  4. Ensure that the displacement is geometrically correct, with respect to the moving piece.
 *  5. Check the content of the destination square.
 *  6. For the sliding pieces (and in case of a 2-square pawn move), ensure that there is no piece
 *     on the trajectory.
 *
 * The move is almost ensured to be legal at this point. The last condition to check
 * is whether the king of the current player will be in check after the move or not.
 *
 *  7. Execute the displacement from the origin to the destination square, in such a way that
 *     it can be reversed. Only the state of the board is updated at this point.
 *  8. Look for king attacks.
 *  9. Reverse the displacement.
 */
function isMoveLegal(position, from, to) {
    // Step (1)
    if (!(0, legality_1.isLegal)(position)) {
        return false;
    }
    // Step (2)
    const fromContent = position.board[from];
    const toContent = position.board[to];
    const movingPiece = Math.trunc(fromContent / 2);
    if (fromContent === -1 /* SpI.EMPTY */ || fromContent % 2 !== position.turn) {
        return false;
    }
    // Miscellaneous variables
    const displacement = to - from + 119;
    let enPassantSquare = -1; // square where a pawn is taken if the move is "en-passant"
    let isTwoSquarePawnMove = false;
    const isPromotion = movingPiece === 5 /* PieceImpl.PAWN */ && (to < 8 || to >= 112);
    const captureIsMandatory = isCaptureMandatory(position);
    // Step (3) - Castling detection.
    if (movingPiece === 0 /* PieceImpl.KING */ && !captureIsMandatory) {
        (0, legality_1.refreshEffectiveCastling)(position);
        if (position.effectiveCastling[position.turn] !== 0) {
            const castlingDescriptor = isCastlingMoveLegal(position, from, to);
            if (castlingDescriptor) {
                return {
                    type: 'regular',
                    moveDescriptor: castlingDescriptor,
                };
            }
        }
    }
    // Step (4)
    if ((DISPLACEMENT_LOOKUP[displacement] & 1 << fromContent) === 0) {
        if (movingPiece === 5 /* PieceImpl.PAWN */ && displacement === 151 - position.turn * 64) {
            const firstSquareOfArea = position.turn * 96; // a1 for white, a7 for black (2-square pawn move is allowed from 1st row at horde chess)
            if (from < firstSquareOfArea || from >= firstSquareOfArea + 24) {
                return false;
            }
            isTwoSquarePawnMove = true;
        }
        else {
            return false;
        }
    }
    // Step (5) -> check the content of the destination square
    if (movingPiece === 5 /* PieceImpl.PAWN */) {
        (0, legality_1.refreshEffectiveEnPassant)(position);
        if (displacement === 135 - position.turn * 32 || isTwoSquarePawnMove) { // non-capturing pawn move
            if (captureIsMandatory || toContent !== -1 /* SpI.EMPTY */) {
                return false;
            }
        }
        else if (toContent === -1 /* SpI.EMPTY */) { // en-passant pawn move
            if (to !== (5 - position.turn * 3) * 16 + position.effectiveEnPassant) {
                return false;
            }
            enPassantSquare = (4 - position.turn) * 16 + position.effectiveEnPassant;
        }
        else { // regular capturing pawn move
            if (toContent % 2 === position.turn) {
                return false;
            }
        }
    }
    else { // piece move
        if (toContent === -1 /* SpI.EMPTY */ ? captureIsMandatory : toContent % 2 === position.turn) {
            return false;
        }
    }
    // Step (6) -> For sliding pieces, ensure that there is nothing between the origin and the destination squares.
    if (movingPiece === 3 /* PieceImpl.BISHOP */ || movingPiece === 2 /* PieceImpl.ROOK */ || movingPiece === 1 /* PieceImpl.QUEEN */) {
        const direction = SLIDING_DIRECTION[displacement];
        for (let sq = from + direction; sq !== to; sq += direction) {
            if (position.board[sq] !== -1 /* SpI.EMPTY */) {
                return false;
            }
        }
    }
    else if (isTwoSquarePawnMove) { // two-square pawn moves also require this test.
        if (position.board[(from + to) / 2] !== -1 /* SpI.EMPTY */) {
            return false;
        }
    }
    // Steps (7) to (9) are delegated to `isKingSafeAfterMove`.
    if (!(0, legality_1.isKingSafeAfterMove)(position, from, to, enPassantSquare)) {
        return false;
    }
    if (isPromotion) {
        return {
            type: 'promotion',
            moveDescriptorFactory: buildPromotionMoveDescriptor(from, to, position.variant, position.turn, toContent),
        };
    }
    else {
        return {
            type: 'regular',
            moveDescriptor: enPassantSquare >= 0 ? move_descriptor_impl_1.MoveDescriptorImpl.makeEnPassant(from, to, enPassantSquare, position.turn) :
                move_descriptor_impl_1.MoveDescriptorImpl.make(from, to, fromContent, toContent),
        };
    }
}
exports.isMoveLegal = isMoveLegal;
function buildPromotionMoveDescriptor(from, to, variant, color, capturedColoredPiece) {
    return promotion => {
        if (promotion === 5 /* PieceImpl.PAWN */ || (promotion === 0 /* PieceImpl.KING */ && variant !== 5 /* GameVariantImpl.ANTICHESS */)) {
            return false;
        }
        return move_descriptor_impl_1.MoveDescriptorImpl.makePromotion(from, to, color, capturedColoredPiece, promotion);
    };
}
/**
 * Play the move corresponding to the given descriptor.
 */
function play(position, descriptor) {
    (0, legality_1.refreshEffectiveCastling)(position);
    // Update the board.
    position.board[descriptor._from] = -1 /* SpI.EMPTY */; // WARNING: update `from` before `to` in case both squares are actually the same!
    if (descriptor.isEnPassant()) {
        position.board[descriptor._optionalSquare1] = -1 /* SpI.EMPTY */;
    }
    else if (descriptor.isCastling()) {
        position.board[descriptor._optionalSquare1] = -1 /* SpI.EMPTY */;
        position.board[descriptor._optionalSquare2] = descriptor._optionalColoredPiece;
    }
    position.board[descriptor._to] = descriptor._finalColoredPiece;
    const movingPiece = Math.trunc(descriptor._movingColoredPiece / 2);
    // Update the castling flags.
    if (movingPiece === 0 /* PieceImpl.KING */) {
        position.effectiveCastling[position.turn] = 0;
    }
    if (descriptor._from < 8) {
        position.effectiveCastling[0 /* ColorImpl.WHITE */] &= ~(1 << descriptor._from);
    }
    if (descriptor._to < 8) {
        position.effectiveCastling[0 /* ColorImpl.WHITE */] &= ~(1 << descriptor._to);
    }
    if (descriptor._from >= 112) {
        position.effectiveCastling[1 /* ColorImpl.BLACK */] &= ~(1 << (descriptor._from % 16));
    }
    if (descriptor._to >= 112) {
        position.effectiveCastling[1 /* ColorImpl.BLACK */] &= ~(1 << (descriptor._to % 16));
    }
    position.castling[0 /* ColorImpl.WHITE */] = position.effectiveCastling[0 /* ColorImpl.WHITE */];
    position.castling[1 /* ColorImpl.BLACK */] = position.effectiveCastling[1 /* ColorImpl.BLACK */];
    // Update the en-passant flag.
    position.enPassant = -1;
    position.effectiveEnPassant = -1;
    if (movingPiece === 5 /* PieceImpl.PAWN */ && Math.abs(descriptor._from - descriptor._to) === 32) {
        const firstSquareOf2ndRow = (1 + 5 * position.turn) * 16;
        if (descriptor._from >= firstSquareOf2ndRow && descriptor._from < firstSquareOf2ndRow + 8) {
            const otherPawn = descriptor._movingColoredPiece ^ 0x01;
            if ((((descriptor._to - 1) & 0x88) === 0 && position.board[descriptor._to - 1] === otherPawn) ||
                (((descriptor._to + 1) & 0x88) === 0 && position.board[descriptor._to + 1] === otherPawn)) {
                position.enPassant = descriptor._to % 16;
                position.effectiveEnPassant = null; // Only geometric conditions have been validated so far.
            }
        }
    }
    // Update the computed flags.
    if (movingPiece === 0 /* PieceImpl.KING */ && position.king[position.turn] >= 0) {
        position.king[position.turn] = descriptor._to;
    }
    // Toggle the turn flag.
    position.turn = 1 - position.turn;
}
exports.play = play;
/**
 * Determine if a null-move (i.e. switching the player about to play) can be played in the current position.
 * A null-move is possible if the position is legal and if the current player about to play is not in check.
 */
function isNullMoveLegal(position) {
    return (0, legality_1.isLegal)(position) && !isKingToMoveAttacked(position);
}
exports.isNullMoveLegal = isNullMoveLegal;
/**
 * Play a null-move on the current position if it is legal.
 *
 * @returns `true` if the null-move has actually been played.
 */
function playNullMove(position) {
    if (isNullMoveLegal(position)) {
        position.turn = 1 - position.turn;
        position.enPassant = -1;
        position.effectiveEnPassant = -1;
        return true;
    }
    else {
        return false;
    }
}
exports.playNullMove = playNullMove;

},{"./attacks":18,"./base_types_impl":19,"./legality":22,"./move_descriptor_impl":23}],25:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseNotation = exports.getNotation = void 0;
const attacks_1 = require("./attacks");
const base_types_impl_1 = require("./base_types_impl");
const fen_1 = require("./fen");
const impl_1 = require("./impl");
const legality_1 = require("./legality");
const move_descriptor_impl_1 = require("./move_descriptor_impl");
const move_generation_1 = require("./move_generation");
const exception_1 = require("../exception");
const i18n_1 = require("../i18n");
/**
 * Convert the given move descriptor to standard algebraic notation.
 */
function getNotation(position, descriptor, pieceStyle) {
    let result = '';
    // Castling move
    if (descriptor.isCastling()) {
        result = descriptor._to % 16 === 6 ? 'O-O' : 'O-O-O';
    }
    // Pawn move
    else if (Math.trunc(descriptor._movingColoredPiece / 2) === 5 /* PieceImpl.PAWN */) {
        if (descriptor.isCapture()) {
            result += (0, base_types_impl_1.fileToString)(descriptor._from % 16) + 'x';
        }
        result += (0, base_types_impl_1.squareToString)(descriptor._to);
        if (descriptor.isPromotion()) {
            result += '=' + getPieceSymbol(descriptor._finalColoredPiece, pieceStyle);
        }
    }
    // Non-pawn move
    else {
        result += getPieceSymbol(descriptor._movingColoredPiece, pieceStyle);
        result += getDisambiguationSymbol(position, descriptor._from, descriptor._to);
        if (descriptor.isCapture()) {
            result += 'x';
        }
        result += (0, base_types_impl_1.squareToString)(descriptor._to);
    }
    // Check/checkmate detection and final result.
    result += getCheckCheckmateSymbol(position, descriptor);
    return result;
}
exports.getNotation = getNotation;
/**
 * Return a string representing the given chess piece according to the given style.
 */
function getPieceSymbol(coloredPiece, pieceStyle) {
    switch (pieceStyle) {
        case 'figurine':
            return (0, base_types_impl_1.figurineToString)(coloredPiece);
        case 'standard':
            return (0, base_types_impl_1.pieceToString)(Math.trunc(coloredPiece / 2)).toUpperCase();
    }
}
/**
 * Return the check/checkmate symbol to use for a move.
 */
function getCheckCheckmateSymbol(position, descriptor) {
    const nextPosition = (0, impl_1.makeCopy)(position);
    (0, move_generation_1.play)(nextPosition, descriptor);
    return (0, move_generation_1.isCheckmate)(nextPosition) ? '#' : (0, move_generation_1.isCheck)(nextPosition) ? '+' : '';
}
/**
 * Return the disambiguation symbol to use for a move from `from` to `to`.
 */
function getDisambiguationSymbol(position, from, to) {
    const attackers = (0, attacks_1.getAttacks)(position, to, position.turn).filter(sq => position.board[sq] === position.board[from]);
    // Disambiguation is not necessary if there less than 2 attackers.
    if (attackers.length < 2) {
        return '';
    }
    let foundNotPined = false;
    let foundOnSameRank = false;
    let foundOnSameFile = false;
    const rankFrom = Math.trunc(from / 16);
    const fileFrom = from % 16;
    for (let i = 0; i < attackers.length; ++i) {
        const sq = attackers[i];
        if (sq === from || isPinned(position, sq, to)) {
            continue;
        }
        foundNotPined = true;
        if (rankFrom === Math.trunc(sq / 16)) {
            foundOnSameRank = true;
        }
        if (fileFrom === sq % 16) {
            foundOnSameFile = true;
        }
    }
    if (foundOnSameFile) {
        return foundOnSameRank ? (0, base_types_impl_1.squareToString)(from) : (0, base_types_impl_1.rankToString)(rankFrom);
    }
    else {
        return foundNotPined ? (0, base_types_impl_1.fileToString)(fileFrom) : '';
    }
}
/**
 * Whether the piece on the given square is pinned or not.
 */
function isPinned(position, sq, aimingAtSq) {
    const kingSquare = position.king[position.turn];
    if (kingSquare < 0) {
        return false;
    }
    const vector = Math.abs(kingSquare - sq);
    const aimingAtVector = Math.abs(aimingAtSq - sq);
    const pinnerQueen = 1 /* PieceImpl.QUEEN */ * 2 + 1 - position.turn;
    const pinnerRook = 2 /* PieceImpl.ROOK */ * 2 + 1 - position.turn;
    const pinnerBishop = 3 /* PieceImpl.BISHOP */ * 2 + 1 - position.turn;
    // Potential pinning on file or rank.
    if (vector < 8) {
        return aimingAtVector >= 8 && pinningLoockup(position, kingSquare, sq, kingSquare < sq ? 1 : -1, pinnerRook, pinnerQueen);
    }
    else if (vector % 16 === 0) {
        return aimingAtVector % 16 !== 0 && pinningLoockup(position, kingSquare, sq, kingSquare < sq ? 16 : -16, pinnerRook, pinnerQueen);
    }
    // Potential pinning on diagonal.
    else if (vector % 15 === 0) {
        return aimingAtVector % 15 !== 0 && pinningLoockup(position, kingSquare, sq, kingSquare < sq ? 15 : -15, pinnerBishop, pinnerQueen);
    }
    else if (vector % 17 === 0) {
        return aimingAtVector % 17 !== 0 && pinningLoockup(position, kingSquare, sq, kingSquare < sq ? 17 : -17, pinnerBishop, pinnerQueen);
    }
    // No pinning for sure.
    else {
        return false;
    }
}
function pinningLoockup(position, kingSquare, targetSquare, direction, pinnerColoredPiece1, pinnerColoredPiece2) {
    for (let sq = kingSquare + direction; sq !== targetSquare; sq += direction) {
        if (position.board[sq] !== -1 /* SpI.EMPTY */) {
            return false;
        }
    }
    for (let sq = targetSquare + direction; (sq & 0x88) === 0; sq += direction) {
        if (position.board[sq] !== -1 /* SpI.EMPTY */) {
            return position.board[sq] === pinnerColoredPiece1 || position.board[sq] === pinnerColoredPiece2;
        }
    }
    return false;
}
/**
 * Parse a move notation for the given position.
 */
function parseNotation(position, notation, strict, pieceStyle) {
    var _a;
    // General syntax
    const m = /^(?:(O-O-O|0-0-0)|(O-O|0-0)|([A-Z\u2654-\u265f])([a-h])?([1-8])?(x)?([a-h][1-8])|(?:([a-h])(x)?)?([a-h][1-8])(?:(=)?([A-Z\u2654-\u265f]))?)([+#])?$/.exec(notation);
    if (m === null) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_MOVE_NOTATION_SYNTAX);
    }
    // Ensure that the position is legal.
    if (!(0, legality_1.isLegal)(position)) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_POSITION);
    }
    // CASTLING
    // m[1] -> O-O-O
    // m[2] -> O-O
    // NON-PAWN MOVE
    // m[3] -> moving piece
    // m[4] -> file disambiguation
    // m[5] -> rank disambiguation
    // m[6] -> x (capture symbol)
    // m[7] -> to
    // PAWN MOVE
    // m[ 8] -> from column (only for captures)
    // m[ 9] -> x (capture symbol)
    // m[10] -> to
    // m[11] -> = (promotion symbol)
    // m[12] -> promoted piece
    // OTHER
    // m[13] -> +/# (check/checkmate symbol)
    let descriptor = false;
    // Parse castling moves
    if (m[1] !== undefined || m[2] !== undefined) {
        descriptor = parseCastlingNotation(position, notation, strict, m[1], m[2]);
    }
    // Non-pawn move
    else if (m[3] !== undefined) {
        descriptor = parseNonPawnNotation(position, notation, strict, pieceStyle, m[3], m[4], m[5], m[7]);
    }
    // Pawn move
    else {
        descriptor = parsePawnMoveNotation(position, notation, strict, pieceStyle, m[8], m[10], m[11], m[12]);
    }
    // STRICT MODE
    if (strict) {
        const observedIsCapture = m[6] !== undefined || m[9] !== undefined;
        if (descriptor.isCapture() !== observedIsCapture) {
            const message = descriptor.isCapture() ? i18n_1.i18n.MISSING_CAPTURE_SYMBOL : i18n_1.i18n.INVALID_CAPTURE_SYMBOL;
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, message);
        }
        const expectedCCS = getCheckCheckmateSymbol(position, descriptor);
        const observedCCS = (_a = m[13]) !== null && _a !== void 0 ? _a : '';
        if (expectedCCS !== observedCCS) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.WRONG_CHECK_CHECKMATE_SYMBOL, expectedCCS, observedCCS);
        }
    }
    // Final result
    return descriptor;
}
exports.parseNotation = parseNotation;
/**
 * Delegate function that computes the move descriptor corresponding to a castling move (corresponding notation: "O-O" or "O-O-O").
 */
function parseCastlingNotation(position, notation, strict, queenSideCastlingSymbol, kingSideCastlingSymbol) {
    const from = position.king[position.turn];
    if (from < 0) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_NO_KING_CASTLING);
    }
    (0, legality_1.refreshEffectiveCastling)(position);
    const isKingSideCastling = kingSideCastlingSymbol !== undefined;
    const toFile = getCastlingDestinationFile(position, isKingSideCastling);
    const descriptor = toFile >= 0 ? (0, move_generation_1.isCastlingMoveLegal)(position, from, toFile + 112 * position.turn) : false;
    if (!descriptor) {
        const message = isKingSideCastling ? i18n_1.i18n.ILLEGAL_KING_SIDE_CASTLING : i18n_1.i18n.ILLEGAL_QUEEN_SIDE_CASTLING;
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, message);
    }
    // STRICT-MODE -> ensure that upper-case O is used instead of digit 0.
    if (strict) {
        const firstChar = (isKingSideCastling ? kingSideCastlingSymbol : queenSideCastlingSymbol).charAt(0);
        if (firstChar === '0') {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.CASTLING_MOVE_ENCODED_WITH_ZERO);
        }
    }
    return descriptor;
}
/**
 * Returns the file of a `to` square to take into account to check whether a castling move is legal or not.
 */
function getCastlingDestinationFile(position, isKingSideCastling) {
    if (position.variant === 1 /* GameVariantImpl.CHESS960 */) {
        if (position.effectiveCastling[position.turn] !== 0) {
            const castlingKing = 0 /* PieceImpl.KING */ * 2 + position.turn;
            for (let file = isKingSideCastling ? 7 : 0; position.board[file + 112 * position.turn] !== castlingKing; file += isKingSideCastling ? -1 : 1) {
                if ((position.effectiveCastling[position.turn] & 1 << file) !== 0) {
                    return file;
                }
            }
        }
        return -1;
    }
    else {
        return isKingSideCastling ? 6 : 2;
    }
}
/**
 * Delegate function that computes the move descriptor corresponding to a non-pawn move. Corresponding notation, for instance "Ne3xd5":
 *
 * - N: piece symbol
 * - e: file disambiguation
 * - 3: rank disambiguation
 * - d5: destination square
 */
function parseNonPawnNotation(position, notation, strict, pieceStyle, pieceSymbol, fileDisambiguation, rankDisambiguation, destinationSquare) {
    const movingColoredPiece = parsePieceSymbol(position, notation, pieceSymbol, strict, pieceStyle) * 2 + position.turn;
    const to = (0, base_types_impl_1.squareFromString)(destinationSquare);
    const toContent = position.board[to];
    // Cannot take your own pieces!
    if (toContent !== -1 /* SpI.EMPTY */ && toContent % 2 === position.turn) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.TRYING_TO_CAPTURE_YOUR_OWN_PIECES);
    }
    // Capture may be mandatory in some variants.
    if (toContent === -1 /* SpI.EMPTY */ && (0, move_generation_1.isCaptureMandatory)(position)) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.CAPTURE_IS_MANDATORY);
    }
    // Find the "from"-square candidates
    let attackers = (0, attacks_1.getAttacks)(position, to, position.turn).filter(sq => position.board[sq] === movingColoredPiece);
    // Apply disambiguation
    if (fileDisambiguation !== undefined) {
        const fileFrom = (0, base_types_impl_1.fileFromString)(fileDisambiguation);
        attackers = attackers.filter(sq => sq % 16 === fileFrom);
    }
    if (rankDisambiguation !== undefined) {
        const rankFrom = (0, base_types_impl_1.rankFromString)(rankDisambiguation);
        attackers = attackers.filter(sq => Math.trunc(sq / 16) === rankFrom);
    }
    if (attackers.length === 0) {
        const message = fileDisambiguation === undefined && rankDisambiguation === undefined ? i18n_1.i18n.NO_PIECE_CAN_MOVE_TO : i18n_1.i18n.NO_PIECE_CAN_MOVE_TO_DISAMBIGUATION;
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, message, pieceSymbol, destinationSquare);
    }
    // Compute the move descriptor for each remaining "from"-square candidate
    let descriptor = false;
    for (let i = 0; i < attackers.length; ++i) {
        if ((0, legality_1.isKingSafeAfterMove)(position, attackers[i], to)) {
            if (descriptor) {
                throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.REQUIRE_DISAMBIGUATION, pieceSymbol, destinationSquare);
            }
            descriptor = move_descriptor_impl_1.MoveDescriptorImpl.make(attackers[i], to, movingColoredPiece, toContent);
        }
    }
    if (!descriptor) {
        const message = position.turn === 0 /* ColorImpl.WHITE */ ? i18n_1.i18n.NOT_SAFE_FOR_WHITE_KING : i18n_1.i18n.NOT_SAFE_FOR_BLACK_KING;
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, message);
    }
    // STRICT-MODE -> check the disambiguation symbol.
    if (strict) {
        const expectedDS = getDisambiguationSymbol(position, descriptor._from, to);
        const observedDS = (fileDisambiguation !== null && fileDisambiguation !== void 0 ? fileDisambiguation : '') + (rankDisambiguation !== null && rankDisambiguation !== void 0 ? rankDisambiguation : '');
        if (expectedDS !== observedDS) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.WRONG_DISAMBIGUATION_SYMBOL, expectedDS, observedDS);
        }
    }
    return descriptor;
}
/**
 * Delegate function that computes the move descriptor corresponding to a pawn move. Corresponding notation, for instance "fxg8=Q":
 *
 * - f: origin file
 * - g8: destination square
 * - =: promotion symbol
 * - Q: promoted piece
 */
function parsePawnMoveNotation(position, notation, strict, pieceStyle, originFile, destinationSquare, promotionSymbol, promotedPiece) {
    const coloredPawn = 5 /* PieceImpl.PAWN */ * 2 + position.turn;
    const to = (0, base_types_impl_1.squareFromString)(destinationSquare);
    const toContent = position.board[to];
    const vector = 16 - position.turn * 32;
    let from = to - vector;
    let enPassantSquare = -1;
    if (originFile !== undefined) { // Capturing pawn move
        // Ensure that `to` is not on the 1st row.
        if ((from & 0x88) !== 0) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_CAPTURING_PAWN_MOVE);
        }
        // Compute the "from"-square.
        const columnFrom = (0, base_types_impl_1.fileFromString)(originFile);
        const columnTo = to % 16;
        if (columnTo - columnFrom === 1) {
            from -= 1;
        }
        else if (columnTo - columnFrom === -1) {
            from += 1;
        }
        else {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_CAPTURING_PAWN_MOVE);
        }
        // Check the content of the "from"-square
        if (position.board[from] !== coloredPawn) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_CAPTURING_PAWN_MOVE);
        }
        // Check the content of the "to"-square
        if (toContent === -1 /* SpI.EMPTY */) { // Look for en-passant captures
            (0, legality_1.refreshEffectiveEnPassant)(position);
            if (to !== (5 - position.turn * 3) * 16 + position.effectiveEnPassant) {
                throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_CAPTURING_PAWN_MOVE);
            }
            enPassantSquare = (4 - position.turn) * 16 + position.effectiveEnPassant;
        }
        else if (toContent % 2 === position.turn) { // detecting regular captures
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_CAPTURING_PAWN_MOVE);
        }
    }
    else if ((0, move_generation_1.isCaptureMandatory)(position)) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.CAPTURE_IS_MANDATORY);
    }
    else { // Non-capturing pawn move
        // Ensure that `to` is not on the 1st row.
        if ((from & 0x88) !== 0) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_NON_CAPTURING_PAWN_MOVE);
        }
        // Check the content of the "to"-square
        if (toContent !== -1 /* SpI.EMPTY */) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_NON_CAPTURING_PAWN_MOVE);
        }
        // Check the content of the "from"-square
        if (position.board[from] === -1 /* SpI.EMPTY */) { // Look for two-square pawn moves
            from -= vector;
            const firstSquareOfArea = position.turn * 96; // a1 for white, a7 for black (2-square pawn move is allowed from 1st row at horde chess)
            if (from < firstSquareOfArea || from >= firstSquareOfArea + 24 || position.board[from] !== coloredPawn) {
                throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_NON_CAPTURING_PAWN_MOVE);
            }
        }
        else if (position.board[from] !== coloredPawn) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_NON_CAPTURING_PAWN_MOVE);
        }
    }
    // Ensure that the pawn move do not let a king in check.
    if (!(0, legality_1.isKingSafeAfterMove)(position, from, to, enPassantSquare)) {
        const message = position.turn === 0 /* ColorImpl.WHITE */ ? i18n_1.i18n.NOT_SAFE_FOR_WHITE_KING : i18n_1.i18n.NOT_SAFE_FOR_BLACK_KING;
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, message);
    }
    // Promotions
    if (to < 8 || to >= 112) {
        if (promotedPiece === undefined) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.MISSING_PROMOTION);
        }
        const promotion = parsePieceSymbol(position, notation, promotedPiece, strict, pieceStyle);
        if (promotion === 5 /* PieceImpl.PAWN */ || (promotion === 0 /* PieceImpl.KING */ && position.variant !== 5 /* GameVariantImpl.ANTICHESS */)) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_PROMOTED_PIECE, promotedPiece);
        }
        // STRICT MODE -> do not forget the `=` character!
        if (strict && promotionSymbol === undefined) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.MISSING_PROMOTION_SYMBOL);
        }
        return move_descriptor_impl_1.MoveDescriptorImpl.makePromotion(from, to, position.turn, toContent, promotion);
    }
    // Non-promotion moves
    else {
        if (promotedPiece !== undefined) { // Detect illegal promotion attempts!
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_PROMOTION);
        }
        return enPassantSquare >= 0 ? move_descriptor_impl_1.MoveDescriptorImpl.makeEnPassant(from, to, enPassantSquare, position.turn) : move_descriptor_impl_1.MoveDescriptorImpl.make(from, to, coloredPawn, toContent);
    }
}
/**
 * Delegate function for piece symbol parsing.
 */
function parsePieceSymbol(position, notation, pieceSymbol, strict, pieceStyle) {
    switch (pieceStyle) {
        case 'figurine': {
            const coloredPieceCode = (0, base_types_impl_1.figurineFromString)(pieceSymbol);
            if (coloredPieceCode < 0) {
                throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_PIECE_SYMBOL, pieceSymbol);
            }
            if (strict && coloredPieceCode % 2 !== position.turn) {
                throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_PIECE_SYMBOL_COLOR, pieceSymbol);
            }
            return Math.trunc(coloredPieceCode / 2);
        }
        case 'standard': {
            const pieceCode = (0, base_types_impl_1.pieceFromString)(pieceSymbol.toLowerCase());
            if (pieceCode < 0) {
                throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_PIECE_SYMBOL, pieceSymbol);
            }
            return pieceCode;
        }
    }
}

},{"../exception":3,"../i18n":6,"./attacks":18,"./base_types_impl":19,"./fen":20,"./impl":21,"./legality":22,"./move_descriptor_impl":23,"./move_generation":24}],26:[function(require,module,exports){
"use strict";
/*!
 * -------------------------------------------------------------------------- *
 *                                                                            *
 *    Kokopu - A JavaScript/TypeScript chess library.                         *
 *    <https://www.npmjs.com/package/kokopu>                                  *
 *    Copyright (C) 2018-2024  Yoann Le Montagner <yo35 -at- melix.net>       *
 *                                                                            *
 *    Kokopu is free software: you can redistribute it and/or                 *
 *    modify it under the terms of the GNU Lesser General Public License      *
 *    as published by the Free Software Foundation, either version 3 of       *
 *    the License, or (at your option) any later version.                     *
 *                                                                            *
 *    Kokopu is distributed in the hope that it will be useful,               *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
 *    GNU Lesser General Public License for more details.                     *
 *                                                                            *
 *    You should have received a copy of the GNU Lesser General               *
 *    Public License along with this program. If not, see                     *
 *    <http://www.gnu.org/licenses/>.                                         *
 *                                                                            *
 * -------------------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseUCINotation = exports.getUCINotation = void 0;
const base_types_impl_1 = require("./base_types_impl");
const fen_1 = require("./fen");
const legality_1 = require("./legality");
const move_generation_1 = require("./move_generation");
const exception_1 = require("../exception");
const i18n_1 = require("../i18n");
/**
 * Convert the given move descriptor to UCI notation.
 */
function getUCINotation(position, descriptor, forceKxR) {
    let result = descriptor.from();
    if (descriptor.isCastling()) {
        result += forceKxR || position.variant === 1 /* GameVariantImpl.CHESS960 */ ? descriptor.rookFrom() : descriptor.to();
    }
    else {
        result += descriptor.to();
    }
    if (descriptor.isPromotion()) {
        result += descriptor.promotion();
    }
    return result;
}
exports.getUCINotation = getUCINotation;
/**
 * Parse a UCI notation for the given position.
 */
function parseUCINotation(position, notation, strict) {
    // General syntax
    const m = /^([a-h][1-8])([a-h][1-8])([kqrbnp]?)$/.exec(notation);
    if (m === null) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.INVALID_UCI_NOTATION_SYNTAX);
    }
    // Ensure that the position is legal (this is also done in `moveGeneration.isMoveLegal(..)`, but performing this check beforehand
    // allows to fill the exception with an error message that is more explicit).
    if (!(0, legality_1.isLegal)(position)) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_POSITION);
    }
    // m[1] - from
    // m[2] - to
    // m[3] - promotion piece
    const from = (0, base_types_impl_1.squareFromString)(m[1]);
    let to = (0, base_types_impl_1.squareFromString)(m[2]);
    let kxRSubstitutionApplied = false;
    let expectedRookFrom = -1; // >= 0 only if KxR substitution has been applied.
    // For non-Chess960 variants, if KxR is detected (and allowed), replace the given `to` square
    // by the actual destination square of the king.
    if (position.variant !== 1 /* GameVariantImpl.CHESS960 */ && !strict && position.board[from] !== -1 /* SpI.EMPTY */ && position.board[to] !== -1 /* SpI.EMPTY */ &&
        position.board[from] % 2 === position.board[to] % 2) {
        const fromPiece = Math.trunc(position.board[from] / 2);
        const toPiece = Math.trunc(position.board[to] / 2);
        if (fromPiece === 0 /* PieceImpl.KING */ && toPiece === 2 /* PieceImpl.ROOK */) {
            kxRSubstitutionApplied = true;
            expectedRookFrom = to;
            to = position.turn * 112 + (from < to ? 6 : 2);
        }
    }
    // Perform move analysis.
    const candidate = (0, move_generation_1.isMoveLegal)(position, from, to);
    let result = false;
    // No legal move.
    if (!candidate) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_UCI_MOVE);
    }
    // Manage promotion.
    if (candidate.type === 'promotion') {
        if (m[3] === '') {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_UCI_MOVE);
        }
        result = candidate.moveDescriptorFactory((0, base_types_impl_1.pieceFromString)(m[3]));
        if (!result) {
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_UCI_MOVE);
        }
    }
    else {
        if (m[3] !== '') { // Throw if a promotion piece is provided while no promotion happens.
            throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_UCI_MOVE);
        }
        result = candidate.moveDescriptor;
    }
    // Check that the KxR substitution is valid if it has been applied.
    if (kxRSubstitutionApplied && (!result.isCastling() || expectedRookFrom !== result._optionalSquare1)) {
        throw new exception_1.InvalidNotation((0, fen_1.getFEN)(position), notation, i18n_1.i18n.ILLEGAL_UCI_MOVE);
    }
    return result;
}
exports.parseUCINotation = parseUCINotation;

},{"../exception":3,"../i18n":6,"./base_types_impl":19,"./fen":20,"./legality":22,"./move_generation":24}]},{},[7])(7)
});
